Ext.grid.RowExpander = function(config){
    Ext.apply(this, config);

    this.addEvents({
        beforeexpand : true,
        expand: true,
        beforecollapse: true,
        collapse: true
    });

    Ext.grid.RowExpander.superclass.constructor.call(this);

    if(this.tpl){
        if(typeof this.tpl == 'string'){
            this.tpl = new Ext.Template(this.tpl);
        }
        this.tpl.compile();
    }

    this.state = {};
    this.bodyContent = {};
};

Ext.extend(Ext.grid.RowExpander, Ext.util.Observable, {
    header: "",
    width: 20,
    sortable: false,
    fixed:true,
    menuDisabled:true,
    dataIndex: '',
    id: 'expander',
    lazyRender : true,
    enableCaching: true,
    fullfmt:'@',

    getRowClass : function(record, rowIndex, p, ds){
        p.cols = p.cols-1;
        var content = this.bodyContent[record.id];
        if(!content && !this.lazyRender){
            content = this.getBodyContent(record, rowIndex);
        }
        if(content){
            p.body = content;
        }
        return this.state[record.id] ? 'x-grid3-row-expanded' : 'x-grid3-row-collapsed';
    },

    init : function(grid){
        this.grid = grid;

        var view = grid.getView();
        view.getRowClass = this.getRowClass.createDelegate(this);

        view.enableRowBody = true;

        grid.on('render', function(){
            view.mainBody.on('mousedown', this.onMouseDown, this);
        }, this);
    },

    getBodyContent : function(record, index){
        if(!this.enableCaching){
            return this.tpl.apply(record.data);
        }
        var content = this.bodyContent[record.id];
        if(!content){
                content = this.tpl.apply(record.data);
            this.bodyContent[record.id] = content;
        }
        return content;
    },

    onMouseDown : function(e, t){
        if(t.className == 'x-grid3-row-expander'){
            e.stopEvent();
            var row = e.getTarget('.x-grid3-row');
            this.toggleRow(row);
        }
    },

    renderer : function(v, p, record){
        p.cellAttr = 'rowspan="2"';
        return '<div class="x-grid3-row-expander">&#160;</div>';
    },

    beforeExpand : function(record, body, rowIndex){
        if(this.fireEvent('beforeexpand', this, record, body, rowIndex) !== false){
            if(this.tpl && this.lazyRender){
                ur='../vidget/RecListPanel.php?op=GetSessionFull&mfn='+encodeURIComponent(this.getBodyContent(record, rowIndex))+'&fmt='+this.fullfmt;
                this.bod=body;
                Ext.Ajax.request
                                ({
                                        bod:body,
                                        url:ur,
                                        success:function(r){this.bod.innerHTML=r.responseText;},
                                        scope:this
                                });
                //body.innerHTML = ur;
            }
            return true;
        }else{
            return false;
        }
    },

    toggleRow : function(row){
        if(typeof row == 'number'){
            row = this.grid.view.getRow(row);
        }
        this[Ext.fly(row).hasClass('x-grid3-row-collapsed') ? 'expandRow' : 'collapseRow'](row);
    },

    expandRow : function(row){
        if(typeof row == 'number'){
            row = this.grid.view.getRow(row);
        }
        var record = this.grid.store.getAt(row.rowIndex);
        var body = Ext.DomQuery.selectNode('div.x-grid3-row-body', row);
        //var body=row;
        
        if(this.beforeExpand(record, body, row.rowIndex)){
            this.state[record.id] = true;
            Ext.fly(row).replaceClass('x-grid3-row-collapsed', 'x-grid3-row-expanded');
            this.fireEvent('expand', this, record, body, row.rowIndex);
        }
    },

    collapseRow : function(row){
        if(typeof row == 'number'){
            row = this.grid.view.getRow(row);
        }
        var record = this.grid.store.getAt(row.rowIndex);
        var body = Ext.fly(row).child('div.x-grid3-row-body', true);
        body.innerHTML='';
        if(this.fireEvent('beforcollapse', this, record, body, row.rowIndex) !== false){
            this.state[record.id] = false;
            Ext.fly(row).replaceClass('x-grid3-row-expanded', 'x-grid3-row-collapsed');
            this.fireEvent('collapse', this, record, body, row.rowIndex);
        }
    }
});


Irbis.RecListPanelTab=function(cfg)
 {
        cfg=cfg||{};
        cfg.layout='fit';
        this.irbDb=cfg.irbDb;
        this.irbShowDbInfoOnFull=cfg.irbShowDbInfoOnFull;
        this.basketName=cfg.basketName;
        this.C_RecListStore=new Ext.data.JsonStore
        ({
          proxy: new Ext.data.HttpProxy({
            url: '../vidget/RecListPanel.php',
            method: 'POST',
            disableCaching: true
          }),
          fields:['id','npp','mfn','brief'],
          baseParams:{action:'RecList',db:Ext.encode(cfg.irbDb),basketName:cfg.basketName},
          root: 'RecList',
          totalProperty:'totalCount',
          autoLoad:false
        });
        this.ChangeDb=function(irbDb)
        {
         this.irbDb=irbDb;
         this.C_RecListStore.removeAll();
         this.C_RecListStore.baseParams.db=Ext.encode(irbDb);
        };
        if (this.irbShowDbInfoOnFull)
         this.expanderTpl='i,{dbid}/{mfn}';
        else
         this.expanderTpl='{dbid}/{mfn}';
        this.expander=new Ext.grid.RowExpander
        ({
                tpl:this.expanderTpl
                //tpl:'{dbid}/{mfn}'
        });
        this.sm=new Ext.grid.CheckboxSelectionModel
        ({
          listeners:
          {
           rowselect:function(sm,rowIndex,record)
           {
            var val=record.get('mfn');
            this.fireEvent('recselect',{mfn:val,rowIndex:rowIndex});
           },
           rowdeselect:function(sm,rowIndex,record)
           {
            this.fireEvent('recdeselect',{rowIndex:rowIndex});
           },
           selectionchange:function(sm)
           {
            this.fireEvent('recselectionchange',{sm:sm});
           },
           scope:this
          },
          singleSelect:false,width:20
        });
        this.grid=new Ext.grid.GridPanel
        ({
                store:this.C_RecListStore,
                loadMask:{msg:'Загрузка...'},
                sm:this.sm,
                plugins:this.expander,
                columns:
                [
                        this.expander,
                        this.sm,
                        /*new Ext.grid.CheckboxSelectionModel
                        ({
                          singleSelect:false,width:20
                        }),*/
                        {header: '#',dataIndex:'npp',align:'right',sortable:true,menuDisabled:true,width:30},
                        {header: 'Описание',dataIndex:'brief',align:'left',sortable:false,menuDisabled:true,width:400}
                ],
                stripeRows: true,
//                autoWidth:true,
                autoExpandColumn: 'brief',
                layout:'fit',
                viewConfig:{forceFit:true},
                listeners:
                {
                        rowdblclick:function(grid,rowIndex,e)
                        {
                                var val=grid.getStore().getAt(rowIndex).get('mfn');
                                this.fireEvent('recdblclick',{mfn:val,grid:grid,rowIndex:rowIndex});
                        },
                        rowclick:function(grid,rowIndex,e)
                        {
                                //val=grid.getStore().getAt(rowIndex).get('mfn');
                                this.fireEvent('recclick',{grid:grid,rowIndex:rowIndex});
                        },
                        scope:this
                },
                bbar:new Ext.PagingToolbar
                ({
                        store:this.C_RecListStore,
                        displayInfo:cfg.showTotalCount,
                        pageSize:20
                })
        });
        this.GetCurRecMfn=function()
        {
         var sm=this.grid.getSelectionModel();
         if (sm.hasSelection())
          return sm.getSelected().get('mfn');
        };
        this.GetSelectedMfns=function()
        {
         var sm=this.grid.getSelectionModel();
         if (sm.hasSelection())
         {
          var ar=[];
          var rs=sm.getSelections();
          for(var i=0;i<rs.length;i++)
          {
           ar[i]=rs[i].get('mfn');
          }
          return ar;
         }
        };
        this.GetCurRecId=function()
        {
         var sm=this.grid.getSelectionModel();
         if (sm.hasSelection())
          return sm.getSelected().get('id');
        };
        this.MakeSearch=function(src,sequence,fmt)
        { 
                this.src=src;
                this.sequence=sequence;
                if (typeof(fmt)=="object")
                {
                        cmcfg=[this.expander,this.sm,
                                {header: '#',width:20,dataIndex:'npp',align:'right',sortable:true,menuDisabled:true}
                                ];
                        //fields:['id','npp','mfn','brief'],
                        for (i=0;i<fmt.length;i++)
                        {
                                if (!fmt[i].isDontShow)
                                        cmcfg[cmcfg.length]=fmt[i];
                        }
                        //cmcfg.push(this.expander);
                        this.grid.getColumnModel().setConfig(cmcfg);
                        //this.grid.getColumnModel(this.expander);
                        this.C_RecListStore.baseParams.src=src||'';
                        this.C_RecListStore.baseParams.sequence=sequence||'';
                        this.C_RecListStore.baseParams.cols=Ext.encode(fmt);
                        this.C_RecListStore.load({params:{start:0,limit:20},add:false});
                }
                else
                {       //alert('!');
                        this.C_RecListStore.load({params:{src:src||'',sequence:sequence||'',fmt:fmt||'',start:0,limit:20},add:false});
                }
        };
        this.Reload=function()
        {
         this.C_RecListStore.load({params:{start:0,limit:20},add:false});
        }
        this.ChangeFullFmt=function(fullfmt)
        {
         this.expander.fullfmt=fullfmt;
        };
        this.GetFullFmt=function()
        {
         return this.expander.fullfmt;
        }
   cfg.items=[this.grid];
   Irbis.RecListPanelTab.superclass.constructor.call(this,cfg);
 };
 
 Ext.extend(Irbis.RecListPanelTab,Ext.Panel);

 Irbis.RecListPanel=function(cfg)
 {
  cfg=cfg||{};
  this.irbDb=cfg.irbDb;
  this.irbShowDbInfoOnFull=cfg.irbShowDbInfoOnFull;
  this.irbRec=cfg.irbRec;
  var cfg2=cfg;
//  cfg2.layout='fit';
  cfg2.title=this.searchTitle;
  cfg2.iconCls='irb-search';
  if (typeof(cfg.basketName)!='undefined')
  {
   cfg.tbar.push('-');
   cfg.tbar.push({iconCls:'irb-basket',tooltip:this.basketAdd,handler:function(){Irbis.ModalRequest({irbDb:this.irbDb,irbArm:this.irbArm,action:'add','mfn[]':this.GetSelectedMfns()},'../vidget/basket.php');},scope:this});
   this.basketName=cfg.basketName;
  }
  this.RecListPanelTab=new Irbis.RecListPanelTab(cfg2);
  rlt=this.RecListPanelTab;
  this.C_RecListStore=rlt.C_RecListStore;
  this.ChangeDb=function(irbDb){this.irbDb=irbDb;this.RecListPanelTab.ChangeDb(irbDb);if (typeof(this.basketName)!='undefined') {this.RecListBasket.ChangeDb(irbDb); this.RecListBasket.Reload();}};
  this.grid=rlt.grid;
  this.GetCurRecMfn=function(){return this.RecListPanelTab.GetCurRecMfn();};
  this.GetSelectedMfns=function(){return this.RecListPanelTab.GetSelectedMfns();};
  this.GetCurRecId=function(){return this.RecListPanelTab.GetCurRecId();};
  this.MakeSearch=function(src,sequence,fmt){this.setActiveTab(0); return this.RecListPanelTab.MakeSearch(src,sequence,fmt);};
  this.Reload=function () { return this.RecListPanelTab.Reload();};
  this.ChangeFullFmt=function(fullfmt) {return this.RecListPanelTab.ChangeFullFmt(fullfmt);};
  this.GetFullFmt=function(){return this.RecListPanelTab.GetFullFmt();};
  this.GetLastSrc=function(){return this.RecListPanelTab.src;};
  this.GetLastSeqence=function(){return this.RecListPanelTab.sequence;};
  this.ModalRequest=Irbis.ModalRequest;
  this.LongRequest=Irbis.LongRequest;
  cfg.layout=void 0;
  cfg.tabPosition='bottom';
  cfg.items=[this.RecListPanelTab];
  if (typeof(cfg.basketName)!='undefined') 
  {
   this.RecListBasket=new Irbis.RecListPanelTab({irbDb:this.irbDb,irbArm:this.irbArm,layout:'fit',basketName:cfg.basketName});
   this.basketPftSelector=new Irbis.PftSelector
   ({
     autoLoad:true,
     valueNotFoundText:'Оптимизированый',
     arm:this.irbArm,
     dbid:this.irbDb,
     xtype:'combo',
     allowBlank: false,
     editable: false,
     fieldLabel: 'БД',
     anchor: '100%',
     listeners:
     {
      select:function(combo,record,index)
      {
       var f=record.get('key');
       if (f=='@') this.RecListBasket.ChangeFullFmt(f); else this.RecListBasket.ChangeFullFmt('@'+f);
      },
      scope:this
     }
   });
   this.bCopy=new Ext.Button({iconCls:'irb-copy',tooltip:'Копировать записи',handler: function(){var w=new Irbis.RecPreselector({oscope:this,url:'../C/CopyRecToDb.php',showSrcDocSelector:true,showTVP:true,showExpDbSelector:true,irbMnuNameByIniSection:'MAIN',irbMnuNameByIniParam:'COPYMNU',irbDb:this.irbDb,irbArm:this.irbArm,title:'Копирование документов',params:{'mfn[]':this.RecListBasket.GetSelectedMfns(),basket:'cat'}});w.show();w.center();},scope:this});
   cfg.items.push
   ({
     title:this.basketTitle,
     iconCls:'irb-basket',
     layout:'fit',
//     basketName:'cat',
     m_recList:this.RecListBasket,
     tbar:
     [
      {iconCls:'irb-clear',tooltip:this.basketClear,handler:function(){this.ModalRequest({irbDb:this.irbDb,irbArm:this.irbArm,action:'clear','mfn[]':this.RecListBasket.GetSelectedMfns()},'../vidget/basket.php');},scope:this},
      {iconCls:'irb-basket-remove',tooltip:this.basketRemove,handler:function(){this.ModalRequest({irbDb:this.irbDb,irbArm:this.irbArm,action:'del','mfn[]':this.RecListBasket.GetSelectedMfns()},'../vidget/basket.php');},scope:this},
      '-',
      {iconCls:'irb-edit',tooltip:this.recEdit,handler:function(){this.ModalRequest({irbDb:this.irbDb,irbRec:this.irbRec,mfn:this.RecListBasket.GetCurRecMfn()},'../C/EditRec.php');},scope:this},
      this.bCopy,
      {iconCls:'irb-delete',tooltip:this.recRemove,handler: function(){this.ModalRequest({irbDb:this.irbDb,irbArm:this.irbArm,'mfn[]':this.RecListBasket.GetSelectedMfns()},'../C/DeleteRecs.php');},scope:this},
      '-',
      this.viewFormat+": ",
      this.basketPftSelector,
      '-',
      {iconCls:'irb-print',tooltip:'Распечатать записи',handler: function(){Irbis.LongRequest({irbDb:this.irbDb,irbArm:this.irbArm,pft:this.RecListBasket.GetFullFmt(),'mfn[]':this.RecListBasket.GetSelectedMfns()},'../C/PrintRecs.php');},scope:this}
     ],
     items:[this.RecListBasket],
     listeners:
     {
      activate:function(tab){tab.m_recList.Reload();}
     }
   });
  }
  cfg.activeTab=0;
  cfg.tbar=void 0;
  Irbis.RecListPanel.superclass.constructor.call(this,cfg);
 };
 Ext.extend(Irbis.RecListPanel,Ext.TabPanel,
 {
  searchTitle:'Результаты поиска',
  basketTitle:'Корзина',
  basketAdd:'Добавить отмеченные записи в корзину',
  basketClear:'Очистить корзину',
  basketRemove:'Удалить из корзины',
  recEdit:'Редактировать запись',
  recRemove:'Удалить записи',
  viewFormat:'Формат просмотра'
 });

 Irbis.RecListPanel.RecExportButton=function(cfg)
 {
  cfg=cfg||{};
  this.RecListPanel=cfg.RecListPanel;
  cfg.text='Экспорт';
  cfg.tooltip='Экспорт отмеченых документов. Если не выбрано ни одного документа, то будет экспортирован весь результат поиска';
  Irbis.RecListPanel.RecExportButton.superclass.constructor.call(this,cfg);
 };
 
 Ext.extend(Irbis.RecListPanel.RecExportButton,Ext.Button);

 Irbis.RecBasket=function(cfg)
 {
  cfg=cfg||{};
  cfg.layout='fit';
  this.irbArm=cfg.irbArm;
  this.irbShowDbInfoOnFull=cfg.irbShowDbInfoOnFull;

  this.C_RecListStore=new Ext.data.JsonStore
  ({
    fields:['id','npp','dbid','mfn','brief'],
    url: '../vidget/RecBasket.php',
    baseParams:{irbArm:cfg.irbArm},
    root: 'RecList',
    totalProperty:'totalCount',
    autoLoad:true
  });
  if (this.irbShowDbInfoOnFull)
   this.expanderTpl='i,{dbid}/{mfn}';
  else
   this.expanderTpl='{dbid}/{mfn}';
  this.expander=new Ext.grid.RowExpander({tpl:this.expanderTpl});
  this.grid=new Ext.grid.GridPanel
  ({
    store:this.C_RecListStore,
    loadMask:{msg:'Загрузка...'},
    sm:new Ext.grid.CheckboxSelectionModel({singleSelect:false,width:20}),
    plugins:this.expander,
    columns:
    [
     this.expander,
     new Ext.grid.CheckboxSelectionModel({singleSelect:false,width:20}),
     {header: '#',dataIndex:'npp',width:20,align:'right',sortable:true,menuDisabled:true},
     {header: 'Описание',autoWidth:true,dataIndex:'brief',sortable:true,menuDisabled:true}
    ],
    stripeRows: true,
    autoWidth:true,
    layout:'fit',
    viewConfig:{forceFit:true},
    bbar:new Ext.PagingToolbar
    ({
      store:this.C_RecListStore,
      displayInfo:cfg.showTotalCount,
      pageSize:20
    })
  });
  cfg.items=[this.grid];
  Irbis.RecBasket.superclass.constructor.call(this,cfg);
  this.addRecs=function(recs)
  {
   r=new Array();
   for (i=0;i<recs.length;i++)
   {
    r[i]=recs[i].data;
   }
   this.C_RecListStore.load({params:{start:0,limit:20,recadd:Ext.encode(r)}});
  }
 };
 
 Ext.extend(Irbis.RecBasket,Ext.Panel);
