Ext.grid.RowExpander128 = function(config){
    Ext.apply(this, config);

    this.addEvents({
        beforeexpand : true,
        expand: true,
        beforecollapse: true,
        collapse: true
    });

    Ext.grid.RowExpander128.superclass.constructor.call(this);

    if(this.tpl){
        if(typeof this.tpl == 'string'){
            this.tpl = new Ext.Template(this.tpl);
        }
        this.tpl.compile();
    }

    this.state = {};
    this.bodyContent = {};
};

Ext.extend(Ext.grid.RowExpander128, Ext.util.Observable, {
    header: "",
    width: 20,
    sortable: false,
    fixed:true,
    menuDisabled:true,
    dataIndex: '',
    id: 'expander',
    lazyRender : true,
    enableCaching: true,
    fullfmt:'@',

    getRowClass : function(record, rowIndex, p, ds){
        p.cols = p.cols-1;
        var content = this.bodyContent[record.id];
        if(!content && !this.lazyRender){
            content = this.getBodyContent(record, rowIndex);
        }
        if(content){
            p.body = content;
        }
        return this.state[record.id] ? 'x-grid3-row-expanded' : 'x-grid3-row-collapsed';
    },

    init : function(grid){
        this.grid = grid;

        var view = grid.getView();
        view.getRowClass = this.getRowClass.createDelegate(this);

        view.enableRowBody = true;

        grid.on('render', function(){
            view.mainBody.on('mousedown', this.onMouseDown, this);
        }, this);
    },

    getBodyContent : function(record, index){
        if(!this.enableCaching){
            return this.tpl.apply(record.data);
        }
        var content = this.bodyContent[record.id];
        if(!content){
                content = this.tpl.apply(record.data);
            this.bodyContent[record.id] = content;
        }
        return content;
    },

    onMouseDown : function(e, t){
        if(t.className == 'x-grid3-row-expander'){
            e.stopEvent();
            var row = e.getTarget('.x-grid3-row');
            this.toggleRow(row);
        }
    },

    renderer : function(v, p, record){
        p.cellAttr = 'rowspan="2"';
        return '<div class="x-grid3-row-expander">&#160;</div>';
    },

    beforeExpand : function(record, body, rowIndex){
        if(this.fireEvent('beforeexpand', this, record, body, rowIndex) !== false){
            if(this.tpl && this.lazyRender){
                ur='../vidget/RecListPanel128.php?op=GetSessionFull&mfn='+encodeURIComponent(this.getBodyContent(record, rowIndex))+'&fmt='+this.fullfmt;
                this.bod=body;
                Ext.Ajax.request
                                ({
                                        bod:body,
                                        url:ur,
                                        success:function(r){this.bod.innerHTML=r.responseText;},
                                        scope:this
                                });
                //body.innerHTML = ur;
            }
            return true;
        }else{
            return false;
        }
    },

    toggleRow : function(row){
        if(typeof row == 'number'){
            row = this.grid.view.getRow(row);
        }
        this[Ext.fly(row).hasClass('x-grid3-row-collapsed') ? 'expandRow' : 'collapseRow'](row);
    },

    expandRow : function(row){
        if(typeof row == 'number'){
            row = this.grid.view.getRow(row);
        }
        var record = this.grid.store.getAt(row.rowIndex);
        var body = Ext.DomQuery.selectNode('div.x-grid3-row-body', row);
        //var body=row;
        
        if(this.beforeExpand(record, body, row.rowIndex)){
            this.state[record.id] = true;
            Ext.fly(row).replaceClass('x-grid3-row-collapsed', 'x-grid3-row-expanded');
            this.fireEvent('expand', this, record, body, row.rowIndex);
        }
    },

    collapseRow : function(row){
        if(typeof row == 'number'){
            row = this.grid.view.getRow(row);
        }
        var record = this.grid.store.getAt(row.rowIndex);
        var body = Ext.fly(row).child('div.x-grid3-row-body', true);
        body.innerHTML='';
        if(this.fireEvent('beforcollapse', this, record, body, row.rowIndex) !== false){
            this.state[record.id] = false;
            Ext.fly(row).replaceClass('x-grid3-row-expanded', 'x-grid3-row-collapsed');
            this.fireEvent('collapse', this, record, body, row.rowIndex);
        }
    }
});


Irbis.RecListPanelTab128=function(cfg)
 {
        cfg=cfg||{};
        cfg.layout='fit';
        this.irbDb=cfg.irbDb;
        this.irbShowDbInfoOnFull=cfg.irbShowDbInfoOnFull;
        this.basketName=cfg.basketName;
        this.C_RecListStore=new Ext.data.JsonStore
        ({
          proxy: new Ext.data.HttpProxy({
            url: '../vidget/RecListPanel128.php',
            method: 'POST',
            disableCaching: true
          }),
          fields:['id','npp','mfn','brief'],
          baseParams:{action:'RecList',db:Ext.encode(cfg.irbDb),basketName:cfg.basketName},
          root: 'RecList',
          totalProperty:'totalCount',
          autoLoad:false
        });
        this.ChangeDb=function(irbDb)
        {
         this.irbDb=irbDb;
         this.C_RecListStore.removeAll();
         this.C_RecListStore.baseParams.db=Ext.encode(irbDb);
        };
        if (this.irbShowDbInfoOnFull)
         this.expanderTpl='i,{dbid}/{mfn}';
        else
         this.expanderTpl='{dbid}/{mfn}';
        this.expander=new Ext.grid.RowExpander128
        ({
                tpl:this.expanderTpl
                //tpl:'{dbid}/{mfn}'
        });
        this.sm=new Ext.grid.CheckboxSelectionModel
        ({
          listeners:
          {
           rowselect:function(sm,rowIndex,record)
           {
            var val=record.get('mfn');
            this.fireEvent('recselect',{mfn:val,rowIndex:rowIndex});
           },
           rowdeselect:function(sm,rowIndex,record)
           {
            this.fireEvent('recdeselect',{rowIndex:rowIndex});
           },
           selectionchange:function(sm)
           {
            this.fireEvent('recselectionchange',{sm:sm});
           },
           scope:this
          },
          singleSelect:false,width:20
        });
        this.grid=new Ext.grid.GridPanel
        ({
                store:this.C_RecListStore,
                loadMask:{msg:'Загрузка...'},
                sm:this.sm,
                plugins:this.expander,
                columns:
                [
                        this.expander,
                        this.sm,
                        {header: '#',dataIndex:'npp',align:'right',sortable:true,menuDisabled:true,width:30},
                        {header: 'Описание',dataIndex:'brief',align:'left',sortable:false,menuDisabled:true,width:400}
                ],
                stripeRows: true,
//                autoWidth:true,
                autoExpandColumn: 'brief',
                layout:'fit',
                viewConfig:{forceFit:true},
                listeners:
                {
                        rowdblclick:function(grid,rowIndex,e)
                        {
                                var val=grid.getStore().getAt(rowIndex).get('mfn');
                                this.fireEvent('recdblclick',{mfn:val,grid:grid,rowIndex:rowIndex});
                        },
                        rowclick:function(grid,rowIndex,e)
                        {
                                //val=grid.getStore().getAt(rowIndex).get('mfn');
                                this.fireEvent('recclick',{grid:grid,rowIndex:rowIndex});
                        },
                        scope:this
                },
                bbar:new Ext.PagingToolbar
                ({
                        store:this.C_RecListStore,
                        displayInfo:cfg.showTotalCount,
                        pageSize:20
                })
        });
        this.GetCurRecMfn=function()
        {
         var sm=this.grid.getSelectionModel();
         if (sm.hasSelection())
          return sm.getSelected().get('mfn');
        };
        this.GetSelectedMfns=function()
        {
         var sm=this.grid.getSelectionModel();
         if (sm.hasSelection())
         {
          var ar=[];
          var rs=sm.getSelections();
          for(var i=0;i<rs.length;i++)
          {
           ar[i]=rs[i].get('mfn');
          }
          return ar;
         }
        };
        this.GetCurRecId=function()
        {
         var sm=this.grid.getSelectionModel();
         if (sm.hasSelection())
          return sm.getSelected().get('id');
        };
        this.MakeSearch=function(src,sequence,fmt)
        { 
                this.src=src;
                this.sequence=sequence;
                if (typeof(fmt)=="object")
                {
                        cmcfg=[this.expander,this.sm,
                                {header: '#',width:20,dataIndex:'npp',align:'right',sortable:true,menuDisabled:true}
                                ];
                        //fields:['id','npp','mfn','brief'],
                        for (i=0;i<fmt.length;i++)
                        {
                                if (!fmt[i].isDontShow)
                                        cmcfg[cmcfg.length]=fmt[i];
                        }
                        //cmcfg.push(this.expander);
                        this.grid.getColumnModel().setConfig(cmcfg);
                        //this.grid.getColumnModel(this.expander);
                        this.C_RecListStore.baseParams.src=src||'';
                        this.C_RecListStore.baseParams.sequence=sequence||'';
                        this.C_RecListStore.baseParams.cols=Ext.encode(fmt);
                        this.C_RecListStore.load({params:{start:0,limit:20},add:false});
                }
                else
                {       //alert('!');
                        this.C_RecListStore.load({params:{src:src||'',sequence:sequence||'',fmt:fmt||'',start:0,limit:20},add:false});
                }
        };
        this.Reload=function()
        {
         this.C_RecListStore.load({params:{start:0,limit:20},add:false});
        }
        this.ChangeFullFmt=function(fullfmt)
        {
         this.expander.fullfmt=fullfmt;
        };
        this.GetFullFmt=function()
        {
         return this.expander.fullfmt;
        }
   cfg.items=[this.grid];
   Irbis.RecListPanelTab128.superclass.constructor.call(this,cfg);
 };
 
 Ext.extend(Irbis.RecListPanelTab128,Ext.Panel);

 //----------------------------------- Irbis.RecListPanel128 -------------------------------------------

 Irbis.RecListPanel128=function(cfg)
 {
  cfg=cfg||{};
  this.irbDb=cfg.irbDb;
  this.irbShowDbInfoOnFull=cfg.irbShowDbInfoOnFull;
  this.irbRec=cfg.irbRec;
  this.irbArm=cfg.irbArm;
  var cfg2=cfg;
//  cfg2.layout='fit';
  cfg2.title=this.searchTitle;
  cfg2.iconCls='irb-search';
//  

 this.m_PftSelector=new Irbis.PftSelector
 ({
   autoLoad:true,
   valueNotFoundText:'Оптимизированый',

   arm:cfg.irbArm,
   dbid:cfg.irbDb,
   xtype:'combo',
   allowBlank: false,
   editable: false,
   fieldLabel: 'БД',
   anchor: '100%',
   listeners:
   {
    select:function(combo,record,index)
    {
     var f=record.get('key');
     if (f=='@')
      this.ChangeFullFmt(f);
     else
      this.ChangeFullFmt('@'+f);
    },
    scope:this
   }
 });

  var btncfg=
  {
   irbArm:this.irbArm,
   irbDb:this.irbDb,
   irbRec:this.irbRec,
   RecListPanel:this
  };
  
  if (typeof(cfg.tbar)=="undefined") cfg.tbar=[];

  if (cfg.showNewRec) cfg.tbar.push(new Irbis.RecListPanel128.ModalButton(Ext.apply({iconCls:'irb-new',tooltip:this.recCreate, url:'../vidget/rlbNewRec.php'},btncfg)));
  if (cfg.showNewRecFromCur) cfg.tbar.push(new Irbis.RecListPanel128.ModalButton(Ext.apply({iconCls:'irb-newfromcur',tooltip:this.recCreateFromCur, url:'../vidget/rlbNewRecFromCur.php'},btncfg)));
  if (cfg.showEditRec) cfg.tbar.push(new Irbis.RecListPanel128.ModalButton(Ext.apply({iconCls:'irb-edit', tooltip:this.recEdit, url:'../vidget/rlbEditRec.php'},btncfg)));
  if (cfg.showDeleteRecs) cfg.tbar.push(new Irbis.RecListPanel128.PreselectionButton(Ext.apply({iconCls:'irb-delete', tooltip:'Удалить записи', title:'Удаление документов', url:'../vidget/rlbDeleteRecs.php', showSrcDocSelector:true, confirmText:'Действительно удалить отмеченные записи?'},btncfg)));
  if (cfg.showGlobalCorrect) cfg.tbar.push(new Irbis.RecListPanel128.PreselectionButton(Ext.apply({iconCls:'irb-globalcorr', tooltip:this.recGlobalCorrect, title:this.recGlobalCorrect, url:'../vidget/rlbGlobalCorrect.php', showSrcDocSelector:true, showGlobalCorrect:true},btncfg)));
  if (cfg.showImportDef) cfg.tbar.push(new Irbis.RecListPanel128.PreselectionButton(Ext.apply({iconCls:'irb-importdef', tooltip:this.recImportDef, title:this.recImportDef, url:'../vidget/rlbCopyRecToDefDb.php', showSrcDocSelector:true},btncfg)));
  if (cfg.showPrintRecs) cfg.tbar.push(new Irbis.RecListPanel128.PreselectionButton(Ext.apply({iconCls:'irb-print', tooltip:this.recPrint, title:this.recPrint, url:'../vidget/rlbPrintRecs.php', showSrcDocSelector:true},btncfg)));
  if (cfg.showExportRecs) cfg.tbar.push(new Irbis.RecListPanel128.PreselectionButton(Ext.apply({iconCls:'irb-export', tooltip:this.recExport, title:this.recExport, url:'../vidget/rlbExportRecs.php', showSrcDocSelector:true, showTVP:true, showContainerSelector:true, showCodepageSelector:true, irbMnuNameByIniSection:'MAIN', irbMnuNameByIniParam:'EXPORTMNU'},btncfg)));
  if (cfg.showCopyRecs) cfg.tbar.push(new Irbis.RecListPanel128.PreselectionButton(Ext.apply({iconCls:'irb-copy', tooltip:this.recCopy, title:this.recCopy, url:'../vidget/rlbCopyRecToDb.php', showSrcDocSelector:true, showTVP:true, irbMnuNameByIniSection:'MAIN', irbMnuNameByIniParam:'COPYMNU',showExpDbSelector:true},btncfg)));
  if (cfg.showImportRecs) cfg.tbar.push(new Irbis.RecListPanel128.PreselectionButton(Ext.apply({iconCls:'irb-import', tooltip:this.recImport, title:this.recImport, url:'../vidget/rlbImportRecs.php', showFileUpload:true, showTVP:true, showContainerSelector:true, showCodepageSelector:true, irbMnuNameByIniSection:'MAIN', irbMnuNameByIniParam:'IMPORTMNU'},btncfg)));
  if (cfg.showStatForms) cfg.tbar.push(new Irbis.RecListPanel128.PreselectionButton(Ext.apply({iconCls:'irb-statform', tooltip:this.recStatForms, title:this.recStatForms, url:'../vidget/rlbStatForms.php', showSrcDocSelector:true, showStatForms:true},btncfg)));
  if (cfg.showSerialSearch) cfg.tbar.push(new Irbis.RecListPanel128.PreselectionButton(Ext.apply({iconCls:'irb-serialsearch', tooltip:this.recSerialSearch, title:this.recSerialSearch, url:'../vidget/rlbSerialSearch.php', showSrcDocSelector:true, showSerialSearch:true,allowEmptySearch:true},btncfg)));
  if (cfg.showAllRecs) cfg.tbar.push(new Ext.Button(Ext.apply({iconCls:'irb-all',tooltip:this.recShowAll, handler: function() {this.RecListPanel.MakeSearch('("V=$")','',[{fmt:"brief",dataIndex:'brief',header:'Описание'}]);}},btncfg)));
  if (cfg.showPft)
  {
   cfg.tbar.push('Формат просмотра: ');
   cfg.tbar.push(this.m_PftSelector);
  }

  
  cfg.tbar.push('-');

  if (typeof(cfg.basketName)!='undefined')
  {
   cfg.tbar.push('->');
   cfg.tbar.push({iconCls:'irb-basket',tooltip:this.basketAdd,handler:function(){Irbis.ModalRequest({irbDb:this.irbDb,irbArm:this.irbArm,action:'add','mfn[]':this.GetSelectedMfns(),basketName:cfg.basketName},'../vidget/basket128.php');},scope:this});
   this.basketName=cfg.basketName;
  }
  this.RecListPanelTab=new Irbis.RecListPanelTab128(cfg2);
  rlt=this.RecListPanelTab;
  this.C_RecListStore=rlt.C_RecListStore;
  this.grid=rlt.grid;
  this.ModalRequest=Irbis.ModalRequest;
  this.LongRequest=Irbis.LongRequest;
  cfg.layout=void 0;
  cfg.tabPosition='bottom';
  cfg.items=[this.RecListPanelTab];
  if (typeof(cfg.basketName)!='undefined') 
  {
   this.RecListBasket=new Irbis.RecListPanelTab128({irbDb:this.irbDb,irbArm:this.irbArm,layout:'fit',basketName:cfg.basketName,GetLastSrc:function(){return '';},GetLastSeqence:function(){return '';}});
   
   this.basketPftSelector=new Irbis.PftSelector
   ({
     autoLoad:true,
     valueNotFoundText:'Оптимизированый',
     arm:this.irbArm,
     dbid:this.irbDb,
     xtype:'combo',
     allowBlank: false,
     editable: false,
     fieldLabel: 'БД',
     anchor: '100%',
     listeners:
     {
      select:function(combo,record,index)
      {
       var f=record.get('key');
       if (f=='@') this.RecListBasket.ChangeFullFmt(f); else this.RecListBasket.ChangeFullFmt('@'+f);
      },
      scope:this
     }
   });

   var basketbtncfg=
   {
    irbArm:this.irbArm,
    irbDb:this.irbDb,
    irbRec:this.irbRec,
    RecListPanel:this.RecListBasket,
    basketName:this.basketName
   };

   var rltbar=
   [
    {iconCls:'irb-clear',tooltip:this.basketClear,handler:function(){this.ModalRequest({irbDb:this.irbDb,irbArm:this.irbArm,action:'clear','mfn[]':this.RecListBasket.GetSelectedMfns(),basketName:this.RecListBasket.basketName},'../vidget/basket128.php');},scope:this},
    {iconCls:'irb-basket-remove',tooltip:this.basketRemove,handler:function(){this.ModalRequest({irbDb:this.irbDb,irbArm:this.irbArm,action:'del','mfn[]':this.RecListBasket.GetSelectedMfns(),basketName:this.RecListBasket.basketName},'../vidget/basket128.php');},scope:this},
    '-'
   ];
   
   if (cfg.showEditRec) rltbar.push(new Irbis.RecListPanel128.ModalButton(Ext.apply({iconCls:'irb-edit', tooltip:this.recEdit, url:'../vidget/rlbEditRec.php'},basketbtncfg)));
   if (cfg.showPrintRecs) rltbar.push(new Irbis.RecListPanel128.PreselectionButton(Ext.apply({iconCls:'irb-print', tooltip:this.recPrint, title:this.recPrint, url:'../vidget/rlbPrintRecs.php', showSrcDocSelector:true},basketbtncfg)));
   if (cfg.showCopyRecs) rltbar.push(new Irbis.RecListPanel128.PreselectionButton(Ext.apply({iconCls:'irb-copy', tooltip:this.recCopy, title:this.recCopy, url:'../vidget/rlbCopyRecToDb.php', showSrcDocSelector:true, showTVP:true, irbMnuNameByIniSection:'MAIN', irbMnuNameByIniParam:'COPYMNU',showExpDbSelector:true},basketbtncfg)));
   if (cfg.showDeleteRecs) rltbar.push(new Irbis.RecListPanel128.PreselectionButton(Ext.apply({iconCls:'irb-delete', tooltip:this.recRemove, title:this.recRemove, url:'../vidget/rlbDeleteRecs.php', showSrcDocSelector:true, confirmText:'Действительно удалить отмеченные записи?'},basketbtncfg)));
   if (cfg.showPft)
   {
      rltbar.push('-');
      rltbar.push(this.viewFormat+": ");
      rltbar.push(this.basketPftSelector);
   }

   cfg.items.push
   ({
     title:this.basketTitle,
     iconCls:'irb-basket',
     layout:'fit',
     m_recList:this.RecListBasket,
     tbar:rltbar,
     items:[this.RecListBasket],
     listeners:
     {
      activate:function(tab){tab.m_recList.Reload();}
     }
   });
  }
  cfg.activeTab=0;
  cfg.tbar=void 0;
  Irbis.RecListPanel128.superclass.constructor.call(this,cfg);
 };
 Ext.extend(Irbis.RecListPanel128,Ext.TabPanel,
 {
  searchTitle:'Результаты поиска',
  basketTitle:'Корзина',
  basketAdd:'Добавить отмеченные записи в корзину',
  basketClear:'Очистить корзину',
  basketRemove:'Удалить из корзины',
  recCopy:'Копировать записи',
  recCreate:'Создать новую запись',
  recCreateFromCur:'Создать новую запись из текущей',
  recEdit:'Редактировать запись',
  recExport:'Экспортировать записи',
  recGlobalCorrect:'Глобальная корректировка',
  recImport:'Импортировать записи',
  recImportDef:'Импортировать записи в основной каталог',
  recPrint:'Печать документов',
  recRemove:'Удалить записи',
  recShowAll:'Показать все записи в БД',
  recStatForms:'Статистические формы',
  recSerialSearch:'Последовательный поиск',
  titleSerialSearch:'Результат последовательного поиска',
  viewFormat:'Формат просмотра',

  ChangeDb:function(irbDb){this.irbDb=irbDb;this.RecListPanelTab.ChangeDb(irbDb);if (typeof(this.basketName)!='undefined') {this.RecListBasket.ChangeDb(irbDb); this.RecListBasket.Reload();this.m_PftSelector.ChangeDb(irbDb); this.m_PftSelector.setValue('@');}},
  GetCurRecMfn:function(){return this.RecListPanelTab.GetCurRecMfn();},
  GetSelectedMfns:function(){return this.RecListPanelTab.GetSelectedMfns();},
  GetCurRecId:function(){return this.RecListPanelTab.GetCurRecId();},
  MakeSearch:function(src,sequence,fmt){this.setActiveTab(0); return this.RecListPanelTab.MakeSearch(src,sequence,fmt);},
  Reload:function () { return this.RecListPanelTab.Reload();},
  ChangeFullFmt:function(fullfmt) {return this.RecListPanelTab.ChangeFullFmt(fullfmt);},
  GetFullFmt:function(){return this.RecListPanelTab.GetFullFmt();},
  GetLastSrc:function(){return this.RecListPanelTab.src;},
  GetLastSeqence:function(){return this.RecListPanelTab.sequence;}
 });

 Irbis.RecBasket128=function(cfg)
 {
  cfg=cfg||{};
  cfg.layout='fit';
  this.irbArm=cfg.irbArm;
  this.irbShowDbInfoOnFull=cfg.irbShowDbInfoOnFull;

  this.C_RecListStore=new Ext.data.JsonStore
  ({
    fields:['id','npp','dbid','mfn','brief'],
    url: '../vidget/RecBasket128.php',
    baseParams:{irbArm:cfg.irbArm},
    root: 'RecList',
    totalProperty:'totalCount',
    autoLoad:true
  });
  if (this.irbShowDbInfoOnFull)
   this.expanderTpl='i,{dbid}/{mfn}';
  else
   this.expanderTpl='{dbid}/{mfn}';
  this.expander=new Ext.grid.RowExpander128({tpl:this.expanderTpl});
  this.grid=new Ext.grid.GridPanel
  ({
    store:this.C_RecListStore,
    loadMask:{msg:'Загрузка...'},
    sm:new Ext.grid.CheckboxSelectionModel({singleSelect:false,width:20}),
    plugins:this.expander,
    columns:
    [
     this.expander,
     new Ext.grid.CheckboxSelectionModel({singleSelect:false,width:20}),
     {header: '#',dataIndex:'npp',width:20,align:'right',sortable:true,menuDisabled:true},
     {header: 'Описание',autoWidth:true,dataIndex:'brief',sortable:true,menuDisabled:true}
    ],
    stripeRows: true,
    autoWidth:true,
    layout:'fit',
    viewConfig:{forceFit:true},
    bbar:new Ext.PagingToolbar
    ({
      store:this.C_RecListStore,
      displayInfo:cfg.showTotalCount,
      pageSize:20
    })
  });
  cfg.items=[this.grid];
  Irbis.RecBasket128.superclass.constructor.call(this,cfg);
  this.addRecs=function(recs)
  {
   r=new Array();
   for (i=0;i<recs.length;i++)
   {
    r[i]=recs[i].data;
   }
   this.C_RecListStore.load({params:{start:0,limit:20,recadd:Ext.encode(r)}});
  }
 };
 
 Ext.extend(Irbis.RecBasket128,Ext.Panel);


 //-------------------------------------------------- BUTTONS


 Irbis.RecListPanel128.PreselectionButton=function(cfg)
 {
  cfg=cfg||{};
  this.LongRequest=Irbis.LongRequest;
  cfg.handler=function()
  {
   var w=new Irbis.RecPreselector
   ({
     oscope:this,
     allowEmptySearch:this.allowEmptySearch,
     showSrcDocSelector:this.showSrcDocSelector,
     showTVP:this.showTVP,
     showContainerSelector:this.showContainerSelector,
     showCodepageSelector:this.showCodepageSelector,
     showExpDbSelector:this.showExpDbSelector,
     showFileUpload:this.showFileUpload,
     showGlobalCorrect:this.showGlobalCorrect,
     showStatForms:this.showStatForms,
     showSerialSearch:this.showSerialSearch,
     irbMnuName:this.irbMnuName,
     irbMnuNameByIniSection:this.irbMnuNameByIniSection,
     irbMnuNameByIniParam:this.irbMnuNameByIniParam,
     url:this.url,
     irbDb:this.RecListPanel.irbDb,
     irbArm:this.RecListPanel.irbArm,
     title:this.title,
     params:
     {
      'mfn[]':this.RecListPanel.GetSelectedMfns(),
      src:this.RecListPanel.GetLastSrc(),
      sequence:this.RecListPanel.GetLastSeqence(),
      pft:this.RecListPanel.GetFullFmt()
     }
    });
    w.show();
    w.center();
  },
  Irbis.RecListPanel128.PreselectionButton.superclass.constructor.call(this,cfg);
 };

 Ext.extend(Irbis.RecListPanel128.PreselectionButton,Ext.Button);

 Irbis.RecListPanel128.ModalButton=function(cfg)
 {
  this.ModalRequest=Irbis.ModalRequest;
  Ext.apply(cfg,
  {
   handler: function()
   {
    if (typeof(this.confirmText)!="undefined") if (!confirm(this.confirmText)) return;
     this.ModalRequest({arm:this.RecListPanel.irbArm,irbDb:this.RecListPanel.irbDb,irbRec:this.irbRec,mfn:this.RecListPanel.GetCurRecMfn()},this.url);
   },
   scope:this
  });
  Irbis.RecListPanel128.ModalButton.superclass.constructor.call(this,cfg);
 };

 Ext.extend(Irbis.RecListPanel128.ModalButton,Ext.Button);

