/*
 Irbis.SearchPanel
 Irbis.SearchSelector
*/

Ext.tree.ColumnTree = Ext.extend(Ext.tree.TreePanel, {
    lines:false,
    borderWidth: Ext.isBorderBox ? 0 : 2, // the combined left/right border for each cell
    cls:'x-column-tree',
    
    onRender : function(){
        Ext.tree.ColumnTree.superclass.onRender.apply(this, arguments);
        this.headers = this.body.createChild(
            {cls:'x-tree-headers'},this.innerCt.dom);

        var cols = this.columns, c;
        var totalWidth = 0;

        for(var i = 0, len = cols.length; i < len; i++){
             c = cols[i];
             totalWidth += c.width;
             this.headers.createChild({
                 cls:'x-tree-hd ' + (c.cls?c.cls+'-hd':''),
                 cn: {
                     cls:'x-tree-hd-text',
                     html: c.header
                 },
                 style:'width:'+(c.width-this.borderWidth)+'px;'
             });
        }
        this.headers.createChild({cls:'x-clear'});
        // prevent floats from wrapping when clipped
        this.headers.setWidth(totalWidth);
        this.innerCt.setWidth(totalWidth);
    }
});

Ext.tree.ColumnNodeUI = Ext.extend(Ext.tree.TreeNodeUI, {
    focus: Ext.emptyFn, // prevent odd scrolling behavior

    renderElements : function(n, a, targetNode, bulkRender){
        this.indentMarkup = n.parentNode ? n.parentNode.ui.getChildIndent() : '';

        var t = n.getOwnerTree();
        var cols = t.columns;
        var bw = t.borderWidth;
        var c = cols[0];

        var buf = [
             '<li class="x-tree-node"><div ext:tree-node-id="',n.id,'" class="x-tree-node-el x-tree-node-leaf ', a.cls,'">',
                '<div class="x-tree-col" style="width:',c.width-bw,'px;">',
                    '<span class="x-tree-node-indent">',this.indentMarkup,"</span>",
                    '<img src="', this.emptyIcon, '" class="x-tree-ec-icon x-tree-elbow">',
                    '<img src="', a.icon || this.emptyIcon, '" class="x-tree-node-icon',(a.icon ? " x-tree-node-inline-icon" : ""),(a.iconCls ? " "+a.iconCls : ""),'" unselectable="on">',
                    '<a hidefocus="on" class="x-tree-node-anchor" href="',a.href ? a.href : "#",'" tabIndex="1" ',
                    a.hrefTarget ? ' target="'+a.hrefTarget+'"' : "", '>',
                    '<span unselectable="on">', n.text || (c.renderer ? c.renderer(a[c.dataIndex], n, a) : a[c.dataIndex]),"</span></a>",
                "</div>"];
         for(var i = 1, len = cols.length; i < len; i++){
             c = cols[i];

             buf.push('<div class="x-tree-col ',(c.cls?c.cls:''),'" style="width:',c.width-bw,'px;">',
                        '<div class="x-tree-col-text">',(c.renderer ? c.renderer(a[c.dataIndex], n, a) : a[c.dataIndex]),"</div>",
                      "</div>");
         }
         buf.push(
            '<div class="x-clear"></div></div>',
            '<ul class="x-tree-node-ct" style="display:none;"></ul>',
            "</li>");

        if(bulkRender !== true && n.nextSibling && n.nextSibling.ui.getEl()){
            this.wrap = Ext.DomHelper.insertHtml("beforeBegin",
                                n.nextSibling.ui.getEl(), buf.join(""));
        }else{
            this.wrap = Ext.DomHelper.insertHtml("beforeEnd", targetNode, buf.join(""));
        }

        this.elNode = this.wrap.childNodes[0];
        this.ctNode = this.wrap.childNodes[1];
        var cs = this.elNode.firstChild.childNodes;
        this.indentNode = cs[0];
        this.ecNode = cs[1];
        this.iconNode = cs[2];
        this.anchor = cs[3];
        this.textNode = cs[3].firstChild;
    }
});
//-------------------------------- Irbis.SearchSelector ----------------------------------------------------------

Irbis.SearchSelector = function(cfg)
{
 cfg=cfg||{};
 cfg.width=200;
 cfg.allowBlank= false;
 cfg.resizable=true;
 cfg.blankText= 'Необходимо выбрать вид поиска';
 cfg.editable= false;
 cfg.fieldLabel= 'Name';
 cfg.name= 'Name';
 cfg.displayField='Name';
 cfg.valueField='Name';
 cfg.hiddenName='Name';
 cfg.typeAhead= true;
 cfg.triggerAction= 'all';
 cfg.emptyText='Выберите вид поиска...';
 cfg.selectOnFocus=true;
 cfg.store= new Ext.data.JsonStore
 ({
   url: '../vidget/SearchPanel.php',
   baseParams:{action:'GetSearchList',irbDb:cfg.irbDb},
   root: 'RecList',
   fields: ['Name','Pref','DictionType','Logic','Menu','F8For','ModByDic','Tranc','Hint','ModByDicAuto','Adv']
 });
 this.fnChangeDb=function(irbDb)
 {
  this.irbDb=irbDb;
  this.store.baseParams.irbDb=Ext.encode(irbDb);
  this.store.load();
 };
 Irbis.SearchSelector.superclass.constructor.call(this,cfg);
};

Ext.extend(Irbis.SearchSelector,Ext.form.ComboBox);

//--------------------------------- Irbis.SearchKey ----------------------------------------------------------
Irbis.SearchKey=function(cfg)
{
 cfg=cfg||{};
 Irbis.SearchKey.superclass.constructor.call(this,cfg);
};

Ext.extend(Irbis.SearchKey,Ext.form.TextField);

//--------------------------------- Irbis.DictionType0 --------------------------------------------------------

Irbis.DictionType0=function(cfg)
{
 cfg=cfg||{};
 cfg.listeners=cfg.listeners||{};   
 Ext.apply(cfg,{
   store:new Ext.data.JsonStore
   ({
     proxy: new Ext.data.HttpProxy({
       url: '../vidget/SearchPanel.php',
       method: 'POST',
       disableCaching: true
     }),
     baseParams: 
     {
      action:'GetDictionItems',start:cfg.irbPref,inModeInitStr:cfg.inModeInitStr
     },
     root: 'RecList',
     fields: ['key','docs','mfn','tag','occ','cnt','format'],
     autoLoad:false
   }),
   width:.99,
//   height:200,
   layout:'fit',
   loadMask:{msg:'Загрузка...'},
   viewConfig: 
   {
     forceFit: true, autoFill:true
   },
   sm: new Ext.grid.RowSelectionModel({singleSelect:true,width:20}),
   columns:
   [
    {header: 'Док-ов',width:30,dataIndex:'docs'},
    {header: 'Термины',dataIndex:'key'}
   ],
   irbPref:cfg.irbPref,
   KeyChange:function(key)
   {
   }
 });
 Irbis.DictionType0.superclass.constructor.call(this,cfg);
 this.store.load({params:{irbDb:Ext.encode(cfg.irbDb)}});
 this.addListener('rowdblclick',function(grid,rowIndex,e)
    {
     var trm=grid.store.getAt(rowIndex).get('key');
     var refs=grid.store.getAt(rowIndex).get('docs');
     var mfn=grid.store.getAt(rowIndex).get('mfn');
     var tag=grid.store.getAt(rowIndex).get('tag');
     var occ=grid.store.getAt(rowIndex).get('occ');
     var cnt=grid.store.getAt(rowIndex).get('cnt');
     var format=grid.store.getAt(rowIndex).get('format');
     this.fireEvent('onTermSelected',{pref:grid.irbPref,term:trm,refs:refs,mfn:mfn,tag:tag,occ:occ,cnt:cnt,format:format});
    },this);
};

Ext.extend(Irbis.DictionType0,Ext.grid.GridPanel);

//--------------------------- Irbis.DictionType1 -----------------------------------------------------------

Irbis.DictionType1=function(cfg)
{
 cfg=cfg||{};
 Ext.apply(cfg,{
   store:new Ext.data.JsonStore
   ({
     proxy: new Ext.data.HttpProxy({
       url: '../vidget/SearchPanel.php',
       method: 'POST',
       disableCaching: true
     }),
     baseParams: 
     {
      action:'GetDictionItemsWDesc',
      mnu:cfg.irbMenu,
      start:cfg.irbPref,
      inModeInitStr:cfg.inModeInitStr
     },
     params:{irbDb:Ext.encode(cfg.irbDb)},
     root: 'RecList',
     fields: ['key','docs','desc','mfn','tag','occ','cnt'],
     autoLoad:false
   }),
   loadMask:{msg:'Загрузка...'},
   width:.99,
   layout:'fit',
   loadMask:{msg:'Загрузка...'},
   viewConfig: 
   {
     forceFit: true, autoFill:true
   },
   sm: new Ext.grid.RowSelectionModel({singleSelect:true,width:20}),
   columns:
   [
    {header: 'Док-ов',width:50,dataIndex:'docs'},
    {header: 'Термины',dataIndex:'key'},
    {header: 'Пояснения',dataIndex:'desc'}
   ],
   irbPref:cfg.irbPref,
   listeners:
   {
    rowdblclick: function(grid,rowIndex,e)
    {
     var trm=grid.store.getAt(rowIndex).get('key');
     var refs=grid.store.getAt(rowIndex).get('docs');
     var mfn=grid.store.getAt(rowIndex).get('mfn');
     var tag=grid.store.getAt(rowIndex).get('tag');
     var occ=grid.store.getAt(rowIndex).get('occ');
     var cnt=grid.store.getAt(rowIndex).get('cnt');
     this.fireEvent('onTermSelected',{pref:grid.irbPref,term:trm,refs:refs,mfn:mfn,tag:tag,occ:occ,cnt:cnt});
    }
   },
   //autoWidth:true,
   //autoExpandColumn: 'key',
   KeyChange:function(key)
   {
   }
 });
 Irbis.DictionType1.superclass.constructor.call(this,cfg);
 this.store.load({params:{irbDb:Ext.encode(cfg.irbDb)}});
};

Ext.extend(Irbis.DictionType1,Ext.grid.GridPanel);

//----------------------------- Irbis.DictionType2 ----------------------------------------------------

Irbis.DictionType2=function(cfg)
{
 cfg=cfg||{};
 Irbis.DictionType2.superclass.constructor.call(this,{
   width:.99,
   //autoHeight:true,
   rootVisible:false,
   //autoScroll:true,
   layout:'fit',
   viewConfig: 
   {
     forceFit: true, autoFill:true
   },
   
   columns:[{
       header:'Термины',
       width:190,
       dataIndex:'desc'
   },{
       header:'Док-ов',
       width:50,
       dataIndex:'docs'
   }],

   loader: new Ext.tree.TreeLoader({
       dataUrl:'../vidget/SearchPanel.php',
       baseParams: 
       {
        action:'GetDictionItemsT2',
        mnu:cfg.irbMenu,
        start:cfg.irbPref,
        inModeInitStr:cfg.inModeInitStr
       },
       requestMethod:'POST',
       params:{irbDb:Ext.encode(cfg.irbDb)},
       uiProviders:{
           'col': Ext.tree.ColumnNodeUI
       }
   }),
   irbPref:cfg.irbPref,
   listeners:
   {
    rowdblclick: function(grid,rowIndex,e)
    {
     var trm=grid.store.getAt(rowIndex).get('key');
     var refs=grid.store.getAt(rowIndex).get('docs');
     this.fireEvent('onTermSelected',{pref:grid.irbPref,term:trm,refs:refs});
    }
   },
   root: new Ext.tree.AsyncTreeNode({
       text:'Tasks'
   }),
   KeyChange:function(key)
   {
   }
 });
};

Ext.extend(Irbis.DictionType2,Ext.tree.ColumnTree);

//----------------------------- Irbis.SearchPanel ---------------------------------------------------------

Irbis.SearchPanel=function(cfg)
{
 this.inModeInitStr=cfg.inModeInitStr;
 this.prevsearch='';
 this.fnChangeDb=function(irbDb)
 {
   this.irbDb=irbDb;
   this.SearchSelector.fnChangeDb(irbDb);
   if (this.MainSelector!=null)
   {
     this.MainSelector.getStore().load({params:{irbDb:Ext.encode(irbDb)}});
   }
 };
 this.fnChangeSearchType=function()
 {
  icfg=
  {
   height:300,
   irbName:this.CurSearchType.Name,
   irbPref:this.CurSearchType.Pref,
   irbDictionType:this.CurSearchType.DictionType,
   irbLogic:this.CurSearchType.Logic,
   irbMenu:this.CurSearchType.Menu,
   irbF8For:this.CurSearchType.F8For,
   irbModByDic:this.CurSearchType.ModByDic,
   irbTranc:this.CurSearchType.Tranc,
   irbHint:this.CurSearchType.Hint,
   irbModByDicAuto:this.CurSearchType.ModByDicAuto,
   irbAdv:this.CurSearchType.Adv,
   irbDb:this.irbDb,
   inModeInitStr:this.inModeInitStr
  };
  if (this.MainSelector!=null)
   this.remove(this.MainSelector,true);
  switch(this.CurSearchType.DictionType)
  {
   case '0': this.MainSelector=new Irbis.DictionType0(icfg); break;
   case '1': this.MainSelector=new Irbis.DictionType1(icfg); break;
   case '2': this.MainSelector=new Irbis.DictionType2(icfg); break;
   default: this.MainSelector=null;
  }
  if (this.MainSelector!=null)
  {
   this.MainSelector.addListener('onTermSelected',function(opt)
   {
    if ((this.operat=='') || (this.prevsearch==''))
    {
     this.prevsearch='("'+opt.pref+opt.term+'")';
     opt.src=this.prevsearch;
    }
    else
    {
     this.prevsearch='('+this.prevsearch+' '+this.operat+' '+'("'+opt.pref+opt.term+'"))';
     opt.src=this.prevsearch;
    }
    this.fireEvent('onTermSelected',opt);
   },this);
   this.add(this.MainSelector);
   this.doLayout();
  }
  this.SearchKey.setRawValue('');
 };

 this.SearchSelector=new Irbis.SearchSelector
 ({
   irbDb:cfg.irbDb,
   listeners: 
   {
    select:function(combo,record,index)
    {
     this.CurSearchType=record.data;
     this.fnChangeSearchType();
    },
    collapse:function(combo)
    {
     this.SearchKey.focus();
    },
    scope: this
   }
 });

 this.SearchKey=new Irbis.SearchKey({enableKeyEvents:true});
 this.SearchKey.on('keyup',function(fld,e){if(e.getKey()==13){this.fireEvent('onTermSelected',{pref:this.MainSelector.irbPref,term:fld.getValue()+"$",src:this.MainSelector.irbPref+fld.getValue()+"$"});}else this.FlyToTerm(fld.getValue())},this,{buffer:250});
 this.LastTermFly='';
 
 this.operat='';
 
 this.btnFirst=new Ext.Button({iconCls: "x-tbar-page-first",scope:this, handler:this.doPagingFirst});
 this.btnPrev=new Ext.Button({iconCls: "x-tbar-page-prev",scope:this, handler:this.doPagingPrev});
 this.btnNext=new Ext.Button({iconCls: "x-tbar-page-next",scope:this, handler:this.doPagingNext});
 this.btnLast=new Ext.Button({iconCls: "x-tbar-page-last",scope:this, handler: this.doPagingLast});
 this.btnLogicType=new Ext.Button
 ({
   iconCls: "irb-new",
   tooltip: this.txtComplexSearch+' ('+this.txtNewSearch+')',
   scope:this, 
   menu:
   [
    {iconCls: 'irb-new',text:this.txtNewSearch,handler:function(){this.setComplex('irb-new');},scope:this},
    {iconCls: 'irb-log-and',text:this.txtLogicAnd,handler:function(){this.setComplex('irb-log-and');},scope:this},
    {iconCls: 'irb-log-or',text:this.txtLogicOr,handler:function(){this.setComplex('irb-log-or');},scope:this},
    {iconCls: 'irb-log-not',text:this.txtLogicNot,handler:function(){this.setComplex('irb-log-not');},scope:this}
//    {iconCls: 'irb-log-infield',text:this.txtLogicF,handler:function(){this.setComplex('irb-log-infield');},scope:this}
   ]
 });
 cfg.tbar=[];

 if (cfg.hideSearchSelector!=true)
 {
  if (cfg.hideComplexSearch!=true)
  {
   this.btnCoplexSearch=new Ext.Button({iconCls: "irb-complexsearch",scope:this, tooltip:this.txtComplexSearch, handler:this.fnCopmlexSearch});
   cfg.tbar.push(this.btnCoplexSearch);
  }
  if (cfg.hideComplex!=true)
   cfg.tbar.push(this.btnLogicType);
  cfg.tbar.push(new Ext.Toolbar.TextItem("Вид поиска: "));
  cfg.tbar.push(this.SearchSelector);
  this.MainSelector=new Irbis.DictionType0();
 }
 else
 {
  if (this.MainSelector!=null)
   this.remove(this.MainSelector,true);
  this.MainSelector=new Irbis.DictionType0
  ({
  	inModeInitStr:cfg.inModeInitStr,
	listeners:
	{
		onTermSelected:function(opt)
		{
			this.fireEvent('onTermSelected',opt);
		},
		scope:this
	}
  });
 }
 cfg.bbar=[this.btnFirst,this.btnPrev,'-',new Ext.Toolbar.TextItem('Ключ: '),this.SearchKey,'-',this.btnNext,this.btnLast];
 cfg.items=[this.MainSelector];
 cfg.layout='fit';
 Irbis.SearchPanel.superclass.constructor.call(this,cfg);
 if (typeof(this.irbDb)!='undefined')
  this.fnChangeDb(this.irbDb);
};

Ext.extend(Irbis.SearchPanel,Ext.Panel,
{
 txtNewSearch:'Новый поиск',
 txtLogicAnd:'<b>И</b> - ужесточить предыдущий поиск',
 txtLogicOr:'<b>ИЛИ</b> - расширить предыдущий поиск',
 txtLogicNot:'<b>И НЕ</b> - изъять из предыдущего поиска',
 txtLogicF:'<b>И В ПОЛЕ</b> - ужесточить предыдущий поиск по полю',
 txtComplexSearch:'Комплексный поиск',

 setComplex:function(ct)
 {
  this.btnLogicType.setIconClass(ct);
  var s='';
  switch(ct)
  {
   case 'irb-new': s=this.txtNewSearch; this.operat=''; break;
   case 'irb-log-and': s=this.txtLogicAnd; this.operat='*'; break;
   case 'irb-log-or': s=this.txtLogicOr; this.operat='+'; break;
   case 'irb-log-not': s=this.txtLogicNot; this.operat='^'; break;
   case 'irb-log-infield': s=this.txtLogicF; this.operat='(F)'; break;
  }
  this.btnLogicType.setTooltip(this.txtComplexSearch+' ('+s+')');
 },
 
 FlyToTerm:function(trm) { if (trm!=this.LastTermFly) { this.MainSelector.getStore().load({params:{term:trm,back:false,irbDb:Ext.encode(this.irbDb)}}); this.LastTermFly=trm; } },
 doPagingFirst:function() { ltrm=''; if (this.MainSelector.getStore().getCount()>0) { ltrm=this.MainSelector.getStore().getAt(0).get('key'); } this.MainSelector.getStore().load({params:{term:'',back:false,irbDb:Ext.encode(this.irbDb)}}); },
 doPagingPrev:function() { ltrm=''; if (this.MainSelector.getStore().getCount()>0) { ltrm=this.MainSelector.getStore().getAt(0).get('key'); } this.MainSelector.getStore().load({params:{term:ltrm,back:true,irbDb:Ext.encode(this.irbDb)}}); },
 doPagingNext:function() { ltrm=''; cnt=this.MainSelector.getStore().getCount(); if (cnt>0) { ltrm=this.MainSelector.getStore().getAt(cnt-1).get('key'); }  this.MainSelector.getStore().load({params:{term:ltrm,back:false,irbDb:Ext.encode(this.irbDb)}}); },
 doPagingLast:function() { this.MainSelector.getStore().load({params:{term:'Я',back:true,irbDb:Ext.encode(this.irbDb)}}); },
 fnCopmlexSearch:function() 
 {
  var w=new Irbis.SearchComplexWindow({width:750,height:400,irbDb:this.irbDb,listeners:
  {
   onTermSelected:function(opt)
   {
    this.fireEvent('onTermSelected',opt);},scope:this}});
  w.show();
 }
});


//-------------------------- Irbis.SearchComplexWindow ----------------------------------------------------------------

Irbis.SearchComplexWindow=function(cfg)
{

 this.searchStr='';
 this.searchPanel=new Irbis.SearchPanel
 ({
   irbDb:cfg.irbDb,
   colcfg:cfg.colcfg,
   height:200,
   title:this.searchPanelTitle,
   collapsible:true,
   titleCollapse:true,
   region:'east',
   split:true,
   hideComplexSearch:true,
   hideComplex:true,
   hideSearchSelector:true,
   width:280,
   listeners:
   {
    onTermSelected:function(opt)
    {
     var s=this.listPanel.getStore();
     var sm=this.listPanel.getSelectionModel();
     if (sm.hasSelection())
     {
      var r=sm.getSelected();
      r.set('term',opt.term);
     }
     /*if (opt.src=='')
      this.m_RecList.MakeSearch('("'+opt.pref+opt.term+'")','',this.colcfg);
     else
      this.m_RecList.MakeSearch(opt.src,'',this.colcfg);*/
    },
    scope:this
   }
 });

 this.bAdd=new Ext.Button({iconCls:'irb-add',text:this.txtAdd,handler:this.addNewRow,scope:this});
 this.bDel=new Ext.Button({iconCls:'irb-delete',text:this.txtDelete,handler:function(){var sm=this.listPanel.getSelectionModel();if (sm.hasSelection()) { var r=sm.getSelected(); this.listPanel.getStore().remove(r);}},scope:this});
 this.bRun=new Ext.Button({iconCls:'irb-search','text':this.txtRun,handler:this.doSearch,scope:this});
 this.bClose=new Ext.Button({iconCls:'irb-logout','text':this.txtClose,handler:this.doClose,scope:this});

 this.listPanel=new Ext.grid.EditorGridPanel
 ({
   region:'center',
   layout:'fit',
   title:this.listPanelTitle,
   enableHdMenu:false,
   clicksToEdit: 1,
   store: new Ext.data.JsonStore
   ({
     autoDestroy: true,
     root: 'rows',
     fields: ['prefix','term','us','logic','searchtype'],
     data: {rows:[]}
   }),
   colModel: new Ext.grid.ColumnModel
   ({
     defaults: {width: 120, sortable: true },
     columns: 
     [
      {header: this.txtLogic, dataIndex: 'logic',width:40, editor:new Ext.form.ComboBox({typeAhead: true, triggerAction: 'all', lazyRender:true, mode: 'local', store: new Ext.data.ArrayStore({id: 0, fields: ['myId', 'displayText'], data: [['*', this.txtAnd], ['+', this.txtOr], ['^', this.txtNot]] }), valueField: 'myId', displayField: 'displayText'}),renderer:this.renderLogic,scope:this},
      {header: this.txtSearchType, dataIndex: 'prefix',editor:new Irbis.SearchSelector({irbDb:cfg.irbDb,listeners:{select:function(combo,record,index)
      {
       combo.gridEditor.record.set('searchtype',record.data);
       this.searchPanel.CurSearchType=record.data; 
       this.searchPanel.fnChangeSearchType();
      }, scope: this }}),renderer:this.renderSearch,scope:this},
      {header: this.txtTerm, dataIndex: 'term',editor: new Ext.form.TextField({allowBlank: false})},
      {header: this.txtUs, dataIndex: 'us',width:30, xtype: 'checkcolumn'}
     ]
    }),
    viewConfig: 
    {
     forceFit: true,
     sortable:false
    },
    sm: new Ext.grid.RowSelectionModel({singleSelect:true,listeners:{rowselect:function(sm,ri,r){if(r.get('pref')!='') this.searchPanel.CurSearchType=r.get('searchtype'); this.searchPanel.fnChangeSearchType();},scope:this}}),
    bbar:[this.bAdd,this.bDel,'->',this.bRun,this.bClose]
 });

 this.panel=new Ext.Panel
 ({
   layout:'border',
   items:[this.listPanel,this.searchPanel]
 });
 cfg.items=[this.panel];
 cfg.layout='fit';
 cfg.title=this.txtWindowTitle;
 Irbis.SearchComplexWindow.superclass.constructor.call(this,cfg);

 //this.searchPanel.getStore().load;
 //var store=this.listPanel.getStore();
 //store.add([new Ext.data.Record({pref:'',prefix:'',term:'',us:true,logic:'*'})]);
 //this.listPanel.getStore().add([new Ext.data.Record({pref:'',prefix:'',term:'',us:true,logic:'*'})]);
 this.addNewRow();
};

Ext.extend(Irbis.SearchComplexWindow,Ext.Window,
{
 searchPanelTitle:'Словарь',
 listPanelTitle:'Сценарий поиска',
 txtAnd:'И',
 txtOr:'ИЛИ',
 txtNot:'И НЕ',
 txtWindowTitle:'Комплексный поиск',
 txtLogic:'Логика',
 txtSearchType:'Вид поиска',
 txtTerm:'Термин',
 txtUs:'Усечение',
 txtAdd:'Добавить',
 txtDelete:'Удалить',
 txtRun:'<b>Выполнить</b>',
 txtClose:'Закрыть',

 renderLogic:function(v)
 {
  if (v=='*') return this.txtAnd;
  if (v=='+') return this.txtOr;
  if (v=='^') return this.txtNot;
 },

 renderSearch:function(v,a,r)
 {
  return v;
 },

 addNewRow:function()
 {
  var store=this.listPanel.getStore();
  store.add([new Ext.data.Record({prefix:'',term:'',us:true,logic:'*',searchtype:{}})]);
 },

 recWork:function(r)
 {
  if (this.searchStr!="") this.searchStr+=r.get('logic');
  this.searchStr+=("(\""+r.get('searchtype').Pref+r.get('term')+(r.get('us')?"$":"")+"\")");
 },

 doSearch:function()
 {
  var store=this.listPanel.getStore();
  store.each(this.recWork,this);
  this.fireEvent('onTermSelected',{src:this.searchStr});
  this.close();
 },

 doClose:function(){this.close();}

});

//-------------------------- Irbis.DbMultySelectTreePanel ------------------------------------------------------------

Irbis.DbMultySelectTreePanel=function(cfg)
{
    cfg.rootVisible=false;
    cfg.singleExpand=false;
    cfg.useArrows=true;
    cfg.root= new Ext.tree.AsyncTreeNode
        ({
                text:"Ext JS",
                id:"root",
                expanded:true
        });
        cfg.loader=new Ext.tree.TreeLoader
        ({
                preloadChildren:true,
                url:'../vidget/GetDbMultySelectTreeItems.php?irbArm='+cfg.irbArm
        });
        //cfg.viewConfig={forceFit: true};
        //cfg.layout='fit';
        cfg.listeners=cfg.listeners||{};
        cfg.listeners.checkchange=function(){this.fireEvent('onSelectionChange',{})};
        cfg.listeners.scope=this;
        this.fnGetVal=function()
        {
                
                rs=this.getChecked('dbname');
                shl=[];
                cn=0;
                for(var i = 0, len = rs.length; i < len; i++)
                {
                        if (typeof(rs[i])!="undefined")
                        {
                                shl[cn]=rs[i];
                                cn++;
                        }       
                }
                return shl;
        };
        this.fnSelects=function(){};
        Irbis.DbMultySelectTreePanel.superclass.constructor.call(this,cfg);
};
Ext.extend(Irbis.DbMultySelectTreePanel,Ext.tree.TreePanel);

//---------------------------------- Irbis.SearchPanelMulty ----------------------------------------------------------

Irbis.SearchPanelMulty=function(cfg)
{

//cfg:
//localdata: db data
        this.irbArm=cfg.irbArm;
        this.irbDb=cfg.irbDb||'';
        this.irbAutoLoad=cfg.irbAutoLoad||false;
        this.m_curoperation='C';
        this.m_autosearch=true;
        this.truncation=true;
        this.rqst=new Ext.form.TextArea
        ({
                name: 'query',
                height:20,
                layout:'fit',
                value:this.rqstdef
        });
        /*this.SearchButtonAvail=function()
        {
                this.SearchButton.setDisabled
                (!(
                        (this.dbmultyselect.fnGetVal()!='')&&
                        (this.rqst.getRawValue()!='')           
                ));     
        };*/
        this.toggleSType=function(btn,pressed)
        {
                if (pressed) this.m_curoperation=btn.irbOp;
        };
        this.toggleTrunc=function(btn,pressed)
        {
                this.truncation=pressed;
        };
        this.toggleAutoSearch=function(btn,pressed)
        {
                this.m_autosearch=pressed;
        };
        this.gosearch=function()
        {
         this.fireEvent('onSearchSelected',
         {
          irbDb:this.dbmultyselect.fnGetVal(),
          irbSearch:this.rqst.getRawValue()
         });
        };
        this.dotermselect=function (pref,term)
        {
                fterm="(\""+pref+term;
                if (this.truncation) fterm+='$';
                fterm+="\")";
                if ((this.m_curoperation=='C')||(this.rqst.getRawValue()==''))
                        this.rqst.setRawValue(fterm);
                else
                        this.rqst.setRawValue(this.rqst.getRawValue()+this.m_curoperation+fterm);
                //this.SearchButtonAvail();
                if (this.m_autosearch) this.gosearch();
        };
        //this.SearchButton=new Ext.Button({text:'Поиск',tooltip:'Начать поиск',handler:this.gosearch,scope:this}); 
        this.searchpanel=new Irbis.SearchPanel
        ({
                split:true,
                collapsible:true,
                rqst:this.rqst,
          //      SearchButton:this.SearchButton,
          //      SearchButtonAvail:false,//this.SearchButtonAvail,
                dotermselect:this.dotermselect,
                minSize: 250,
                margins:'0 0 0 5',
                region:'west',
                width:300,
                irbDb:this.selbds,
                irbAutoLoad:true
        });
        this.searchpanel.on('onTermSelected',function(opt){this.dotermselect(opt.pref,opt.term);},this);
        this.dbmultyselect=new Irbis.DbMultySelectTreePanel
        ({
                irbArm:cfg.irbArm,
                layout:'fit',
                //split:true,
                //height:100,
                title:'Выберите базы данных для поиска',
                localdata:cfg.localdata,
                autoScroll:true,
                //collapsible:true,
                region:'center'
        });
        this.dbmultyselect.on('onSelectionChange',function()
                        {
                                this.searchpanel.fnChangeDb(this.dbmultyselect.fnGetVal());
                                /*this.SearchButton.setDisabled
                                (!(
                                        (this.dbmultyselect.fnGetVal()!='')&&
                                        (this.rqst.getRawValue()!='')           
                                ));*/
                                if ((this.m_autosearch)/*&&(!this.SearchButton.disabled)*/) this.gosearch();
                        },this,{buffer:300});
        //this.SearchButtonAvail();
        cfg.layout='fit';
        cfg.standardSubmit=true;
        //cfg.renderTo='searchpanel';
        cfg.method='POST';
        cfg.items=
        [
                new Ext.Panel
                ({
                        layout:'border',
                        //buttons:[this.SearchButton],
                        items:
                        [
                                //new Ext.form.Hidden({name:'id',value:this.id}),
                                //new Ext.form.Hidden({name:'lf',value:this.lf}),
                                //new Ext.form.Hidden({name:'rc',value:this.rc}),
                                //new Ext.form.Hidden({name:'o',value:''}),
                                //new Ext.form.Hidden({name:'bases',value:''}),
                                //new Ext.form.Hidden({name:'fmt',value:'brief'}),
                                this.searchpanel,
                                {
                                        region:'center',
                                        split:true,
                                        layout:'border',
                                        items:
                                        [
                                                this.dbmultyselect,
                                                {
                                                        region:'north',
                                                        layout:'fit',
                                                        height:50,
                                                        split:true,
                                                        items:[this.rqst],
                                                        tbar:
                                                        [
                                                                {
                                                                        text:'Новый поиск',
                                                                        tooltip: 'Перейти к новому поиску при выборе поискового термина',
                                                                        iconCls:'irb-search',
                                                                        pressed: (this.curoperation==''),
                                                                        allowDepress:false,
                                                                        enableToggle:true,
                                                                        toggleGroup:'rp-group',
                                                                        toggleHandler:this.toggleSType,
                                                                        irbOp:'C',
                                                                        pressed:true,
                                                                        scope:this
                                                                },'-',{
                                                                        text:'И',
                                                                        tooltip: 'Уточнить поиск',
                                                                        pressed: (this.curoperation=='*'),
                                                                        allowDepress:false,
                                                                        enableToggle:true,
                                                                        toggleGroup:'rp-group',
                                                                        toggleHandler:this.toggleSType,
                                                                        irbOp:'*',
                                                                        scope:this
                                                                },{
                                                                        text:'ИЛИ',
                                                                        tooltip:'Расширить поиск',
                                                                        pressed: (this.curoperation=='+'),
                                                                        allowDepress:false,
                                                                        enableToggle:true,
                                                                        toggleGroup:'rp-group',
                                                                        toggleHandler:this.toggleSType,
                                                                        irbOp:'+',
                                                                        scope:this
                                                                },{
                                                                        text: 'И НЕ',
                                                                        tooltip:'Исключить из поиска',
                                                                        pressed: (this.curoperation=='^'),
                                                                        allowDepress:false,
                                                                        enableToggle:true,
                                                                        toggleGroup:'rp-group',
                                                                        toggleHandler:this.toggleSType,
                                                                        irbOp:'^',
                                                                        scope:this
                                                                },'-',{
                                                                        text: 'Усечение',
                                                                        tooltip:'Усекать термины справа',
                                                                        pressed: this.truncation,
                                                                        enableToggle:true,
                                                                        toggleHandler:this.toggleTrunc,
                                                                        pressed:true,
                                                                        scope:this
                                                                },'-',{
                                                                        text: 'Автопоиск',
                                                                        tooltip:'Искать записи сразу после добавления нового поискового термина',
                                                                        pressed: this.m_autosearch,
                                                                        enableToggle:true,
                                                                        toggleHandler:this.toggleAutoSearch,
                                                                        pressed:true,
                                                                        scope:this
                                                                }//,'-',new Ext.form.ComboBox({})
                                                        ]
                                                }
                                                
                                        ]
                                }
                        ]
                })
        ];
        this.dbmultyselect.fnSelects();
        Irbis.SearchPanelMulty.superclass.constructor.call(this,cfg);

};

Ext.extend(Irbis.SearchPanelMulty,Ext.form.FormPanel);
