﻿Irbis.R={version:Irbis.version};

Irbis.R.ARM=function(cfg)
{
 cfg=cfg||{};

 this.irbArm=cfg.arm;
 this.irbDb=cfg.irbDb;
 this.colcfg=cfg.colcfg;
 this.orgsigla=cfg.orgsigla;

 this.m_SearchPanel=new Irbis.SearchPanel
 ({
   irbDb:cfg.irbDb,
   colcfg:cfg.colcfg,
   hideComplex:true,
   height:200,
   title:this.searchPanelTitle,
   collapsible:true,
   titleCollapse:true,
   region:'west',
   split:true,
   width:320,
   listeners:
   {
    onTermSelected:function(opt)
    {
     if (opt.src=='')
      this.m_RecList.MakeSearch('("'+opt.pref+opt.term+'")','',this.colcfg);
     else
      this.m_RecList.MakeSearch(opt.src,'',this.colcfg);
    },
    scope:this
   }
 });

 this.currecid=cfg.currecid;

 this.ModalRequest=Irbis.ModalRequest;
 this.LongRequest=Irbis.LongRequest;

 this.m_RecList=new Irbis.RecListPanel128
 ({
   irbDb:cfg.irbDb,
   irbArm:cfg.arm,
   irbRec:cfg.currecid,
   title:'Результаты поиска',
   region:'center',
   split:true,
   showExportRecs:true,
   showPrintRecs:true,
   showAllRecs:true,
   showPft:true,
   basketName:'cat',
   tbar:[],
   listeners:
   {
    recdblclick:function(opt)
    {                                       
    },
    recselectionchange:function(opt)
    {
    },
    scope:this
   }
 });

 this.m_DbSelector=new Irbis.DbSelector
 ({
   arm:cfg.arm,
   xtype:'combo',
   allowBlank: false,
   editable: false,
   fieldLabel: 'БД',
   anchor: '100%',
   listeners:
   {
    select:function(combo,record,index)
    {
     this.changeDb(record.get('irbDb'),record.get('options'));
    },
    scope:this
   }
 });

 this.changeDb=function(irbDb,opt)
 {
  this.irbDb=irbDb;
  this.m_SearchPanel.fnChangeDb(irbDb);
  this.m_RecList.ChangeDb(irbDb);
 }

 cfg.layout='border';
 cfg.tbar=
 [
  'База данных:',this.m_DbSelector,
  '->',
  {
   iconCls:'irb-logout',
   text:'<b>Выход</b>',
   tooltip:'Завершить работу',
   handler: function()
   {
    Ext.Ajax.request
    ({
      url: '../R/Logout.php',
      failure: function(){Ext.Msg.alert("Ошибка","Ошибка связи!");},
      success: function(response)
      {
       resp=Ext.decode(response.responseText); 
       resp.Action();
      },
      irbArm:this.irbArm,
      params: { action: 'Logout',arm:this.irbArm}
    });
   },
   irbArm:cfg.arm
  }
 ];
 cfg.items=
 [
    this.m_SearchPanel,this.m_RecList
 ];

 this.m_pan=new Ext.Panel(cfg);
 Irbis.R.ARM.superclass.constructor.call(this,{region:'center',items:[this.m_pan],layout:'fit'});

 var task = {
  run: function()
  {
   Ext.Ajax.request
   ({
     url: '../R/r.php',
     params: { arm: cfg.arm, action:'Noop' }
   });
  },
  interval: 60000 //1 min
 };
 runner = new Ext.util.TaskRunner();
 runner.start(task);
}
Ext.extend(Irbis.R.ARM,Ext.Viewport,{
 searchPanelTitle:'Поиск'
});
