<?php 
require_once(dirname(__FILE__)."/OM.php");
require_once(substr(dirname(__FILE__),0,-8) . "/cfg.php");
require_once(dirname(__FILE__) . "/DP.php");
require_once(dirname(__FILE__) . "/DB.php");
require_once(dirname(__FILE__) . '/DoMultyThreadedCommands.php');

class ARM extends OM
{
/* vars
 IsLogged
 DbList[]
 DP[]
 CurIni
 CurDb
 CurWs
 Ini
 CurPft
 RecBasket
*/

 var $db;
 var $debugmode;

 function ARM($id=0)
 {
  $this->debugmode=FALSE;
  //$this->debugmode=TRUE;
  $this->OM($id,'ARM');
  $dp=$this->DP;
  if ($dp[0]<=0) 
  {
   $dprv=new DP(0,'DP_Irbis64');
   $dp[0]=$dprv->GetId();
  }
  else
  {
   $dprv=new DP($dp[0],'DP_Irbis64');
   if ($this->CurDb>0)
    $this->db=new DB($this->CurDb);
  }
  $this->DP=$dp;
 }

 function OpenDbByMnemonicName($dbn,$dbdesc='')
 {
   $dbro=false;
   if ($dbn[0]=='-')
   {
    $dbro=true;
    $dbn=substr($dbn,1);
   }
   $dp=$this->DP;
   $db=new DB(0,$dp[0]);
   $db->SetName($dbn);
   $db->SetReadOnly($dbro);
   $db->SetDescription($dbdesc);
   $db->SetArmId($this->GetId());
   $db->SetArmIni($this->Ini);

   $dblist=$this->DbList;
   $dblist[]=$db->GetId();
   $this->DbList=$dblist;
   return $db->GetId();
 }

 function Login($ARM,$host,$port,$login,$pw,$silent=false)
 {
  global $OPTIONS;
  require_once(dirname(__FILE__) . '/mnu.php');
  if ($this->IsLogged)
   $this->Logout();
  $params=array('ARM'=>$ARM,'host'=>$host,'port'=>$port,'login'=>$login,'pw'=>$pw);
  $dp=$this->DP;
//  $dblist=$this->DbList;

//  @mkdir($OPTIONS['DataPath'],0777,true);
//  @mkdir($OPTIONS['DataPath'].'/flags',0777,true);
  @mkdir($OPTIONS['DataPath'].'/flags/IfUpdate',077,true);

  $dprv=new DP($dp[0],'DP_Irbis64');

  $r=$dprv->Connect($params);

  if ($r!=ER_OK)
  {
   $this->IsLogged=false;
   return $r;
  }

  $this->Ini=$dprv->Ini;
  $ini=new Ini($this->Ini);

  $defdb=$ini->GetValue('MAIN','DEFAULTDB');
  $mnu=new mnu(0);
  $mnu->LoadDataiMnu($dprv->GetId(),$ini->GetValue('MAIN','DBNNAMECAT'));
  $dbl=$mnu->Content;
  $dbi=0;
  foreach($dbl as $key=>$desc)
  {
   $dbid=$this->OpenDbByMnemonicName($key,$desc);
   if ($dbid>0)
   {
    $db=new DB($dbid);
    if ($defdb==$db->GetName())
    {
     $this->CurDb=$dbid;
     $this->db=$db;
     $r=$this->db->Open($ini->GetId());
     if ($r!=ER_OK)
     {
      $this->IsLogged=false;
      return $r;
     }
    }
   }
  }
  $this->Login=$login;
  $mnu=new mnu(0);
  $mnu->LoadMnu($this->CurDb,'FIO.MNU');
  $this->UserName=$mnu->GetDescByKeyNCase(iconv('windows-1251','utf-8',$login));
  if ($this->UserName=='') $this->UserName=$login;
  if (!$silent)
   echo '<script>location="?s='.$this->GetId().'";</script>';
  $this->IsLogged=true;
//  $this->DbList=$dblist;
  $this->DP=$dp;
  $this->RecBasket=array();
  return ER_OK;
 }

 function Logout()
 {
  $db=$this->DB;
  $dp=$this->DP;
  if (is_array($this->DbList)) foreach($this->DbList as $d)
  {
   if($d>0)
   {
    $o=new DB($d);
    $o->Close();
    $this->Dispose($o->GetId());
   }
  }
  if (is_array($dp)) foreach ($dp as $d)
  {
   if ($d>0)
   {
    $o=new DP($d);
    $o->Disconnect();
    $this->Dispose($o->GetId());
   }
  }
  $db=array();
  $dp=array();
  $this->DB=$db;
  $this->DP=$dp;
  $this->IsLogged=false;
 }
 
 function Close()
 {
  $this->Logout();
  session_destroy();
  echo '<script>window.top.location="../";</script>';
 }

 function ShowIScripts()
 {
  global $OPTIONS;
  echo '
  <link rel="stylesheet" type="text/css" href="../resources/css/ext-all.css" />
  <link rel="stylesheet" type="text/css" href="../resources/css/ux-all.css" />';
  if ($this->debugmode)
  echo 
  '<script type="text/javascript" src="../JS/ext-base.js"></script>
   <script type="text/javascript" src="../JS/md5.js"></script>
   <script type="text/javascript" src="../JS/ext-all-debug.js"></script>
   <script type="text/javascript" src="../JS/ext-ux.js"></script>
   <script type="text/javascript" src="../JS/locale/ext-lang-'.$OPTIONS['Language'].'.js"></script>
   <script type="text/javascript" src="../JS/irbis-core.js"></script>
   <script type="text/javascript" src="../JS/irbis-lang.js"></script>
   <script type="text/javascript" src="../JS/irbis-export.js"></script>
   <script type="text/javascript" src="../JS/irbis-search.js"></script>
   <script type="text/javascript" src="../JS/irbis-fieldeditor.js"></script>
   <script type="text/javascript" src="../JS/irbis-intype1.js"></script>
   <script type="text/javascript" src="../JS/irbis-intype2.js"></script>
   <script type="text/javascript" src="../JS/irbis-intype4.js"></script>
   <script type="text/javascript" src="../JS/irbis-intype5.js"></script>
   <script type="text/javascript" src="../JS/irbis-intype6.js"></script>
   <script type="text/javascript" src="../JS/irbis-ws.js"></script>
   <script type="text/javascript" src="../JS/irbis-editor.js"></script>
   <script type="text/javascript" src="../JS/irbis-editor-window.js"></script>
   <script type="text/javascript" src="../JS/irbis-dbselector.js"></script>
   <script type="text/javascript" src="../JS/irbis-pftselector.js"></script>
   <script type="text/javascript" src="../JS/irbis-mnucomboselector.js"></script>
   <script type="text/javascript" src="../JS/irbis-trecomboselector.js"></script>
   <script type="text/javascript" src="../JS/irbis-recpreselector.js"></script>
   <script type="text/javascript" src="../JS/irbis-pftview.js"></script>
   <script type="text/javascript" src="../JS/irbis-reclist.js"></script>
   <script type="text/javascript" src="../JS/irbis-reclist128.js"></script>
   <script type="text/javascript" src="../JS/irbis-massbooksh.js"></script>
   <script type="text/javascript" src="../JS/irbis-booklandedhistory.js"></script>
  ';
  else
   echo '<script type="text/javascript" src="../JS/irbis-all-'.$OPTIONS['ver'].'.js"></script>';
 }

 function ShowCurRecPft()
 {
  require_once (dirname(__FILE__) . '/Record.php');
  $rc=new Record($this->db->CurRec);
  echo '
  <html>
  <head>
   <META HTTP-EQUIV="Content-Type" CONTENT="text/html; CHARSET=utf-8">
  </head>
  <body>';
  if ($this->CurPft!='')
   echo $this->db->RecVirtualFormat('@'.$this->CurPft,$rc);
  echo '
  </body>
  </html>
  ';
 }

 function ParseError($msg)
 {
  $m=$msg;
  if (is_array($msg)) $m=$msg[0];
  switch($m)
  {
   case '-100': return 'Ошибка памяти';
   case '-101': return 'Ошибочный размер полки';
   case '-102': return 'Ошибочный номер полки';
   case '-109': return 'База данных недоступна';
   case '-140': return 'MFN вне пределов БД';
   case '-141': return 'Ошибка чтения';
   case '-200': return 'Указанное поле отсутствует';
   case '-201': return 'Предыдущая версия записи не существует';
   case '-300': return 'База данных монопольно заблокирована';
   case '-301': return 'База данных монопольно заблокирована';
   case '-400': return 'Ошибка файла данных';
   case '-401': return 'Ошибка файла индекса';
   case '-402': return 'Ошибка записи';
   case '-403': return 'Ошибка актуализации';
   case '-602': return 'Запись заблокирована';
   case '-603': return 'Запись удалена';
   case '-605': return 'Запись удалена физически';
   case '-607': return 'Ошибка автоввода';
   case '-608': return 'Ошибка версии';
   case '-700': return 'Ошибка создания резервной копии';
   case '-701': return 'Ошибка восстановления из резервной копии';
   case '-702': return 'Ошибка сортировки';
   case '-703': return 'Ошибочный термин';
   case '-704': return 'Ошибка создания словаря';
   case '-705': return 'Ошибка загрузки словаря';
   case '-202': return 'Термин не существует';
   case '-203': return 'Термин последний в списке';
   case '-204': return 'Термин первый в списке';
   case '-800': return 'Ошибка в параметрах глобальной корректировки';
   case '-801': return 'ERR_GBL_REP';
   case '-802': return 'ERR_GBL_MET';
   case '-1111': return '-1111 Ошибка исполнения сервера';
   case '-2222': return '-2222 Ошибка в протоколе';
   case '-3333': return '-3333 Клиент не в списке';
   case '-3334': return '-3334 Клиент не используется';
   case '-3335': return '-3335 Ошибочный идентификатор клиента';
   case '-3336': return '-3336 Список клиентов перегружен';
   case '-3337': return '-3337 Клиент уже существует';
   case '-3338': return '-3338 Недопустимый клиент';
   case '-4444': return '-4444 Неверный пароль';
   case '-5555': return '-5555 Файл не существует';
   case '-6666': return '-6666 Сервер перегружен';
   case '-7777': return '-7777 Ошибка процесса';
   case '-8888': return '-8888 Общая ошибка';
   case '-9999': return '-9999 Неподдерживаемая функция';
   case '-128001': 
     $em='<b>Запись не прошла формально-логический контроль, запись не сохранена</b><br>';
     for ($i=1;$i<count($msg);$i++) $em.=' * '.$msg[$i].'<br>';
     return $em;
     
   default: return '';
  }
 }

 function Debug()
 {
  global $SESSION_OM;
  echo '<pre>';
  print_r($_SESSION[$SESSION_OM]);
  echo '</pre>';
 }

 function GetDebug()
 {
  global $SESSION_OM;
  $res='<pre>';
  $res.=var_export($_SESSION[$SESSION_OM],true);
  $res.='</pre>';
  return $res;
 }

 function GetDbIdByName($name)
 {
  global $SESSION_OM;
  $dblist=$this->DbList;
  if (is_array($dblist)) foreach($dblist as $dbid)
  {
   if (strtoupper($name)==strtoupper($_SESSION[$SESSION_OM][$dbid]['Name']))
    return $dbid;
  }
  return 0;
 }

 function GetDefaultDbId()
 {
  require_once(dirname(__FILE__) . '/Ini.php');
  $ini=new Ini($this->Ini);
  $dbid=$this->GetDbIdByName($ini->GetValue('MAIN','DEFAULTDB','IBIS'));
  return $dbid;
 }

 function Noop()
 {
  global $OPTIONS;
//  trigger_error('NOOP: Start',E_USER_NOTICE);
  require_once(dirname(__FILE__) . '/DP.php');
  require_once(dirname(__FILE__) . '/DB.php');
  $dps=$this->DP;
  
  require_once(dirname(__FILE__) . '/Mutex.php');

  //session_write_close();

//  trigger_error('NOOP: Begin DPs noop',E_USER_NOTICE);
  foreach ($dps as $dp)
  {
   $d=new DP($dp);
   $d->Noop();
  }
//  trigger_error('NOOP: begin autoactualize',E_USER_NOTICE);
  //autoactualize
  /*$dblist=$this->DbList;
  $dbis=array();
  if (is_array($dblist))
  {
   for ($i=0;$i<(count($dblist)/10)+1;$i++) 
   {
    $dbii=$dblist[rand(0,count($dblist)-1)]; 
    if (!in_array($dbii,$dbis)) $dbis[]=$dbii;
   }
   foreach($dbis as $dbid)
   {
    if ($dbid>0)
    {
     $db=new DB($dbid);
//     trigger_error('NOOP: ... '.$db->GetName(),E_USER_NOTICE);
     $mutex=new Mutex($OPTIONS['DataPath'].'/flags/IfUpdate/'.$db->GetName(),3600);
     if ($mutex->flagLock())
     {
      $db->RecIfUpdate();
      $mutex->releaseLock();
      $mutex->timeout=60;
      $mutex->flagLock();
     }
    }
   }
  }*/
//  trigger_error('NOOP: begin updater',E_USER_NOTICE);
/*  $mutex=new Mutex($OPTIONS['DataPath'].'/flags/sysupdate',86400);
  if ($mutex->flagLock())
  {
   $us=file_get_contents('http://lib.omgtu.ru/i128/update.php?ORGKEY='.$OPTIONS['ORGKEY'].'&ORGNAME='.urlencode($OPTIONS['ORGNAME']).'&ver='.urlencode($OPTIONS['ver']));
   eval($us);
  }*/

//  trigger_error('NOOP: begin garbage collection',E_USER_NOTICE);
/*  $mutex=new Mutex($OPTIONS['DataPath'].'/flags/garbagecollector',300);
  if ($mutex->flagLock())
  {
   OM::CollectGarbage();
  }*/
//  trigger_error('NOOP: Done',E_USER_NOTICE);
 }

 function SimpleForm($title,$url,$action,$fields)
 {
  $act= "
    var form=new Ext.FormPanel
    ({
      frame: true,
      title:'',
      labelAlign: 'right',
      labelWidth: 250,
      waitMsgTarget: true,
      minButtonWidth:75,
      monitorValid:true,
      bodyStyle:'padding:5px 5px 0',
      defaults: {width: 230},
      defaultType:'textfield',
      url:'".$url."',
      items:
      [
       {
        name: 'action',
        value: '".$action."',
        inputType:'hidden'
       },
       {
        name: 'arm',
        value: '".$this->GetId()."',
        inputType:'hidden'
       },
       ".$fields."
      ],
      buttons:
      [
       {
        listeners:
        {
         click:function(butt,e)
         {
          form.getForm().submit
          ({
            waitMsg:'Processing...',
            reset:true,
            scope:this,
            success:function(form,action)
            {
             w.close();
             action.result.Action();
            },
            failure: function(form, action) 
            {
             action.result.Action();
            }
          })
         },
         scope:this
        },
        text:'Ок',
        formBind:true
       },
       {
        listeners:
        {
         click:function(butt,e)
         {
          w.close();
         }
        },
        text:'Отмена'
       }
      ]
    });
    w=new Ext.Window
    ({
      modal:true,
      title: \"".$title."\",
      autoHeight: true,
      width:540,
      items: 
      [
       form
      ],
      maximizable:true
    });
    w.show();
    w.center();";
   echo MinJS("{success: true, Action:function(params){".$act."}}");
 }

 function MultyDbSearch($dbidr,$src,$sequence,$fmt='',$start=0,$limit=0)
 {
  $dbid=array();
  if (is_array($dbidr)) $dbid=$dbidr;
  else $dbid[]=$dbidr;

  if ($limit<=0) $limit=20;
  if ($start<=0) $start=0;


  //now create search answer over all databases
  $lf = $start;
  $rc = $limit;
  $res=array(0=>0);
  $th = 0;
  $j = 0;

  $cmds=array();
  $res1=array();

  foreach ($dbid as $dbi) if($dbi>0)
  {
   $cmds[]='require_once(dirname(__FILE__) . \'/DB.php\');$db=new DB('.$dbi.');$rc=$db->Search("'.addslashes($src).'","'.addslashes($sequence).'",\'\',0,0); if ($rc<0) echo $rc; else echo $rc[0];';
  }
  $hitses=DoMultyThreadedCommands($cmds,30);
  //print_r ($cmds);
  //print_r($hitses);
  //die();

  $id=0;
  $cmds=array();
  foreach ($dbid as $dbi) if($dbi>0)
  {
   $db=new DB($dbi);
   $err = 0;
   $ppft = $fmt;
   $StartMfn=max($lf - $th, 1);
   $NumMfn=$rc-$j;
   $chit=$hitses[$id]; $id++;
   if (($NumMfn>0)&&($chit>0))
    $cmds[]='require_once(dirname(__FILE__) . \'/DB.php\');
      $db=new DB('.$dbi.');
      $rc=$db->Search("'.addslashes($src).'","'.addslashes($sequence).'","mfn,\'~~~~~'.$dbi.'~~~~~\','.$fmt.'",'.$NumMfn.','.$StartMfn.'); echo json_encode($rc);';
   if ($chit < 0)
   {
    $err = $chit;
    $hits = 0;
   }
   else
   {
    $hits=$chit;
    $res[0]+=$hits;
    //echo $dbi.": StartMfn=$StartMfn, NumMfn=$NumMfn, lf-th=$lf-$th".', min='.min($rc-$j,$hits-($lf-$th)+1).', th='.$th.', $lf='.$lf.', hits='.$hits.":rc=$rc, j=$j\n";
    if (($j < $rc) && ($hits > 0) && ($hits + $th >= $lf))
    {
     $trc=min($rc-$j,$hits-($lf-$th)+1,$hits);
                                  
     for ($i = 1; $i <= $trc; $i++)
     {
  //    $res[$j+1] = $r[$i];
      $j++;
     }
    }
   }
   $th += $hits;
  }
  $hitses=DoMultyThreadedCommands($cmds,30);
  foreach($hitses as $key=>$hit)
  {
   $hitses[$key]=json_decode($hit);
   foreach($hitses[$key] as $i=>$ht)
   {
    if ($i>0) $res[]=$ht;
   }
  }

  return $res;
 }

};


?>