<?php 
require_once (dirname(__FILE__) . "/OM.php");
require_once (dirname(__FILE__) . "/Record.php");

//define('DPC_RECREAD', 1);

class DB extends OM
{
	// var $Provider;
	// var $Name;
	// var Description
	// var IsRO
	// WsOpt
	// PftOpt
	// CurRec
	// IsOpen
	// FmtMnu // id(mnu) -  WS
	// ini
	// ARM // arm id
        // TemporaryUnaval

	var $dprv;

	function DB($id, $Provider = 0)
	{
		require_once (dirname(__FILE__) . "/DP.php");
		$this->OM($id, 'DB');
		if ($this->Ini <= 0) $this->Ini = 0;
		if ($this->Provider==0) $this->Provider = $Provider;
		$this->SetProvider($this->Provider);
		$this->SetError(ER_OK);
		if ($id > 0)
		{
			$this->dprv = new DP($this->Provider);
		}
		else
		{

		}
		
	}

	function GetName()
	{
		return $this->Name;
	}

	function SetName($name)
	{
		$this->Name = $name;
	}

	function GetDescription()
	{
		return $this->Description;
	}

	function SetDescription($desc)
	{
		$this->Description = $desc;
	}

	function IsReadOnly()
	{
		return $this->IsRO;
	}

	function SetReadOnly($IsRo = true)
	{
		$this->IsRO = $IsRo;
		return $this->IsReadOnly();
	}

	function SetProvider($pn)
	{
		$this->dprv = new DP($pn);
		$this->Provider = $pn;
		return $this->SetError(ER_OK);
	}

	function SetArmIni($iniid)
	{
		$this->ArmIni = $iniid;
	}

	function GetProvider()
	{
		return $this->dprv->GetId();
	}

        function GetIniValue($sect,$key,$defval)
        {
	 require_once (dirname(__FILE__) . "/Ini.php");
	 $ini = new Ini($this->Ini);
	 return $ini->GetValue($sect,$key,$defval);
        }

        function SetOrgGuid(Record $r)
        {
         $guid=$this->GetIniValue('MAIN','ORGGUID','');
         if ($guid!='')
         {
          $r->FieldAdd(113,'^AORGGUID^B'.$guid);
         }
        }
        
        function RemoveOrgGuid(Record $r)
        {
         $guid=$this->GetIniValue('MAIN','ORGGUID','');
         if ($guid!='')
         {
          $f133occ=$r->GetFieldOcc(113);
          for ($i=1;$i<=$f113occ;$i++)
          {
           if ($r->GetSubField(113,$i,'A')=='ORGGUID')
           {
            if ($r->GetSubField(113,$i,'B')==$guid)
            {
             $r->FieldDelete(113,$i);
             $f113occ--;
             $i--;
            }
           }
          }
         }
        }

        function SetUnaval($errcode)
        {
         if (time()>$this->TemporaryUnavail)
         {
          $this->TemporaryUnavailLen=$this->TemporaryUnavailLen*2;
          $this->TemporaryUnavail=time()+$this->TemporaryUnavailLen;
          trigger_error('Set database '.$this->GetName().' to unavailable state ('.$this->TemporaryUnavailLen.'). Error code = '.$errcode,E_USER_NOTICE);
         }
        }

        function IsUnavail()
        {
         //return FALSE;
         $res=($this->TemporaryUnavail>time());
         if (!$res) $this->TemporaryUnavailLen=1;
         return $res;
        }

        function CheckUnavail($errcode)
        {
         if (
             ($errcode>=0) || 
             ($errcode==-9999) || 
             ($errcode==-602) || 
             ($errcode==-607) || 
             ($errcode==-608)
            )
         {
          $this->TemporaryUnavailLen=1;
          return;
         }
         else $this->SetUnaval($errcode);
        }

	function Open($iniid)
	{
	        if ($this->IsUnavail()) return -109;
		if ($this->IsOpen) $this->Close();
		require_once (dirname(__FILE__) . "/opt.php");
		require_once (dirname(__FILE__) . "/Ini.php");
		require_once (dirname(__FILE__) . "/mnu.php");
		require_once (dirname(__FILE__) . "/ARM.php");
		$armid=$this->GetArmId();
		$arm=new ARM($armid);
		$ini = new Ini(0);
		if ($this->Ini > 0) $ini->Dispose($this->Ini);
		$this->Ini = $ini->GetId();
		$ini->InitSharedVar('Content','UI/'.$arm->Login.'/'.$this->Name.'.ini');
		if ($ini->Content===NULL)
		{
 		 $tini = new Ini(0);
		 $mini = new Ini($iniid);
		 $tini->Load($this->GetId(), $this->Name);
		 $ini->Content = $mini->Content;
		 $ini->ApplyIni($tini->GetId());
		 $tini->Dispose($tini->GetId());
		}
		$wsopt = new opt(0);
		$this->WsOpt = $wsopt->GetId();
		$wsopt->LoadOpt($this->GetId(), $ini->GetValue('MAIN', 'WSOPT','WS31.OPT'));
		$pftopt = new opt(0);
		$this->PftOpt = $pftopt->GetId();
		$pftopt->LoadOpt($this->GetId(), $ini->GetValue('MAIN', 'PFTOPT','PFTw.OPT'));
		$FmtMnu = new mnu(0);
		$FmtMnu->LoadMnu($this->GetId(), $ini->GetValue('MAIN', 'FMTMNU'));
		$this->FmtMnu = $FmtMnu->GetId();
		//now recheck dataprovider
		if (($ini->GetValue('PROVIDER', 'TYPE', 'Local') != 'Local') && ($this->dprv->
			ProviderType == 'DP_Irbis64'))
		{
			$this->dprv = new DP(0, 'DP_'.$ini->GetValue('PROVIDER', 'TYPE'), $this->dprv->
				GetId());
			$this->Provider = $this->dprv->GetId();
			$pars['Ini'] = $ini;
			$pars['dbid']=$this->GetId();
			$res=$this->dprv->Connect($pars);
			if ($res<0) 
			{
			 $this->CheckUnavail($res);
 			 return $this->SetError($res);
 			}
		}
		$this->IsOpen = true;
		$this->ArmIni = $iniid;
		$this->CheckUnavail(0);
		return $this->SetError(ER_OK);
	}

	function Close()
	{
		if ($this->IsOpen)
		{
			if ($this->CurRec > 0)
			{
				$this->Dispose($this->CurRec);
				$this->CurRec = 0;
			}
		}
	}

	function GetFile($path, $name)
	{
	        if ($this->IsUnavail()) return -109;
		//  if (!$this->IsOpen) $errc=$this->Open($this->ArmIni); if ($errc!=ER_OK) return $errc;
		return $this->dprv->GetFile($path, $this->Name, $name);
	}

	function RecIfUpdate($mfn = 0)
	{
	        if ($this->IsUnavail()) return -109;
	        $errc=ER_OK;
		if (!$this->IsOpen) $errc = $this->Open($this->ArmIni);
		if ($errc != ER_OK) return $errc;
		require_once (dirname(__FILE__) . "/DP.php");
		$dp = new DP($this->Provider);
		$res=$dp->RecIfUpdate($this->Name, $mfn);
		$this->CheckUnavail($res);
		return $res;
	}

	function SetDbNamesLabel(Record $r)
	{
	 $name=$this->Name;
	 $dnames=$r->DbNames;
	 if (!is_array($dnames)) $dnames=array(0=>$name);
	 else if (!in_array($name,$dnames)) $dnames[]=$name;
	 $r->DbNames=$dnames;
	}

	function RecRead($mfn, $lock, Record $r)
	{ //  id  (>0)   (<0)
	        if ($this->IsUnavail()) return -109;
		if (!$this->IsOpen) $errc = $this->Open($this->ArmIni);
		if ($errc != ER_OK) return $errc;
		require_once (dirname(__FILE__) . "/Record.php");
		require_once (dirname(__FILE__) . "/DP.php");
		$dp = new DP($this->Provider);
		$res=$dp->RecRead($this->Name, $mfn, false,$r);
		$this->SetDbNamesLabel($r);
		$this->CheckUnavail($res);
		//trigger_error('DB:RecRead: '.var_export($r->Version,true),E_USER_NOTICE);
		$this->SetOrgGuid($r);
		return $res;
	}

	function RecVirtualFormat($Format, Record $VirtualRecord)
	{
	        if ($this->IsUnavail()) return -109;
		if (!$this->IsOpen) $errc = $this->Open($this->ArmIni);
		if ($errc != ER_OK) return $errc;
		$res=$this->dprv->RecVirtualFormat($this->Name, $Format, $VirtualRecord);
		$this->CheckUnavail($res);
		return $res;
	}

	function GetMaxMfn()
	{
	        if ($this->IsUnavail()) return -109;
		if (!$this->IsOpen) $errc = $this->Open($this->ArmIni);
		if ($errc != ER_OK) return $errc;
		$res=$this->dprv->GetMaxMfn($this->Name);
		$this->CheckUnavail($res);
		return $res;
	}

	function RecReadAndFormat($mfn, $bLock, $Format)
	{
	        if ($this->IsUnavail()) return -109;
		if (!$this->IsOpen) $errc = $this->Open($this->ArmIni);
		if ($errc != ER_OK) return $errc;
		$res=$this->dprv->RecReadAndFormat($this->Name, $mfn, $bLock, $Format);
		$this->CheckUnavail($res);
		return $res;
	}

	function GetTermList($Pref, $StartTerm, $NumTerms = 20, $isb = 0, $format = '')
	{
	        if ($this->IsUnavail()) return -109;
	        //trigger_error(var_export($this,true),E_USER_NOTICE);
		if (!$this->IsOpen) $errc = $this->Open($this->ArmIni);
		if ($errc != ER_OK) return $errc;
		
		$ini = new Ini($this->Ini);
		
		$res=$this->dprv->GetTermList($this->Name, $Pref, $StartTerm, $NumTerms, $isb, $format);
		$this->CheckUnavail($res);
		//trigger_error(var_export($res,true),E_USER_NOTICE);
		return $res;
	}


	function Search($Expression, $Sequence = '', $Format = '', $NumMfn = 0, $FirstMfn =
		0, $Min = 0, $Max = 0)
	{
	        if ($this->IsUnavail()) return -109;
	        $errc=ER_OK;
		if (!$this->IsOpen) $errc = $this->Open($this->ArmIni);
		if ($errc != ER_OK) return $errc;
		$res=$this->dprv->Search($this->Name, $Expression, $Sequence, $Format, $NumMfn,
			$FirstMfn, $Min, $Max);
		$this->CheckUnavail($res);
		//trigger_error(var_export($res,true),E_USER_NOTICE);
		return $res;
	}

	function SaveAndUpdateRecord(Record $rec, $bgupdate = false)
	{
	        if ($this->IsUnavail()) return -109;
	        $errc=ER_OK;
		if (!$this->IsOpen) $errc = $this->Open($this->ArmIni);
		if ($errc != ER_OK) return $errc;
		$this->RemoveOrgGuid($rec);

		$t=$rec->EditorLoader_wc;
                if (is_array($t)) foreach ($t as $tabno=>$tabinfo) if (is_array($tabinfo))
                {
                 $t1=$tabinfo['tabinfo'];
                 if(is_array($t1)) foreach ($t1 as $fn=>$fd) if (($fn!='fldcount')&&($fn!='ee'))
                 {
                  if ($fd['default']!='')
                  {
                   $sfs=$rec->ParseField($fd['default']);
                   if (is_array($sfs)) foreach($sfs as $csf=>$csfdata)
                   {
                    if ($rec->GetSubField($fn,1,$csf)=='') $rec->SetSubField($fn,1,$csf,$csfdata);
                   }
                  }
                 }
                }
                $dbnflc=$this->Format128($rec, 'dbnflc');
                if ($dbnflc[0]!=0) { $dbnflc[0]=-128001; return $dbnflc; }

		$res=$this->dprv->RecWrite($this->Name, false, !$bgupdate, $rec);
		$this->CheckUnavail($res);
		$this->SetDbNamesLabel($rec);
		//trigger_error(var_export($res,true),E_USER_NOTICE);
		return $res;
	}


	function GetArmId()
	{
		return $this->ARM;
	}

	function SetArmId($armid)
	{
		$this->ARM = $armid;
	}

    function ForEachRecord(&$class,$func,$Src,$Posl='',$portion=500,$startres='',$recstart=0,$reccount=0)
    {
     set_time_limit(36000);
     $fres=array('action'=>'none','res'=>$startres);
     $recs=$this->FindRecords($Src,$Posl);
     //echo $this->rDump().': '.$Src.'<hr><pre>';print_r($recs);echo'</pre>';
     if (!is_array($recs)) return $recs;
     if ($recs[0]<0) return $recs[0];
     $reccnt=$recs[0];
     if ($reccount>0) $o['cnt']=min($reccnt,$recstart+$reccount);
     //echo $reccnt;
     for ($i=0;$i*$portion<$reccnt;$i++)
     {
      if (($recstart>0)&&((($i+1)*$portion)<$recstart)) { continue; }
      $recs=array();
      //echo "$Src, $Posl, $portion, ".($i*$portion+1);
      //echo $this->GetName();
      $recs=$this->FindRecords($Src,$Posl,$portion,$i*$portion+1);
      //print_r($recs);
      if (!is_array($recs)) return $recs;
      if ($recs[0]<0) return $recs[0];
      for ($j=1;$j<count($recs);$j++)
      {
       if (($recstart>0)&&(($i*$portion+$j)<$recstart)) { continue;}
       $fres=$class->$func($this,$recs[$j],$fres['res']);
       switch($fres['action'])
       {
        case 'none': break;
        case 'save': $this->SaveAndUpdateRecord($recs[$j]); break;
        case 'fatal': $this->FindRecordsClearResult($recs); return $fres['res']; break;
        default: break;
       }
      }
      $this->FindRecordsClearResult($recs);
     }
     return $fres['res'];
    }

	function FindRecordsAndDo(&$obj,$func,$Expression, $Sequence = '', $NumMfn = 0, $FirstMfn = 0, $Min =
		0, $Max = 0)
	{
	 if ($this->IsUnavail()) return array('errcode'=>-109);
	 $res=array('errcode'=>0);
	 $recs=$this->FindRecords($Expression, $Sequence, $NumMfn, $FirstMfn, $Min, $Max);
	 if (!is_array($recs)) return array('errcode'=>$recs);
	 if ($recs[0]<0) return array('errcode'=>$recs[0]);
	 if ($recs[0]==0) return array('errcode'=>0,'rescount'=>0);
	 $res['rescount']=$recs[0];
//	 print_r($recs);
	 for ($i=1; $i<count($recs); $i++)
	 {
	  $r=$recs[$i];
	  $res['resar'][]=$obj->$func($res,$r,$recs,$i);
	 }
	 $this->FindRecordsClearResult($recs);
	 return $res;
	}

	function FindRecordsSortResult($recs,$SortClass,$SortFunc,$AscSortDir=TRUE)
	{
	 if (($SortClass===NULL)||($SortFunc='')) return $recs;
	 if (!method_exists($SortClass,$SortFunc)) return $recs;
	 return usort($recs,array(get_class($SortClass),$SortFunc));
	}

	function FindRecords($Expression, $Sequence = '', $NumMfn = 0, $FirstMfn = 0, $Min =0, $Max = 0,$SortClass=NULL,$SortFunc='',$AscSortDir=TRUE)
	{
         if ($this->IsUnavail()) return -109;
         $errc=ER_OK;
 	 if (!$this->IsOpen) $errc = $this->Open($this->ArmIni);
	 if ($errc != ER_OK) return $errc;
	 //echo $Expression.' - '.$Sequence.' - '.$FirstMfn.' - '.$NumMfn.' - '.$Min.' - '.$Max."\n";
	 $res=$this->dprv->RecSearch($this->Name, $Expression, $Sequence, $NumMfn, $FirstMfn);
	 if (is_array($res)) for ($i=1;$i<count($res);$i++)
	  $this->SetDbNamesLabel($res[$i]);
	 //print_r($res);
	 //print_r($this->dprv);
	 return $res;
/*		$r = $this->Search($Expression, $Sequence, "&uf('+0')", $NumMfn, $FirstMfn, $Min,
			$Max);
		if (!is_array($r)) return array(0=>$r);
		if ($r[0] < 1) return array(0=>$r[0]);
		$res = array(0=>0);
		foreach ($r as $key => $m)
		{
			if ($key == 0) $res[0] = $m;
			else
			{
				if ($m != '')
				{
					$rr = new Record(0);
					$rr->ParseIrbisRec($m);
					//trigger_error('parsed mfn:'.var_export($rr->GetMfn(),true),E_USER_NOTICE);
					//$rr->DEBUG=debug_backtrace();
					$this->SetOrgGuid($rr);
 					$res[] = $rr;
				}
			}
		}
		return $res;*/
	}

	function FindRecordsClearResult($res)
	{
		if (is_array($res))
		{
			for ($i = 1; $i < count($res); $i++)
			{
			 if ($res[$i]!==NULL)
			 {
 			  if ($res[$i]->GetType()=='Record')
			   $res[$i]->Dispose($res[$i]->GetId());
			  else trigger_error('REMOVE NOT RECORD:'.var_export($res[$i]->rDump(),true),E_USER_NOTICE);
			 }
			}
		}
	}

	function FindRecordsGroupBy($recs,$pft128name,$pft128class='',$pft128params=array())
	{
	 $res=array();
	 if ((!is_array($recs)) || ($recs[0]<0)) return NULL;
	 for ($i=1;$i<=$recs[0];$i++)
	 {
	  $fmtres=$this->Format128($recs[$i], $pft128name, $pft128class,$pft128params);
	  $res[$fmtres][0]++;
	  $res[$fmtres][]=$recs[$i];
	 }
	 return $res;
	}

	static function FindRecordsSortBy_sort($a,$b)
	{
	 if ($a->SortString>$b->SortString) return 1;
	 if ($a->SortString<$b->SortString) return -1;
	 return 0;
	}

	function FindRecordsSortBy($recs,$pft128name,$pft128class='',$pft128params=array())
	{
	 if ((!is_array($recs)) || ($recs[0]<0)) return $recs;
	 for ($i=1;$i<=$recs[0];$i++) $recs[$i]->SortString=$this->Format128($recs[$i], $pft128name, $pft128class,$pft128params);
	 usort($recs,'DB::FindRecordsSortBy_sort');
	 return $recs;
	}

	function GetMnu($path,$name,$mnuid=0)
	{
	 if ($this->IsUnavail()) return -109;
         require_once (dirname(__FILE__) . "/mnu.php");
	 $mnu = new mnu($mnuid);
 	 $pn = $mnu->ParseMnuLink($name);
	 $r = $this->GetFile($path, $pn['name']);
	 $r = iconv('windows-1251', 'utf-8', $r);
	 if ($r < 0) return $r;
	 if ($r == '')
	 {
	  $mnu->Content = array();
	  return $mnu;
	 }
        
	 $mnu->ParseMnu($r);

	 if ($pn['sorttype'] == 0) $mnu->SortByKey();
	 else  $mnu->SortByDesc();
	 return $mnu;
	}
	
	function GetMnuDescByKey($path,$name, $key)
	{
		$mnu = $this->GetMnu($path, $name,0);
		$res=$mnu->GetDescByKey($key);
		$mnu->Dispose($mnu->GetId());
		return $res;
	}

	function DoFLC(Record $r,$flcname='')
	{
	 /*
	     
	   array
	   (
	    'retCode'=>max return code (0-ok,1-warn,2-error)
	    'msgs'=>array
	    (
	            0=>array
  	 	   (
		     'code'=> error code
		     'msg'=>error message
		   )
	    )
	   )
	   example:
	   array('retCode'=>1,'msgs'=>array(0=>array('code'=>0,'msg'=>'ok'),1=>array('code'=>1,'msg'=>'warning')))
	 */
	 if ($flcname=='')
	  $flcname=$this->GetIniValue('ENTRY','DBNFLC','DBNFLC');
	 if ($flcname=='')
	  return array('retCode'=>0,'msgs'=>array());
	 $pres=$this->RecVirtualFormat("&uf('6".$flcname."')",$r);
//	 trigger_error('DoFLC: '.var_export($pres,true),E_USER_NOTICE);
	 if ($pres<0)
	 {
	  return array
	  (
	   'retCode'=>($pres+0),
	   'msgs'=>array
	   (
	    0=>array
	    (
	     'code'=>$pres+0,
	     'msg'=>ARM::ParseError($pres+0)
	    )
	   )
	  );
	 }
	 $res['retCode']=0;
	 $res['msgs']=array();
	 $rres=explode("\n",$pres);
	 if (is_array($rres)) foreach($rres as $str)
	 {
	  $tstr=trim($str);
	  if ($tstr!='')
	  {
	   $c=$tstr{0};
	   $cres['code']=0;
	   $cres['msg']='';
	   if (($c=='0')||($c=='1')||($c=='2'))
	   {
	    $tstr=trim(substr($tstr,1));
	   }
	   else
	    $c=0;
	   $cres['code']=$c;
	   $cres['msg']=$tstr;
	   $res['msgs'][]=$cres;
	   if (($c<0) || ($c>$res['retCode'])) $res['retCode']=$c;
	  }
	 }
	 
	 return $res;
	}

	function DeleteRec($mfn)
	{
	 if ($this->IsUnavail()) return -109;
	 $res=$this->dprv->DeleteRec($this->Name,$mfn);
	 $this->CheckUnavail($res);
 	 return $res;
	}

	function Format128(Record $r, $fmtname, $fmtcontainer='',$params=array())
	{
	 require_once (dirname(__FILE__) . "/format128.php");
	 $fmt=new Format128;
	 return $fmt->Fmt($this, $r, $fmtname, $fmtcontainer, $params);
	}
}
?>