<?php 
require_once (dirname(__FILE__)."/OM.php");
require_once(dirname(__FILE__) . '/Record.php');
require_once(dirname(__FILE__) . '/DummyDP.php');

if (!defined('APATH_SYS')) define('APATH_SYS', 0);
if (!defined('APATH_DATAI')) define('APATH_DATAI', 1);
if (!defined('APATH_MST')) define('APATH_MST', 2);
if (!defined('APATH_IF')) define('APATH_IF', 3);
if (!defined('APATH_DB')) define('APATH_DB', 10);


/*

mst entry: array
(
 '_id'=>string (mfn),
 'object'=>mixed,
 'keys'=>array of arrays
 (
  'key'=>string,
  'field'=>string,
  'occ'=>string,
  'cnt'=>string
 )
)

*/


class DP_Mongo extends DummyDP
{
 // var opid; // Owner provider id
 // var $cmdno;
 // var $m_cARM;
 // var $sId;
 // var $address;
 // var $port;
 // var $login;
 // var $pw;
 // var IsConnected;

 var $mongo;

 function __construct($id=0)
 {       
  try
  {
   $this->DummyDP($id, 'DP_Mongo');
   $this->mongo['conn'] = new Mongo('localhost');
   $this->mongo['db'] = $this->mongo['conn']->ibis128;
  }
  catch (MongoConnectionException $e) 
  {
   trigger_error('Error connecting to MongoDB server',E_USER_NOTICE);
  } 
  catch (MongoException $e) 
  {
   trigger_error('Error: ' . $e->getMessage(),E_USER_NOTICE);
  }
 }


 function __destruct()
 {
  $conn=$this->mongo['conn'];
  $conn->close();
 }

 function InitDb($dbname)
 {
  try
  {
   $this->mongo['mst'] = $this->mongo['db']->$dbname;
   $this->mongo['mst']->ensureIndex('keys.key');
   //$keys=array();
   //$keys[]=array('key'=>'I=456','field'=>903,'occ'=>1,'cnt'=>1);
   //$item=array('content'=>array(903=>array(0=>array('*'=>'456'))),'keys'=>$keys);
   //$this->mongo['mst']->insert($item);
  }
  catch (MongoConnectionException $e) 
  {
   trigger_error('Error connecting to MongoDB server',E_USER_NOTICE);
  } 
  catch (MongoException $e) 
  {
   trigger_error('Error: ' . $e->getMessage(),E_USER_NOTICE);
  }
 }

 function SetOwnerProvider($id)
 {
  $this->odpi = $id;
 }

 function Connect($params)
 {
  $this->SetOwnerDb($params['dbid']);
  return 0;
 }

 function Disconnect()
 {
  return 0;
 }

 function GetFile($nApath, $sAdbn, $FileName)
 {
  $odp=new DP($this->odpi);
  return $odp->GetFile($nApath,$sAdbn,$FileName);
 }
 
 function GetFormattedRecordsAfterSearch($DbName, $Expression, $Format, $NumRecords =
 	0, $FirstRecord = 0, $Min = 0, $Max = 0, $Sequence = '')
 {
  return -9999; //NA
 }

 function GetMaxMfn($DbName)
 {
  return -9999; // NA
 }

 function NoOperation()
 {
  return 0;
 }

 function RecIfUpdate($DbName, $mfn)
 {
  return 0;
 }

 function RecRead($DbName, $mfn, $bLock,Record $rec)
 {
  $this->InitDb($DbName);
  $mst=$this->mongo['mst'];
  $mr=$mst->findOne(array('_id' => new MongoId($mfn)));
  if ($mr===NULL) return -140; // mfn out of range
  $rec->SetContentA($mr['content']);
  $rec->SetMfn($mr['_id'].'');
  return 0;
 }

 function RecReadAndFormat($DbName, $mfn, $bLock, $Format)
 {
  $r=new Record(0);
  $this->RecRead($DbName, $mfn, $bLock,$r);
  $res=$this->RecVirtualFormat($DbName, $Format, $r);
  $r->Dispose();
  return $res;
 }

 function RecVirtualFormat($DbName, $Format, Record $VirtualRecord)
 {
  $odp=new DP($this->odpi);
  return $odp->RecVirtualFormat($DbName, $Format, $VirtualRecord);
 }

 function RecWrite($DbName, $bLock, $bIfUpdate, Record $r)
 {
  $this->InitDb($DbName);
  echo $DbName.'~';
  $mfn=$r->GetMfn();
  $mst=$this->mongo['mst'];
  $keys=array();
  if ($bIfUpdate)
  {
   $keys[]=array('key'=>'I='.$r->GetSubField(903,1,'*'),'field'=>'903','occ'=>1,'cnt'=>1);
  }
  $item=array('content'=>$r->GetContentA(),'keys'=>$keys);
  if (($mfn!='') && ($mfn!=-1))
  {
   $item['_id']=new MongoId($mfn);
  }
  $r1=$mst->insert($item,array('safe'=>true));
  echo 'res: ';print_r($r1);
  $r->SetMfn($item['_id'].'');
  return $r->GetId();
 }

 /**
  *   <0   
  *  ,    -  ,
  *  0 - -  
  */
 function Search($DbName, $Expression, $Sequence, $Format, $NumMfn = 0, $FirstMfn =0, $Min = 0, $Max = 0)
 {
  echo $Format;
  $this->InitDb($DbName);
  $recs=$this->RecSearch($DbName, $Expression, $Sequence, $NumMfn, $FirstMfn);
  $res=array(0=>$recs[0]);
  $db=new DB($this->odbi);
  for ($i=1;$i<count($recs);$i++)
  {
   $res[]=$db->Format128($recs[$i], $Format);
  }
  $db->FindRecordsClearResult($recs);
  //print_r($res);
  return $res;
 }

 /**
  *   <0   
  *  ,    - ,
  *  0 - -  
  */
 function RecSearch($DbName, $Expression, $Sequence, $NumMfn = 0, $FirstMfn = 0)
 {
  //echo $DbName.' - '.$Expression.' - '.$Sequence.' - '.$NumMfn.' - '.$FirstMfn;

  $this->InitDb($DbName);
  $c=new IrbisToMongoSearch($Expression);
  $src=$c->Exec();
  $mst=$this->mongo['mst'];
  //$cursor=$mst->find($src);
  $cursor=$mst->find();
  //print_r($cursor);
  $res=array(0=>$cursor->count());
  
  if ( ($FirstMfn==0) && ($NumMfn==0)) return $res;
  if ($FirstMfn>1) $cursor=$cursor->skip($FirstMfn-1);
  if ($NumMfn>1) $cursor=$cursor->limit($NumMfn);
  foreach ($cursor as $doc) 
  {
   $r=new Record(0);
   $r->SetContentA($doc['content']);
   $r->SetMfn($doc['_id'].'');
   $r->SetSubField(920,1,'*','PAZK');
   $res[]=$r;
  }
  return $res;
 }

 function FullTextSearch($DbName,$FTExpression,$Expression,$Sequence,$FTSPrefix,$MaxWordDistance=-1,$Morphology=FALSE,$NumMfn=0,$FirstMfn=0,$Min=0,$Max=0)
 {
  return -9999;
 }

 function WriteToIni($IniText)
 {
  return -9999; // NA;
 }

 function GetTermList($DbName, $Pref, $StartTerm, $NumTerms, $isback = 0, $format ='')
 {
  //return array('errorcode'=>-999);
  return array();
 }

 function Noop()
 {
  return 0;
 }

 function SetOwnerDb($id)
 {
  $this->odbi=$id;
 }

 function DeleteRec($DbName,$mfn)
 {
  $this->InitDb($DbName);
  $mst=$this->mongo['mst'];
  $id=new MongoId($mfn);

  $mst->remove(array('_id'=>$id),array('safe'=>true));
  return 0;
 }


};

//***************************** Search *****************************************

class IrbisToMongoSearch
{
 var $searchstr;
 var $spos;
 var $logeof;
 var $lex;
 var $curlex;
 var $mas; //     
 var $oper; //  

 function __construct($search='',$parse=true)
 {
  $this->searchstr='';
  if ($search!='')
  {
   $this->SetSearch($search);
   if ($parse) $this->ParseSearch();
  }
 }

 function __destruct()
 {
 }

 private function logeof() //
 {
  return $this->spos>=$this->slen;
 }

 private function getch() //
 {
  $ch=$this->searchstr{$this->spos};
  $this->spos++;
  return $ch;
 }

 private function scantext() //
 {
  $ch=$this->getch();
  if ($ch!='"') return FALSE;
  if ($this->logeof()) return FALSE;
  $ch=$this->getch();
  $str='';
  while ((!$this->logeof())&&($ch!='"'))
  {
   if ($ch=="\\") {if ($this->searchstr{$this->spos}=='"') $str.=$this->getch();}
   else $str.=$ch;
   $ch=$this->getch();
  }
  if (($this->logeof())&&($ch!='"')) return FALSE;
  $this->lex[]=array('type'=>'T','val'=>$str);
  return TRUE;
 }

 private function scanword() //
 {
  $ch=$this->getch();
  if ($this->logeof()) return FALSE;
  $this->spos--;
  $ch=$this->getch();
  $str='';
  while ((!$this->logeof())&&($ch!=' ')&&($ch!='*')&&($ch!='+')&&($ch!='^'))
  {
   $str.=$ch;
   $ch=$this->getch();
  }
  $this->lex[]=array('type'=>'T','val'=>$str);
  return TRUE;
 }

 private function Scan() //
 {//  
  while((!$this->logeof())&&($this->searchstr{$this->spos}==' ')) $this->spos++;
  if ($this->logeof()) return TRUE;
  while (!$this->logeof())
  {
   $ch=$this->searchstr{$this->spos};
   if (($ch=='(') && (($this->slen-$this->spos)>=3) && ($this->searchstr{$this->spos+1}=='F') && ($this->searchstr{$this->spos+2}==')')) {$this->lex[]=array('type'=>'F'); $this->spos+=3;}
   else if ($ch=='(') {$this->lex[]=array('type'=>'('); $this->spos++;}
   else if ($ch==')') {$this->lex[]=array('type'=>')'); $this->spos++;}
   else if ($ch=='"') {if (!$this->scantext()) return FALSE;}
   else if ($ch=='*') {$this->lex[]=array('type'=>'*'); $this->spos++;}
   else if ($ch=='+') {$this->lex[]=array('type'=>'+'); $this->spos++;}
   else if ($ch=='^') {$this->lex[]=array('type'=>'^'); $this->spos++;}
   else {if (!$this->scanword()) return FALSE;}
  }
  return TRUE;
 }

 private function curlextype()
 {
  return $this->lex[$this->curlex]['type'];
 }

 private function curlexval()
 {
  return $this->lex[$this->curlex]['val'];
 }

 private function popOper()
 {
  if (count($this->oper)==0) return '';
  $op=$this->oper[count($this->oper)-1];
  unset($this->oper[count($this->oper)-1]);
  return $op;
 }

 private function pushOper($op)
 {
  $this->oper[count($this->oper)]=$op;
 }

 private function popData()
 {
  if (count($this->mas)==0) return NULL;
  $d=$this->mas[count($this->mas)-1];
  unset($this->mas[count($this->mas)-1]);
  return $d;
 }

 private function pushData($data)
 {
  $this->mas[count($this->mas)]=$data;
 }


 function arrayGetRecIdList($myArray)
 {
  if(!is_array($myArray)) return $myArray; 
  foreach ($myArray as &$myvalue) $myvalue=$myvalue['recid'];
  $myArray=array_values(array_unique($myArray));
  return $myArray; 
 }

 function arrayUnique($myArray) 
 { 
  if(!is_array($myArray)) return $myArray; 
  foreach ($myArray as &$myvalue) $myvalue=serialize($myvalue);  
  $myArray=array_unique($myArray); 
  foreach ($myArray as &$myvalue) $myvalue=unserialize($myvalue);  
  return $myArray; 
 } 

 private function doOpers()
 {
  $this->res=array();
  $co=$this->popOper();
  while(($co!='')&&($co!='('))
  {
   $m1=$this->popData();
   $m2=$this->popData();
   $m=array();
   if ($co=='*') $m=array('$and'=>array($m1,$m2));
   else if ($co=='^') $m=array('$nor'=>array($m1,$m2));
   else if ($co=='+') $m=array('$or'=>array($m1,$m2));
//   else if ($co=='F') $m=array_values(array_udiff($m1,$m2,'IrbisSearch::CompareIdxOcc'));
   else return FALSE;
   $this->pushData($m);
   $co=$this->popOper();
  }
  if ($co=='(') $this->pushOper('(');
  return TRUE;
 }


 function SetSearch($search='') //
 {
  $this->searchstr=$search;
  $this->spos=0;
  $this->logeof=false;
  $this->slen=strlen($search);
  $this->lex=array();
  $this->curlex=0;
  $this->mas=array();
  $this->oper=array();
 }

 function ParseSearch() //
 {
  if(!$this->Scan()) return FALSE; // Syntax error
 }

 function Exec()
 {
  //$this->SetSearch($search);
  //if ($this->ParseSearch()==FALSE) return NULL;
  $lexlen=count($this->lex);
  $res=array();
  for (;$this->curlex<$lexlen;$this->curlex++)
  {
   if ( ($this->curlextype()=='(') || ($this->curlextype()=='*') || ($this->curlextype()=='+') || ($this->curlextype()=='^') || ($this->curlextype()=='F'))
    $this->pushOper($this->curlextype());
   else if ($this->curlextype()=='T') 
   {
    $curlex=$this->curlexval();
    if (substr($curlex,-1)=='$')
    {
     $curlex=array('gte'=>substr($curlex,0,-1));
    }
    $this->mas[]=array('keys.key'=>$curlex);
   }
   else if ($this->curlextype()==')') 
   {
    if (!$this->doOpers()) return $this->error('doOpers return FALSE');
    if (count($this->oper)==0) return $this->error(') w/o (');
    $op=$this->popOper(); //strip (
    if ($op!='(') return $this->error('internal error');
   }
  }
  if (!$this->doOpers()) return $this->error('doOpers (last) return FALSE');
  if (count($this->oper)!=0) return $this->error('count($this->oper)!=0');
  if (count($this->mas)!=1) return $this->error('count($this->mas)!=1');
  return $this->mas;
 }

 function error($str='')
 {
  echo $str."\n";
  return NULL;
 }
}


?>
