<?php 

require_once(dirname(__FILE__) . '/OM.php');
require_once(dirname(__FILE__) . '/Record.php');
require_once(dirname(__FILE__) . '/Ini.php');
require_once(dirname(__FILE__) . '/DummyDP.php');
require_once(dirname(__FILE__) . '/DP_z3950.php');

define('DPz3950DBG', 0);

ini_set('max_execution_time',30);

class DP_ebsco extends DP_z3950
{
    function DP_ebsco($id)
    {
     DP_z3950::DP_z3950($id);
    }

    function RecRead($DbName, $mfn, $bLock,Record $r)
    {
     $e = $this->ConvertSearchExpression('("I='.$mfn.'")');
     yaz_syntax($this->resid, $this->remoteformat);
     yaz_search($this->resid, 'rpn', $e);
     yaz_range($this->resid,1,1);
     yaz_wait();
     $error = yaz_errno($this->resid);
     if ($error!=0) return $this->Error($error);
     $hits = yaz_hits($this->resid);
     if ($hits == 0) return -400;
     yaz_range($this->resid, 1, 1);
     $rec = yaz_record($this->resid, 1, "raw");
     // iso-   -
     $e = $r->SetFromMarc($rec, $this->remotecp); if ($e < 0) return $e;
     $zid=$r->GetField('001',1);
     $e = $r->ApplyFst(APATH_DB, $this->odbi, $this->fstinname); if ($e < 0) return $e;
     if ($r->GetField(903,1)=='') $r->FieldAdd(903,$zid);
     $r->SetMfn($zid);
//     $r->Dump();
     return 0;
    }

    
    function Search($DbName, $Expression, $Sequence, $Format, $NumMfn = 0,
        $FirstMfn = 0, $Min = 0, $Max = 0,$isExt=false)
    {
        $this->wlog("DP_z3950::Search(DbName=$DbName, Expression=$Expression, Sequence=$Sequence, Format=$Format, NumMfn=$NumMfn,FirstMfn=$FirstMfn, Min=$Min, Max=$Max,isExt=$isExt)\n");
        $this->wlog('Expression='.$Expression);
    	//echo $Expression;
        //if (($er = $this->Connect($sysconn)) < 0) return $er;
        //$db = $this->dbcfg['DbIni']['PROVIDER']['DB'];
        $e = $this->ConvertSearchExpression($Expression);
        yaz_syntax($this->resid, $this->remoteformat);
        yaz_search($this->resid, 'rpn', $e);
        yaz_range($this->resid,1,1);
        $this->wlog('Converted expression: '.$e.'<br>');
        yaz_wait();
        $error = yaz_errno($this->resid);
        $this->wlog('Errno: '.$error.'<br>');
        if ($error!=0)
        {
            return $this->Error($error);
        }
		$hits = yaz_hits($this->resid);
        $this->wlog('Hits: '.$hits.'<br>');
		//echo "FirstMfn = $FirstMfn; NumMfn = $NumMfn<br>";
        if ($NumMfn == 0) return array(0 => $hits);
        $res = array();
        $res[0] = $hits;
        //echo $hits;
        if ($hits>0)
        {
        	if (($FirstMfn > 0)&&($FirstMfn<$hits)) 
			{
				$n=min($NumMfn,$hits-$FirstMfn+1);
				yaz_range($this->resid, $FirstMfn, $n);
//				yaz_present($this->resid); yaz_wait();
				//echo "yaz_range ($FirstMfn, $n) hits=$hits<br>";
			}
        }
        $Format=str_replace('mfn','\'~~~~~mfn~~~~~\'',$Format);
        for ($p = $FirstMfn; (($p<=$hits)&&($p <= $FirstMfn + $NumMfn - 1)); $p++)
        {
        	//echo "show $p<br>";
            $rec = yaz_record($this->resid, $p, "raw");
            $this->wlog('Rec #: '.$p.'<br>');
            $this->wlog('IsoBuf: '.var_export($rec,true).'<br>');
            if (empty($rec)) continue;
            //$rec=iconv($this->remotecp,'utf-8',$rec);
            // iso-   -
            $r = new Record(0);
            $e = $r->SetFromMarc($rec, $this->remotecp);
//            $r->Dump();
//            $this->wlog('ISO<br>'.$r->rDump().'<br>');
//            $this->wlog("");
            $zid=$r->GetField('001',1);
            if ($e < 0) return $e;
            $db=new DB($this->odbi);
            $e = $r->ApplyFst(APATH_DB, $this->odbi, $this->fstinname);
            $this->wlog('Applied FST ('.$this->odbi.', errorcode: '.$e.')<br>');
            $this->wlog($r->rDump().'<br>');
            if ($e < 0) return $e;
            if ($r->GetField(903,1)=='') $r->FieldAdd(903,$zid);
            $r->SetMfn($zid);
            if ($r->GetSubField(951,1,'I')!='')
             $r->SetSubField(951,1,'I',str_replace('%FIELD13.a%',$zid,$r->GetSubField(951,1,'I')).'&S=R');

//            echo '<pre>'; $r->Dump(); echo '</pre>';

            $nr=array();
            $nr['mfn']=$r->GetMfn();
//            $nr['mfn']=$zid;
            if ($Format=='@') $Format="&uf('6kn_h')";
            $nr['format']=$db->RecVirtualFormat($Format, $r);
            //$r->Dump();
            //print_r($nr);
            $this->wlog('nr[mfn]='.$nr['mfn']."\n");
            $nr['format']=str_replace('~~~~~mfn~~~~~',$nr['mfn'],$nr['format']);
            $this->wlog('Formatted<br>');
            $this->wlog($nr['format']);
            //echo (var_export($nr,true));
            if ($isExt)
            	$res[]=$nr;
            else
            	$res[] = $nr['format'];
           $r->Dispose($r->GetId());
        }
        $this->wlog(var_export($res,true));
        return $res;
    }

       function RecSearch($DbName, $Expression, $Sequence, $NumMfn = 0, $FirstMfn = 0)
       {
    	$r = $this->Search($DbName,$Expression, $Sequence, "&uf('+0')", $NumMfn, $FirstMfn);
	if (!is_array($r)) return array(0=>$r);
	if ($r[0] < 1) return array(0=>$r[0]);
	$res = array(0=>0);
	foreach ($r as $key => $m)
	{
	 if ($key == 0) $res[0] = $m;
	 else
	 {
	  if ($m != '')
	  {
	   $rr = new Record(0);
	   $rr->ParseIrbisRec($m);
	   $res[] = $rr;
	  }
	 }
	}
	return $res;
       }


}
;
?>