<?php 

require_once(dirname(__FILE__) . '/OM.php');
require_once(dirname(__FILE__) . '/Record.php');
require_once(dirname(__FILE__) . '/Ini.php');
require_once(dirname(__FILE__) . '/DummyDP.php');

define ('DPi128DBG',0);



class DP_i128 extends DummyDP
{
//    var $host;
//    var $port;
//    var $login;
//    var $pw;
//    var $proxy;
//    var $IsConnected;
//    var $cfg;
//    var $db;
//    var $odb; //owner db config
//    var $timeout;
//    var $dbcfg;
//    var $remotecp;
//    var $mode;
//    var $z21id;
//    var $termpreg;
//    var $termpregcolrefs;
//    var $termpregcolterms;
    
    function DP_i128($id)
    {
     $this->OM($id,'DP_i128');
     //       ( )
     if ($id<=0)
     {
      $this->host = 'http://127.0.0.1/irb';
      $this->port = 80;
      $this->login = '';
      $this->pw = '';
      $this->db='IBIS';
      $this->timeout=120;
      $this->IsConnected = false;
      $this->mode=1;
      $this->sesid='';
      $this->armid=0;
      $this->dbid=0;
      $this->proxy='';
      $this->proxyUser='';
      $this->proxyPassword;
     }
    }
  
    function SetOwnerProvider($id)
    {
     $this->odpi=$id;
    }

    private function exception($errcode)
    {
      return $errcode;
    }

    private function ExecRqst($params)
    {
     $ch = curl_init();
     $conn='DP/i128/'.md5($this->address.$this->port.$this->login.$this->pw.$this->ARM.$this->db).'/';
     $this->InitSharedVar('sesid',$conn.'sesid');
     $this->InitSharedVar('armid',$conn.'armid');
     $this->InitSharedVar('dbid',$conn.$this->db);

     if ( ($params['act']!='Connect') || ( ($params['act']=='Connect') && ( ($this->sesid=='') || ($this->armid==0) || ($this->dbid=='')) ) )
     {
      //trigger_error('DP_i128: sesid: '.var_export($this->sesid,true), E_USER_NOTICE);

      if ($this->sesid!='')
       $params['PHPSESSID']=$this->sesid;
      $params['DbName']=$this->db;
      $params['armid']=$this->armid;
      $params['dbid']=$this->dbid;

      curl_setopt($ch,CURLOPT_URL,$this->host.'/gateway/api.php'); 
      curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $this->timeout);
      if (($this->port!='')&&($this->port!=80))
       curl_setopt($ch,CURLOPT_PORT,$this->port);
      curl_setopt($ch, CURLOPT_POST, 1);
      curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
      curl_setopt($ch, CURLOPT_FAILONERROR, 1);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
      //trigger_error('DP_i128: '.var_export($params,true), E_USER_NOTICE);
      curl_setopt($ch,CURLOPT_POSTFIELDS,http_build_query($params));
      if ($this->proxy!='')
      {
         curl_setopt($ch, CURLOPT_HTTPPROXYTUNNEL, TRUE);
         curl_setopt($ch, CURLOPT_PROXY, $this->proxy);
         if(($this->proxyUser!='')&&($this->proxyPassword!=''))
         {
             curl_setopt($ch,CURLOPT_PROXYAUTH,CURLAUTH_BASIC);
             curl_setopt($ch, CURLOPT_USERPWD, "{$this->proxyUser}:{$this->proxyPassword}");
          }
      }
      
      $res=curl_exec($ch);
      $er=curl_errno($ch);
      if ($er != 0)
      {
       trigger_error('DP_i128: ('.$this->host.'/gateway/api.php): '.curl_error($ch)."\n".$pf, E_USER_NOTICE);
       //trigger_error('DP_i128: '.var_export($res,true), E_USER_NOTICE);
       curl_close($ch);
       if ($er<0) return $er;
       return -$er;
      }
      curl_close($ch);
      //if ($this->host=='http://176.62.72.25/irb')
      //{
      // trigger_error('DP_i128: '.$this->host.var_export($res,true), E_USER_NOTICE);
      // trigger_error('DP_i128: '.var_export($params,true), E_USER_NOTICE);
      //}
      if ($res!='') eval('$r1='.$res.';');
      if ( ((is_array($r1['res'])) && ($r1['res'][0]==-3335)) || ((!is_array($r1['res'])) && ($r1['res']==-3335)))
      {
       $this->ReConnect();
       return $this->ExecRqst($params);
      }

      //trigger_error('DP_i128: '.var_export($r1,true), E_USER_NOTICE);
      if (is_array($r1))
      {
       if ($params['act']=='Connect')
       {
        if ($this->sesid=='')
         $this->sesid=$r1['sesid'];

        $this->armid=$r1['armid'];
        $this->dbid=$r1['dbid'];
        $this->i128ver=$r1['i128ver'];
       }
       return $r1['res']===NULL?-400:$r1['res'];
      }
      else
       return -400;
     }
     else
      return 0;
    }

    function Reconnect()
    {
     $this->sesid='';
     $this->armid='';
     $this->dbid='';
     $this->IsConnected = false;
     $p['act']='Connect';
     $p['login']=$this->login;
     $p['pw']=$this->pw;
     $r=$this->ExecRqst($p);
     if ($r<0) return $r;
     $this->IsConnected=1;
     return 0;
    }
 
    function Connect($params)
    {
     if ($this->IsConnected) return 0;
     $this->SetOwnerDb($params['dbid']);
     $odp=new DP($this->odpi);
      // read parameters
     $ini=$params['Ini'];
     
     $this->host = $ini->GetValue('PROVIDER','HOST','http://127.0.0.1/irb');
     $this->port = $ini->GetValue('PROVIDER','PORT',80);
     $this->login = $ini->GetValue('PROVIDER','LOGIN','');
     $this->pw = $ini->GetValue('PROVIDER','PW','');
     $this->db=$ini->GetValue('PROVIDER','DB','IBIS');
     $this->timeout=$ini->GetValue('PROVIDER','TIMEOUT',120);
     $this->IsConnected = false;
     $this->proxy=$ini->GetValue('PROVIDER','PROXY','');
     $this->proxyUser=$ini->GetValue('PROVIDER','PROXYUSER','');
     $this->proxyPassword=$ini->GetValue('PROVIDER','PROXYPASSWORD','');


     //      -      id -   

     $p['act']='Connect';
     $p['login']=$this->login;
     $p['pw']=$this->pw;

     $r=$this->ExecRqst($p);

     if ($r<0) return $r;

     $this->IsConnected=1;

     return 0;
    }

    function Disconnect($sysconn)
    {
     $p['act']='Disconnect';
     $r=$this->ExecRqst($p);
     $this->IsConnected = false;
     $this->sesid='';
     return $r;
    }

    function GetFile($nApath,$Adbn,$FileName)
    {
     $p['act']='GetFile';
     $p['nApath']=$nApath;
     $p['Adbn']=$Adbn;
     $p['FileName']=$FileName;
     $r=$this->ExecRqst($p);
     return iconv('utf-8','windows-1251',$r);
    }

    function GetFormattedRecordsAfterSearch($DbName, $Expression, $Format, $NumRecords =
        0, $FirstRecord = 0, $Min = 0, $Max = 0, $Sequence = '')
    {
        $p['act']='GetFormattedRecordsAfterSearch';
        $p['DbName']=$DbName;
        $p['Expression']=$Expression;
        $p['Format']=$Format;
        $p['NumRecords']=$NumRecords;
        $p['FirstRecord']=$FirstRecord;
        $p['Min']=$Min;
        $p['Max']=$Max;
        $p['Sequence']=$Sequence;
        return $this->ExecRqst($p);
    }

    function GetMaxMfn($DbName)
    {
        $p['act']='GetMaxMfn';
        $p['DbName']=$DbName;
        return $this->ExecRqst($p);
    }

    function NoOperation()
    {
        $p['act']='NoOperation';
        return $this->ExecRqst($p);
    }

    function RecIfUpdate($DbName, $mfn)
    {
        $p['act']='RecIfUpdate';
        $p['DbName']=$DbName;
        $p['mfn']=$mfn;
        return $this->ExecRqst($p);
    }

    function RecRead($DbName, $mfn, $bLock,Record $rec)
    {
        $p['act']='RecRead';
        $p['DbName']=$DbName;
        $p['mfn']=$mfn;
        $p['bLock']=$bLock;
        $res=$this->ExecRqst($p);
        if (is_array($res))
        {
         $rec->SetFromArray($res);
         return 0;
        }
        //trigger_error('RecRead: '.var_export($res,true),E_USER_NOTICE);
        return $res;
    }

    function RecReadAndFormat($DbName, $mfn, $bLock, $Format)
    {
        $p['act']='RecReadAndFormat';
        $p['DbName']=$DbName;
        $p['mfn']=$mfn;
        $p['block']=$bLock;
        $p['Format']=$Format;
        return $this->ExecRqst($p);
    }

    function RecVirtualFormat($DbName, $Format, Record $VirtualRecord)
    {
     $p['act']='RecVirtualFormat';
     $p['DbName']=$DbName;
     $p['Format']=$Format;
     $p['VirtualRecord']=var_export($VirtualRecord->GetAsArray(),true);
     $res=$this->ExecRqst($p);
     return $res['res'];
    }

    function RecWrite($DbName, $bLock, $bIfUpdate, Record $VirtualRecord)
    {
     $p['act']='RecWrite';
     $p['DbName']=$DbName;
     $p['bLock']=$bLock;
     $p['bIfUpdate']=$bIfUpdate;
     //var_export($VirtualRecord->GetAsArray());
     $p['VirtualRecord']=var_export($VirtualRecord->GetAsArray(),true);
//print_r($p);
     $res=$this->ExecRqst($p);
//print_r($res);
     if (is_array($res))
     {
      $VirtualRecord->SetFromArray($res['VirtualRecord']);
      return $res['res'];
     }
     return $res;
    }

    function Search($DbName, $Expression, $Sequence, $Format, $NumMfn = 0, $FirstMfn =
        0, $Min = 0, $Max = 0,$IsExt=false)
    {
     $p['act']='Search';
     $p['DbName']=$DbName;
     $p['Expression']=$Expression;
     $p['Sequence']=$Sequence;
     $p['Format']=$Format;
     $p['NumMfn']=$NumMfn;
     $p['FirstMfn']=$FirstMfn;
     $p['Min']=$Min;
     $p['Max']=$Max;
     $p['IsExt']=$IsExt;
     return $this->ExecRqst($p);
    }

    function RecSearch($DbName, $Expression, $Sequence, $NumMfn = 0, $FirstMfn = 0)
    {
     $p['DbName']=$DbName;
     $p['Expression']=$Expression;
     $p['Sequence']=$Sequence;
     $p['NumMfn']=$NumMfn;
     $p['FirstMfn']=$FirstMfn;
     if ($this->i128ver>'2012.0831')
     {
      $p['act']='RecSearch';
      $res=$this->ExecRqst($p);
      if (is_array($res)) for ($i=1;$i<count($res);$i++)
      {
       $rec=new Record(0);
       $rec->SetFromArray($res[$i]);
        $res[$i]=$rec;
      }
      return $res;
     }
     else
     {
      $p['act']='Search';
      $p['Format']="&uf('+0')";
      $res=$this->ExecRqst($p);
      //trigger_error('DP_i128: '.var_export($res,true), E_USER_NOTICE);
      if (is_array($res)) for ($i=1;$i<count($res);$i++)
      {
       $rec=new Record(0);
       $rec->ParseIrbisRec($res[$i]);
       $res[$i]=$rec;
      }
      return $res;
     }
    }


    function WriteToIni($IniText)
    {
     $odp=new DP($this->odpi);
     return $odp->WriteToIni($IniText);
     //   64
    }

    function GetTermList($DbName, $Pref, $StartTerm, $NumTerms, $isback=0,$format = '')
    {
     $p['act']='GetTermList';
     $p['DbName']=$DbName;
     $p['Pref']=$Pref;
     $p['StartTerm']=$StartTerm;
     $p['NumTerms']=$NumTerms;
     $p['isback']=$isback;
     $p['format']=$format;
     $res=$this->ExecRqst($p);
     return $res;
    }

    function SetOwnerDb($id)
    {
     $this->odbi=$id;
    }

}
;
?>