<?php 

require_once(dirname(__FILE__) . '/OM.php');
require_once(dirname(__FILE__) . '/Record.php');
require_once(dirname(__FILE__) . '/Ini.php');
require_once(dirname(__FILE__) . '/DummyDP.php');

define ('DPi128DBG',0);


class master_file
{
 
 var $mst;
 var $xrf;
 var $fname;
 var $xrfbsize;
 var $posmaxwidth;
 var $headersize;
 var $headers;

 function __construct($fname)
 {
  $this->fname=$fname;
  $this->posmaxwidth=8;
  $this->xrfbsize=$this->posmaxwidth*2;
  $this->mst=NULL;
  $this->headersize=1024;
  $this->headers=NULL;
 }

 private function Open($mode)
 {
  if ($this->mst===NULL)
  {
   $this->mst=fopen($this->fname.'.mst128',$mode);
   $this->xrf=fopen($this->fname.'.xrf128',$mode);
  }
 }

 function __destruct()
 {
  $this->Close();
 }
 
 function private Close()
 {
  if ($this->mst!==NULL)
  {
   fclose($this->mst);
   fclose($this->xrf);
   $this->mst=NULL;
   $this->headers=NULL;
  }
 }

 private function toNum($str,$start,$len)
 {
  $v=0; for ($i=$start;$i<($start+$len);$i++) $v=$v*256+ord($str{$i}); 
  return $v;
 }

 private function toStr($num,$len)
 {
  $res='';
  $n1=$num;
  $d=$n1/256;
  $ost=$n1 % 256;
  $i=0;
  while(d>=1)
  {
   $res=chr($ost).$res;
   $i++;
  }
  for ($j=$i;$j<$len;$j++) $res.=chr(0).$res;
  return $res;
 }
 
 function GetHeaders()
 {
  if ($this->headers===NULL)
  {
   $p=ftell($this->mst); fseek($this->mst,0); $hmst=fread($this->mst,$this->headersize); fseek($this->mst,$p);
   $p=ftell($this->xrf); fseek($this->xrf,0); $hxrf=fread($this->xrf,$this->headersize); fseek($this->xrf,$p);

   $this->headers['mst']['ver']=$this->toNum($hmst,0,4);
   $this->headers['mst']['lastpos']=$this->toNum($hmst,4,12);
  
   $this->headers['xrf']['ver']=$this->toNum($hxrf,0,4);
  }
 }

 function Saveheaders()
 {
  if (($this->headers!==NULL) && ($this->mst!==NULL))
  {
   fseek($this->mst,0);
   fseek($this->xrf,0);
   fwrite($this->mst,$this->toStr($this->headers['mst']['ver'],4).$this->toStr($this->headers['mst']['lastpos'],8));
   fwrite($this->xrf,$this->toStr($this->headers['xrf']['ver'],4));
  }
 }

 function GetByMfn($mfn)
 {
  $this->Open('rb');
  if(fseek($this->xrf,$mfn*$this->xrfbsize+$this->headersize)!=0) return NULL;
  $xrfblock=fread($this->xrf,$this->xrfbsize);
  $pos=0; for ($i=0;$i<8;$i++) $pos=$pos*256+ord($xrfblock{$i});
  $len=0; for ($i=8;$i<16;$i++) $len=$len*256+ord($xrfblock{$i});
  if(fseek($this->mst,$pos+$this->headersize)!=0) return NULL;
  $res=fread($this->mst,$len);
  if ($res=='') $res="NULL";
  $this->Close();
  eval('$res='.$res.';');
  return $res;
 }

 function SetByMfn($mfn,$data,$usermeta=array())
 {
  $pd=$this->GetByMfn($mfn);
  $nd['data']=$data;
  $nd['meta']=array('prevoffset'=>-1,'offset'=>-1,'ver'=>1,'mfn'=>0);
  if ($pd!=NULL)
  {
   $nd['meta']['prevoffset']=$pd['meta']['offset'];
   $nd['meta']['ver']=$pd['meta']['ver']+1;
  }
  $nd['meta']['mfn']=$mfn;
  $nd['meta']['usermeta']=$usermeta;
  $this->Open('c+');
  $this->Lock();
  $this->GetHeaders();
  ///       
  $this->SaveHeaders();
  $this->UnLock();
  $this->Close();
  
 }

}


class DP_int extends DummyDP
{
 function DP_int($id)
 {
  $this->OM($id,'DP_int');
 }

 function Connect($params)
 {
  if ($this->IsConnected) return 0;
  $this->SetOwnerDb($params['dbid']);
  //$odp=new DP($this->opid);
  //$ini=$params['Ini'];
  return 0;
 }

 function Disconnect($sysconn)
 {
  $this->IsConnected = false;
  $this->sesid='';
  return $r;
 }

 function GetFile($nApath,$Adbn,$FileName)
 {
  return '';
 }

 function GetFormattedRecordsAfterSearch($DbName, $Expression, $Format, $NumRecords =
        0, $FirstRecord = 0, $Min = 0, $Max = 0, $Sequence = '')
 {
  return -9999; //NA
 }
 function GetMaxMfn($DbName)
 {
  return -9999; // NA
 }

 function NoOperation()
 {
  return 0;
 }

 function RecIfUpdate($DbName, $mfn)
 {
  return 0;
 }

 function RecRead($DbName, $mfn, $bLock,Record $rec)
 {
  return -9999; //NA
 }

 function RecReadAndFormat($DbName, $mfn, $bLock, $Format)
 {
  return -9999; // NA
 }

 function RecVirtualFormat($DbName, $Format, Record $VirtualRecord)
 {
  return -9999; // NA
 }

 function RecWrite($DbName, $bLock, $bIfUpdate, Record $VirtualRecord)
 {
  return -9999;
 }

 /**
 *   <0   
 *  ,    -  ,
 *  0 - -  
 */
 function Search($DbName, $Expression, $Sequence, $Format, $NumMfn = 0, $FirstMfn =0, $Min = 0, $Max = 0)
 {
  return -9999;
 }

 function WriteToIni($IniText)
 {
  return -9999; // NA;
 }

 function GetTermList($DbName, $Pref, $StartTerm, $NumTerms, $isback = 0, $format ='')
 {
  return array('errorcode'=>-999);
 } 

 function Noop()
 {
  return 0;
 }

 function SetOwnerDb($id)
 {
  $this->odbi=$id;
 }

 function DeleteRec($DbName,$mfn)
 {
  return -9999; //NA
 }
}
