<?php 

require_once(dirname(__FILE__) . '/OM.php');
require_once(dirname(__FILE__) . '/Record.php');
require_once(dirname(__FILE__) . '/Ini.php');
require_once(dirname(__FILE__) . '/DummyDP.php');

define ('DPRAIDB0DBG',0);

/*
 mfn: dbid/mfn

*/


class DP_raidb0 extends DummyDP
{
//    var $dbcfg;
//    var $IsConnected;
//    var $odpi
    
    function DP_raidb0($id)
    {
     $this->OM($id,'DP_raidb0');
     //       ( )
     if ($id<=0)
     {
      $this->dbcfg=array();
      $this->IsConnected = false;
     }
    }
  
    function SetOwnerProvider($id)
    {
     $this->odpi=$id;
    }

    private function exception($errcode)
    {
      return $errcode;
    }

    function Connect($params)
    {
     if ($this->IsConnected) return 0;
     $odp=new DP($this->odpi);
      // read parameters
     $ini=$params['Ini'];
     $sdbcount=$ini->GetValue('PROVIDER','SUBDBS_COUNT',0);
     $this->odbi=$params['dbid'];
     $this->dbcfg=array();
     $cfg=array();
     $readweightsum=0;
     $writeweightsum=0;
     $odb=new DB($params['dbid']);
     for ($i=1;$i<=($sdbcount+0);$i++)
     {
      $dbconf=array();
      $dbn=$ini->GetValue('PROVIDER','SUBDBSCFG_'.$i.'_NAME','');
      if ($dbn!='')
      {
       $dbro=false;
       if ($dbn[0]=='-')
       {
        $dbro=true;
        $dbn=substr($dbn,1);
       }
       //trigger_error(var_export($params,true),E_USER_NOTICE);
       //die();
       $db=new DB(0,$this->odpi);
       $db->SetName($dbn);
       $db->SetReadOnly($dbro);
       $db->Open($odb->ArmIni);
       //$db->SetArmId($this->GetId());
       //$db->SetArmIni($this->Ini);
       $dbconf['dbid']=$db->GetId();
       $dbconf['readweight']=$ini->GetValue('PROVIDER','SUBDBSCFG_'.$i.'_READWEIGHT',1);
       $dbconf['writeweight']=$ini->GetValue('PROVIDER','SUBDBSCFG_'.$i.'_WRITEWEIGHT',1);
       $readweightsum+=$dbconf['readweight'];
       $writeweightsum+=$dbconf['writeweight'];
      }
      $cfg[]=$dbconf;
     }

     // set read and write weights
     if ($readweightsum==0) $readweightsum=1;
     if ($writeweightsum==0) $writeweightsum=1;
     foreach ($cfg as $i=>$dbconf)
     {
      $dbconf['readweight']=$dbconf['readweight']/$readweightsum;
      $dbconf['writeweight']=$dbconf['writeweight']/$writeweightsum;
     }

     //save dbs config
     $this->dbcfg=$cfg;

     $this->IsConnected = true;
     return 0;
    }

    function Disconnect($sysconn)
    {
        $this->IsConnected = false;
    }

    function GetFile($nApath,$Adbn,$FileName)
    {
     $odp=new DP($this->odpi);
     return $odp->GetFile($nApath,$Adbn,$FileName);
    }

    function GetFormattedRecordsAfterSearch($DbName, $Expression, $Format, $NumRecords =
        0, $FirstRecord = 0, $Min = 0, $Max = 0, $Sequence = '')
    {
        return -9999; // NA
    }

    function GetMaxMfn($DbName)
    {
        return -9999; // NA
    }

    function NoOperation()
    {
        return 0;
    }

    private function ParseMfn($mfn)
    {
     $p=strpos($mfn,'/');
     if ($p===false) return array('dbid'=>0,'mfn'=>$mfn);
     return array('dbid'=>substr($mfn,0,$p),'mfn'=>substr($mfn,$p+1));
     /*$dbi=explode('/',$mfn);
     $lmfn=trim(substr($mfn,strlen($dbi[0])+1));
     return array('dbid'=>$dbi[0],'mfn'=>$lmfn);*/
    }

    function RecIfUpdate($DbName, $mfn)
    {
     if ($mfn!=0)
     {
      $lmfn=$this->ParseMfn($mfn);
      if ($lmfn['dbid']<1) return -110;
      $db=new DB($lmfn['dbid']);
      return $db->RecIfUpdate($lmfn['mfn']);
     }
     else
     {
      $dbcfgs=$this->dbcfg;
      foreach ($dbcfgs as $i=>$dbcfg)
      {
       $db=new DB($dbcfg['dbid']);
       $db->RecIfUpdate(0);
      }
      return 0;
     }
    }

    function RecRead($DbName, $mfn, $bLock,Record $r)
    {
     $lmfn=$this->ParseMfn($mfn);
//trigger_error('raidb0 rec read: '.$mfn);
     if ($lmfn['dbid']<1) return -110;
     $db=new DB($lmfn['dbid']);
     $res=$db->RecRead($lmfn['mfn'],$bLock,$r);
     $r->SetMfn($lmfn['dbid'].'/'.$r->GetMfn());
     return $res;
    }

    function RecReadAndFormat($DbName, $mfn, $bLock, $Format)
    {
     $lmfn=$this->ParseMfn($mfn);
     if ($lmfn['dbid']<=0) return -110;
     $db=new DB($lmfn['dbid']);
     $r=new Record(0);
//trigger_error('raidb0 recreadandformat: '.$mfn);
     return $db->RecReadAndFormat($lmfn['mfn'],$bLock,$Format);
    }

    function RecVirtualFormat($DbName, $Format, Record $VirtualRecord)
    {
     if ($this->odpi<=0) return -110;
     $odp=new DP($this->odpi);
     return $odp->RecVirtualFormat($DbName, $Format, $VirtualRecord);
//trigger_error('raidb0 recvirtualformat: '.$mfn);
     //   64
    }

    function RecWrite($DbName, $bLock, $bIfUpdate, Record $VirtualRecord)
    {
     $lmfn=$this->ParseMfn($VirtualRecord->GetMfn());
//trigger_error('raidb0 recwrite: '.$VirtualRecord->GetMfn());
     if ($lmfn['dbid']<1)
     {
      //record is new. detect database to write
      $cfg=$this->dbcfg;
      $wsum=0;
      $wght=rand(0,32000)/32000;
      foreach ($cfg as $i=>$dbconf)
      {
       $wsum+=$dbconf['writeweight'];
       if ($wsum>=$wght)
       {
        if ($lmfn['dbid']<1)
        {
         $lmfn['dbid']=$dbconf['dbid'];
         $lmfn['mfn']=-1;
        }
       }
      }
     }

     if ($lmfn['dbid']<1) return -9999; //Search for db unsuccessful
     
     $db=new DB($lmfn['dbid']);
     $r=new Record(0);
     $r->SetFromRecord($VirtualRecord);
     $r->SetMfn($lmfn['mfn']);
     $res=$db->SaveAndUpdateRecord($r);
     $r->Dispose($r->GetId());
     return $res;
    }

    function Search($DbName, $Expression, $Sequence, $Format, $NumMfn = 0, $FirstMfn =
        0, $Min = 0, $Max = 0,$IsExt=false)
    {
//     echo $FirstMfn.' - '.$NumMfn;
     $dbcfgs=$this->dbcfg;
     $res=array();
     $res[0]=0;
     $tc=0;
//     if ($NumMfn==0) $NumMfn=1000000;
//     if ($FirstMfn==0) $FirstMfn=1;
     foreach ($dbcfgs as $i=>$dbcfg)
     {
      //echo $i;
      $r1=array();
      $db=new DB($dbcfg['dbid']);
      if (($res[0]<$FirstMfn)||($FirstMfn==0))
       $r1=$db->Search($Expression, $Sequence, $Format, $NumMfn, $FirstMfn-$res[0], $Min, $Max);
      else
      {
       if ($res[0]<$FirstMfn+$NumMfn)
        $r1=$db->Search($Expression, $Sequence, $Format, $NumMfn-($res[0]-$FirstMfn), 1, $Min, $Max);
       else
       {
        //$r1=array(0=>0);
        $r1=$db->Search($Expression, $Sequence, $Format);
       }
      }
      //echo('r1: '.var_export(count($r1),true));
      for($j=1;$j<count($r1);$j++)
      {
       if ($Format=="&uf('+0')") $res[]=("0\n".$dbcfg['dbid'].'/'.substr($r1[$j],2));
       else $res[]=$r1[$j];
       //trigger_error('r1['.$j.']: '.var_export($r1[$j],true),E_USER_NOTICE);
      }
      if (($res[0]>=0) &&($r1[0]>=0))
       $res[0]+=$r1[0];
      else if($r1[0]<0) $res[0]=$r1[0];
     }
     //trigger_error('res: '.var_export($res,true),E_USER_NOTICE);
     //trigger_error($Format,E_USER_NOTICE);
     //echo count($res);
     return $res;
    }


    function RecSearch($DbName, $Expression, $Sequence, $NumMfn = 0, $FirstMfn = 0)
    {
     $dbcfgs=$this->dbcfg;
     $res=array();
     $res[0]=0;
     $tc=0;
     foreach ($dbcfgs as $i=>$dbcfg)
     {
      $r1=array();
      $db=new DB($dbcfg['dbid']);
      if (($res[0]<$FirstMfn)||($FirstMfn==0))
       $r1=$db->FindRecords($Expression, $Sequence, $NumMfn, $FirstMfn-$res[0]);
      else
      {
       if ($res[0]<$FirstMfn+$NumMfn)
        $r1=$db->FindRecords($Expression, $Sequence, $NumMfn-($res[0]-$FirstMfn), 1);
       else
       {
        //$r1=array(0=>0);
        $r1=$db->FindRecords($Expression, $Sequence);
       }
      }
      for($j=1;$j<count($r1);$j++)
      {
       $r1[$j]->SetMfn($dbcfg['dbid'].'/'.$r1[$j]->GetMfn());
       $res[]=$r1[$j];
      }
      if (($res[0]>=0) &&($r1[0]>=0))
       $res[0]+=$r1[0];
      else if($r1[0]<0) $res[0]=$r1[0];
     }
     return $res;

/* 	$r = $this->Search($DbName,$Expression, $Sequence, "&uf('+0')", $NumMfn, $FirstMfn);
	if (!is_array($r)) return array(0=>$r);
	if ($r[0] < 1) return array(0=>$r[0]);
	$res = array(0=>0);
	foreach ($r as $key => $m)
	{
	 if ($key == 0) $res[0] = $m;
	 else
	 {
	  if ($m != '')
	  {
	   $rr = new Record(0);
	   $rr->ParseIrbisRec($m);
	   $res[] = $rr;
	  }
	 }
	}
	return $res;*/
    }


    function WriteToIni($IniText)
    {
     $odp=new DP($this->odpi);
     return $odp->WriteToIni($IniText);
     //   64
    }

    static function GetTermList_sort($a, $b)
    {
     return strcmp(
      iconv('UTF-8', 'ISO-8859-1//TRANSLIT', $a['key']),
      iconv('UTF-8', 'ISO-8859-1//TRANSLIT', $b['key'])
     );
    }

    function GetTermList($DbName, $Pref, $StartTerm, $NumTerms, $isback=0,$format = '')
    {
     $dbcfgs=$this->dbcfg;
     $res=array();
     foreach ($dbcfgs as $i=>$dbcfg)
     {
      $db=new DB($dbcfg['dbid']);
      $r1=$db->GetTermList($Pref, $StartTerm, $NumTerms, $isback, $format);
      //trigger_error(var_export($r1,true),E_USER_NOTICE);
      if (is_array($r1)) foreach($r1 as $key=>$refs)
      {
       if ((is_numeric($key))&&($refs['key']!=''))
       {
        $res[]=array('key'=>$refs['key'],'refs'=>$refs['refs']);
        //$res[$refs['key']]+=$refs['refs'];
       }
      }
     }
     //print_r($res);
     
     usort($res, 'DP_raidb0::GetTermList_sort');

     for ($i=0;$i<(count($res)-1);$i++) if ($res[$i]['key']==$res[$i+1]['key'])
     {
      $res[$i+1]['refs']+=$res[$i]['refs'];
      unset ($res[$i]);
     }
     
     $res=array_values($res);
     
     $ress=array();
     $cr=count($res);
     //if ($cr > $NumTerms)
     //{
      if ($isback) for ($i=0;$i<min($NumTerms,$cr);$i++) $ress[]=$res[$i];
      if (!$isback) for ($i=max($cr-$NumTerms,0);$i<$cr;$i++) $ress[]=$res[$i];
     //}
     //trigger_error('terms: '.var_export($ress,true),E_USER_NOTICE);
     $ress['errorcode']=0;
     return $ress;
    }
}
;
?>