<?php 

require_once(dirname(__FILE__) . '/OM.php');
require_once(dirname(__FILE__) . '/Record.php');
require_once(dirname(__FILE__) . '/Ini.php');
require_once(dirname(__FILE__) . '/DummyDP.php');

define ('DPRAIDB0DBG',0);

/*
 mfn: id by I= <=> dbid/mfn
*/


class DP_sk extends DummyDP
{
//    var $dbcfg;
//    var $IsConnected;
//    var $odpi
    
    function DP_sk($id)
    {
     $this->OM($id,'DP_sk');
     //       ( )
     if ($id<=0)
     {
      $this->dbcfg=array();
      $this->IsConnected = false;
     }
    }
  
    function SetOwnerProvider($id)
    {
     $this->odpi=$id;
    }

    private function exception($errcode)
    {
      return $errcode;
    }

    function Connect($params)
    {
     if ($this->IsConnected) return 0;
     $odp=new DP($this->odpi);
      // read parameters
     $ini=$params['Ini'];
     $sdbcount=$ini->GetValue('PROVIDER','SUBDBS_COUNT',0);
     $this->odbi=$params['dbid'];
     $this->dbcfg=array();
     $cfg=array();
     $readweightsum=0;
     $writeweightsum=0;
     $odb=new DB($params['dbid']);
     for ($i=1;$i<=($sdbcount+0);$i++)
     {
      $dbconf=array();
      $dbn=$ini->GetValue('PROVIDER','SUBDBSCFG_'.$i.'_NAME','');
      if ($dbn!='')
      {
       $dbro=false;
       if ($dbn[0]=='-')
       {
        $dbro=true;
        $dbn=substr($dbn,1);
       }
       //trigger_error(var_export($params,true),E_USER_NOTICE);
       //die();
       $db=new DB(0,$this->odpi);
       $db->SetName($dbn);
       $db->SetReadOnly($dbro);
       $db->Open($odb->ArmIni);
       //$db->SetArmId($this->GetId());
       //$db->SetArmIni($this->Ini);
       $dbconf['dbid']=$db->GetId();
       $dbconf['readweight']=$ini->GetValue('PROVIDER','SUBDBSCFG_'.$i.'_READWEIGHT',1);
       $dbconf['writeweight']=$ini->GetValue('PROVIDER','SUBDBSCFG_'.$i.'_WRITEWEIGHT',1);
       $readweightsum+=$dbconf['readweight'];
       $writeweightsum+=$dbconf['writeweight'];
      }
      $cfg[]=$dbconf;
     }

     // set read and write weights
     if ($readweightsum==0) $readweightsum=1;
     if ($writeweightsum==0) $writeweightsum=1;
     foreach ($cfg as $i=>$dbconf)
     {
      $dbconf['readweight']=$dbconf['readweight']/$readweightsum;
      $dbconf['writeweight']=$dbconf['writeweight']/$writeweightsum;
     }

     //save dbs config
     $this->dbcfg=$cfg;

     $this->IsConnected = true;
     return 0;
    }

    function Disconnect($sysconn)
    {
        $this->IsConnected = false;
    }

    function GetFile($nApath,$Adbn,$FileName)
    {
     $odp=new DP($this->odpi);
     return $odp->GetFile($nApath,$Adbn,$FileName);
    }

    function GetFormattedRecordsAfterSearch($DbName, $Expression, $Format, $NumRecords =
        0, $FirstRecord = 0, $Min = 0, $Max = 0, $Sequence = '')
    {
        return -9999; // NA
    }

    function GetMaxMfn($DbName)
    {
        return -9999; // NA
    }

    function NoOperation()
    {
        return 0;
    }


    private function ParseMfn($mfn)
    {
     $dbi=explode('/',$mfn);
     $lmfn=trim(substr($mfn,strlen($dbi[0])+1));
     return array('dbid'=>$dbi[0],'mfn'=>$lmfn);
    }

    function RecIfUpdate($DbName, $mfn)
    {
     if ($mfn!=0)
     {
      $lmfn=$this->ParseMfn($mfn);
      $db=new DB($lmfn['dbid']);
      return $db->RecIfUpdate($lmfn['mfn']);
     }
     else
     {
      $dbcfgs=$this->dbcfg;
      foreach ($dbcfgs as $i=>$dbcfg)
      {
       $db=new DB($dbcfg['dbid']);
       $db->RecIfUpdate(0);
      }
      return 0;
     }
    }

    function RecRead($DbName, $mfn, $bLock,Record $r)
    {
     $lmfn=$this->ParseMfn($mfn);
     $db=new DB($lmfn['dbid']);
     return $db->RecRead($lmfn['mfn'],$bLock,$r);
    }

    function RecReadAndFormat($DbName, $mfn, $bLock, $Format)
    {
     $lmfn=$this->ParseMfn($mfn);
     $db=new DB($lmfn['dbid']);
     $r=new Record(0);
     return $db->RecReadAndFormat($lmfn['mfn'],$bLock,$Format);
    }

    function RecVirtualFormat($DbName, $Format, Record $VirtualRecord)
    {
     $odp=new DP($this->odpi);
     return $odp->RecVirtualFormat($DbName, $Format, $VirtualRecord);
     //   64
    }

    function RecWrite($DbName, $bLock, $bIfUpdate, Record $VirtualRecord)
    {
     $lmfn=$this->ParseMfn($VirtualRecord->GetMfn());
     if ($lmfn['dbid']<1) return -9999;
     //trigger_error(var_export($lmfn,true),E_USER_NOTICE);
     //return -9999;
     
     $db=new DB($lmfn['dbid']);
     $r=new Record(0);
     $r->SetFromRecord($VirtualRecord);
     $r->SetMfn($lmfn['mfn']);
     $res=$db->SaveAndUpdateRecord($r);
     $r->Dispose($r->GetId());
     return $res;
    }

    function Search($DbName, $Expression, $Sequence, $Format, $NumMfn = 0, $FirstMfn =
        0, $Min = 0, $Max = 0,$IsExt=false)
    {
     $dbcfgs=$this->dbcfg;
     $res=array();
     $res[0]=0;
     $tc=0;
//     if ($NumMfn==0) $NumMfn=1000000;
//     if ($FirstMfn==0) $FirstMfn=1;
     foreach ($dbcfgs as $i=>$dbcfg)
     {
      $r1=array();
      $db=new DB($dbcfg['dbid']);
      if (($res[0]<$FirstMfn)||($FirstMfn==0))
       $r1=$db->Search($Expression, $Sequence, $Format, $NumMfn, $FirstMfn-$res[0], $Min, $Max);
      else
      {
       if ($res[0]<$FirstMfn+$NumMfn)
        $r1=$db->Search($Expression, $Sequence, $Format, $NumMfn-($res[0]-$FirstMfn), 1, $Min, $Max);
       else
        $r1=$db->Search($Expression, $Sequence, $Format,1,1);
      }
      //trigger_error('r1: '.var_export($r1,true),E_USER_NOTICE);
      for($j=1;$j<count($r1);$j++)
      {
       if ($Format=="&uf('+0')") $res[]=("0\n".$dbcfg['dbid'].'/'.substr($r1[$j],2));
       else $res[]=$r1[$j];
       //trigger_error('r1['.$j.']: '.var_export($r1[$j],true),E_USER_NOTICE);
      }
      if (($res[0]>=0) &&($r1[0]>=0))
       $res[0]+=$r1[0];
      else if($r1[0]<0) $res[0]=$r1[0];
     }
     //trigger_error('res: '.var_export($res,true),E_USER_NOTICE);
     //trigger_error($Format,E_USER_NOTICE);
     return $res;
    }

    function WriteToIni($IniText)
    {
     $odp=new DP($this->odpi);
     return $odp->WriteToIni($IniText);
     //   64
    }

    static function GetTermList_sort($a, $b)
    {
     return strcmp($a['key'], $b['key']);
    }

    function GetTermList($DbName, $Pref, $StartTerm, $NumTerms, $isback=0,$format = '')
    {
     $dbcfgs=$this->dbcfg;
     $res=array();
     foreach ($dbcfgs as $i=>$dbcfg)
     {
      $db=new DB($dbcfg['dbid']);
      $r1=$db->GetTermList($Pref, $StartTerm, $NumTerms, $isback, $format);
      if (is_array($r1)) foreach($r1 as $key=>$refs)
      {
       if ((is_numeric($key))&&($refs['key']!=''))
       {
        //$r2=array('key'=>$refs['key'],'refs'=>$refs['refs']);
        $res[$refs['key']]=$refs['refs'];
       }
      }
     }
     uasort($res, 'DP_sk::GetTermList_sort');
     $ress=array();
     foreach($res as $key=>$refs)
     {
      $ress[]=array('key'=>$key,'refs'=>$refs);
     }
     
     if (count($ress) > $NumTerms) 
     {
      if ($isback) array_splice($ress, 0, -$NumTerms);
      else array_splice($ress, $NumTerms + 1);
     }
     $ress['errorcode']=0;
     return $ress;
    }
}
;
?>