<?php 

require_once(dirname(__FILE__) . '/OM.php');
require_once(dirname(__FILE__) . '/Record.php');
require_once(dirname(__FILE__) . '/Ini.php');
require_once(dirname(__FILE__) . '/DummyDP.php');

define ('DPSQLODBG',0);


/*
table recs:
id - increment
rec - serialization of Record::GetAsArray

table keys
id - increment
key - keyword
keycount - keyword count

table idx
id - increment
keyid - link to keys['id']
recid - link to recs['id']
idxopt - serialize of link options
*/


class DP_sqlo extends DummyDP
{
//    var $host;
//    var $port;
//    var $login;
//    var $pw;
//    var $IsConnected;
//    var $cfg;
//    var $db;
//    var $odb; //owner db config
//    var $timeout;
//    var $dbcfg;
//    var $remotecp;
    var $link;
    
    function DP_sqlo($id)
    {
     $this->OM($id,'DP_sqlo');
     //       ( )
     if ($id<=0)
     {
      $this->host = '127.0.0.1';
      $this->port = 3306;
      $this->login = '';
      $this->pw = '';
      $this->db='IBIS';
      $this->timeout=120;
      //$this->IsConnected = false;
      $this->armid=0;
      $this->dbid=0;
      if ($this->IsConnected)
      {
       $cn='SQL_'.$this->sqldriver;
       $this->link = new $cn();
       $this->link->Connect($this->host,$this->port, $this->login, $this->pw,$this->db);
      }
     }
    }
  
    function SetOwnerProvider($id)
    {
     $this->odpi=$id;
    }

    private function exception($errcode)
    {
      return $errcode;
    }

 
    function Connect($params)
    {
     if ($this->IsConnected) return 0;
     $this->SetOwnerDb($params['dbid']);
     $odp=new DP($this->odpi);
      // read parameters
     $ini=$params['Ini'];
     $this->host = $ini->GetValue('PROVIDER','HOST','127.0.0.1');
     $this->port = $ini->GetValue('PROVIDER','PORT',3306);
     $this->login = $ini->GetValue('PROVIDER','LOGIN','');
     $this->pw = $ini->GetValue('PROVIDER','PW','');
     $this->db=$ini->GetValue('PROVIDER','DB','IBIS');
     $this->sqldriver=$ini->GetValue('PROVIDER','SQLDRIVER','mysql');
     $this->timeout=$ini->GetValue('PROVIDER','TIMEOUT',120);
     $this->IsConnected = false;

     require_once(dirname(__FILE__) . '/SQL/'.$this->sqldriver.'.inc');
     $cn='SQL_'.$this->sqldriver;
     $this->link = new $cn();
     $this->link->Connect($this->host,$this->port, $this->login, $this->pw,$this->db);

     $this->IsConnected=1;

     return 0;
    }

    function Disconnect($sysconn)
    {
     $this->IsConnected = false;
     $this->link->Disconnect();
     return array(0=>0);
    }

    function GetFile($nApath,$Adbn,$FileName)
    {
     $odp=new DP($this->odpi);
     return $odp->GetFile($nApath,$Adbn,$FileName);
    }

    function GetFormattedRecordsAfterSearch($DbName, $Expression, $Format, $NumRecords =
        0, $FirstRecord = 0, $Min = 0, $Max = 0, $Sequence = '')
    {
        return -9999;
    }

    function GetMaxMfn($DbName)
    {
     return -9999;
    }

    function NoOperation()
    {
        return 0;
    }

    function RecIfUpdate($DbName, $mfn)
    {
      $r=new Record(0);
      $this->link->Idx_DelByRec($mfn);
      $res=$this->RecRead($DbName,$mfn,false,$r); if ($r<0) return $r;
      $keys=array();
      $keys[]=array('key'=>'I='.$r->GetSubField(903,1,'*'),'mfn'=>$r->GetMfn(),'fld'=>903,'occ'=>1,'cnt'=>1);
      foreach($keys as $k)
      {
       $this->link->Idx_Add($k['key'],$k['mfn'],$k['fld'],$k['occ'],$k['cnt']);
      }
      $r->Dispose($r->GetId());
      //$r->ApplyFst(10,$this->odbi,$DbName.'.fst');
      /*$c=$r->GetContent();
      foreach ($c as $fld=>$occinf)
      {
       foreach ($occinf as $occ=>$val)
       {
        $vals=explode('%',$val);
        foreach ($vals as $cnt=>$subv)
        $this->link->Idx_Add($subv,$mfn,$fld,$occ,$cnt);
       }
      }*/
      return 0;
    }

    function RecRead($DbName, $mfn, $bLock,Record $rec)
    {
     $res=$this->link->Rec_Get($mfn);
     if ($res===NULL) return -400;
     $rec->SetFromArray(unserialize($res));
     $rec->SetMfn($mfn);
     return 0;
    }
    function RecReadAndFormat($DbName, $mfn, $bLock, $Format) { return -9999; }

    function RecReadAndFormat128($DbName, $mfn, $bLock, $Format,$FormatHost='',$FormatParams=array())
    {
     $r=new Record(0);
     $res=$this->RecRead($DbName,$mfn,$bLock,$r); if ($res!=0) return $res;
     $db=new DB($this->odbi);
     $res=$db->Format128($r,$Format,$FormatHost,$FormatParams);
        
    }

    function RecVirtualFormat($DbName, $Format, Record $VirtualRecord)
    {
     return -9999;
    }

    function RecWrite($DbName, $bLock, $bIfUpdate, Record $VirtualRecord)
    {
     $r=$VirtualRecord->GetAsArray();
     if ($VirtualRecord->GetMfn()==-1)
     {
      $id=$this->link->Rec_Add(serialize($r));
      if ($id!==NULL) $VirtualRecord->SetMfn($id);
      else return -400;
     }
     else
     {
      if (!($this->link->Rec_Set($VirtualRecord->GetMfn(),serialize($r)))) return -400;
     }
     if ($bIfUpdate) $this->RecIfUpdate($DbName,$VirtualRecord->GetMfn());
     return $VirtualRecord->GetMfn();
    }

    function Search($DbName, $Expression, $Sequence, $Format, $NumMfn = 0, $FirstMfn =
        0, $Min = 0, $Max = 0,$IsExt=false)
     {
      return -9999;
     }

    function Search128($DbName, $Expression, $Sequence, $Format, $FormatHost='', $FormatParams=array(),$NumMfn = 0, $FirstMfn = 0, $Min = 0, $Max = 0,$IsExt=false)
    {
     $res=$this->RecSearch($DbName,$Expression,$Sequence,$NumMfn,$FirstMfn);
     $rc=count($res);
     $res1[0]=$res[0];
     $db=new DB($this->odbi);
     for($i=1;$i<$rc;$i++)
      $res1[$i]=$db->Format128($res[$i],$Format,$FormatHost,$FormatParams);
     $db->FindRecordsClearResult($res);
     return $res1;
    }

    function GetIdx($term,$start,$limit)
    {
     return $this->link->Idx_SelectByKey($term);
    }

    function RecSearch($DbName, $Expression, $Sequence, $NumMfn = 0, $FirstMfn = 0)
    {
     require_once(dirname(__FILE__) . '/IrbisSearch.php');
     $c=new IrbisSearch();
     $res=$c->Exec($Expression,$this,'GetIdx',$FirstMfn,$NumMfn);
     $res=$c->arrayGetRecIdList($res);
     if ($Sequence!='') {}
     $resa=array(0=>count($res));
     if ($NumMfn==0) return $resa;
     $b=$FirstMfn;
     if ($b>0) $b--;
     $e=min($b+$NumMfn,$resa[0]);
     $resa[0]=$e-$b;
     for ($i=$b;$i<$e;$i++)
     {
      $row=$this->link->Rec_Get($res[$i]);
      $rec=new Record(0);
      $rec->SetFromArray(unserialize($row['rec']));
      $rec->SetMfn($row['id']);
      $resa[]=$rec;
     }
     return $resa;
    }

    function WriteToIni($IniText)
    {
     $odp=new DP($this->odpi);
     return $odp->WriteToIni($IniText);
     //   64
    }

    function GetTermList($DbName, $Pref, $StartTerm, $NumTerms, $isback=0,$format = '')
    {
     return $this->link->Idx_List($Pref,$StartTerm,$NumTerms);
     return -9999;
    }

    function SetOwnerDb($id)
    {
     $this->odbi=$id;
    }

}
;
?>