<?php 

require_once(dirname(__FILE__) . '/OM.php');
require_once(dirname(__FILE__) . '/Record.php');
require_once(dirname(__FILE__) . '/Ini.php');
require_once(dirname(__FILE__) . '/DummyDP.php');

define('DPz3950DBG', 0);

ini_set('max_execution_time',30);

class DP_z3950 extends DummyDP
{
/*    var $resid;
    var $address;
    var $port;
    var $login;
    var $group;
    var $pw;
    var $IsPersistent;
    var $cookie; // cookie for session (YAZ proxy)
    var $proxy; // Proxy for connection (YAZ proxy)
    var $IsPiggyBack;
    var $IsConnected;
    var $db;
    var $remoteformat;
    var $remotecp;
    var $fstinname;
    var $fstoutname;
    var $dbcfg;
    var $timeout;*/

    var $resid;
    var $StO;
    var $StT;
    var $SpO;
    var $SpT;

 function wlog($s)
 {
//  $f=fopen('z3950.log','ab');
//  fwrite($f,str_replace("<br>","\n",date('H:i:s ').$s));
//  trigger_error($s,E_USER_NOTICE);
//  fclose($f);
 }

    function DP_z3950($id)
    {
     $this->OM($id,'DP_z3950');
     //       ( )
     if ($id<=0)
     {
      $this->address = '127.0.0.1';
      $this->port = 210;
      $this->login = '';
      $this->pw = '';
      $this->db = 'ibis';
      $this->remoteformat = 'rusmarc';
      $this->remotecp = 'windows-1251';
      $this->fstinname = 'rmarci';
      $this->fstoutname = 'rmarce';
      $this->IsPersistent = true;
      $this->IsPiggyBack = true;
      $this->timeout = array('timeout'=>30);

      $this->cookie = '';
      $this->proxy = '';
      $this->IsConnected = false;
     }

     if ($this->IsConnected)
     {
      $res = yaz_connect($this->address.':'.$this->port.'/'.$this->db);
      if ($res)
          $this->resid = $res;
     }
    }

    function Error($er)
    {
    	trigger_error("Z3950 Error: ".$er.' - '.yaz_error($this->resid),E_USER_NOTICE);
    	return -3950000-$er;
    	/*switch ($er)
    	{
    		case 109: return -109; break;
    		default: return -9999; 
    	}*/
    }

    function Connect($params)
    {
     if ($this->IsConnected) return 0;
     $this->SetOwnerDb($params['dbid']);
     $odp=new DP($this->odpi);
      // read parameters
     $ini=$params['Ini'];

     $this->address = $ini->GetValue('PROVIDER','HOST','127.0.0.1');
     $this->port = $ini->GetValue('PROVIDER','PORT',210);
     $this->login = $ini->GetValue('PROVIDER','LOGIN','');
     $this->pw = $ini->GetValue('PROVIDER','PW','');
     $this->db = $ini->GetValue('PROVIDER','DB','');
     $this->remoteformat = $ini->GetValue('PROVIDER','REMOTEFORMAT','rusmarc');
     $this->remotecp = $ini->GetValue('PROVIDER','REMOTECP','windows-1251');
     $this->fstinname = $ini->GetValue('PROVIDER','FSTINNAME','rmarci');
     $this->fstoutname = $ini->GetValue('PROVIDER','FSTOUTNAME','rmarce');
     $this->IsPersistent = $ini->GetValue('PROVIDER','ISPERSISTENT',true);
     $this->IsPiggyBack = $ini->GetValue('PROVIDER','ISPIGGYBACK',true);
     $this->timeout = array('timeout'=>$ini->GetValue('PROVIDER','TIMEOUT',30));

//     $this->dbcfg['DbIni']=$ini->Content;

     $res = yaz_connect($this->address.':'.$this->port.'/'.$this->db);
     if ($res)
     {
         $this->IsConnected = true;
         $this->resid = $res;
         return 0;
     }
     return - 9999;
    }

    function Disconnect($sysconn)
    {
        $this->IsConnected = false;
        if (!$this->IsPersistent) @yaz_close($this->resid);
    }

    function PSkipComm(&$expr)
    {
        $expr = ltrim($expr);
    }
    function PTerm(&$expr)
    {
        //"A=$"
        //          
        //  0   , -1  
        $ZATTR=array
		(
			'I='=>12,
			'P='=>1,
			'T='=>4,//
			'TS='=>5,
			'B='=>'7+8',//ISBN/ISSN
			'U='=>14,///
			'K='=>21,// 
			'G='=>31,// 
			'J='=>54,//
			'C='=>55,
			'MI='=>59,// 
			'V='=>1001,//,  
			'A='=>1003,//
			'M='=>'2+3+1005+1006',///
			'DP='=>'1012',// 
			'O='=>1018,// 
			'N='=>1031,
		);
        $this->PSkipComm($expr);
        $t = ($expr{0} == '"');
        $j = 0;
        $t ? $j = 1 : $j = 0;
        $l = strlen($expr);
        while (($j < $l) && ((($t) && ($expr{$j} != '"')) || ((!$t) && ($expr{$j} != ' ') &&
            ($expr{$j} != '+') && ($expr{$j} != '*') && ($expr{$j} != '^')))) $j++;
        $trm=substr($expr,$t ? 1:0,$t?$j-1:$j);
        $expr=substr($expr,$t?$j+1:$j);
        $t1=explode('=',$trm);
        if (!is_array($t1)) return -1;
        $key=$t1[0].'=';
        $attr1=explode('+',$ZATTR[$key]);
        $trm=substr($trm,strlen($key));
        $attr5=0;
        if (!is_array($attr1)) return -109;
        if (substr($trm,-1)=='$')
        {
        	$attr5=1;
        	$trm=substr($trm,0,-1);
        }
        $cnt=0;
        foreach($attr1 as $at)
        {
        	if ($cnt>0) $res='@or '.$res.' ';
        	$cnt++;
        	$res.='@attr 1='.$at.' ';
        	if ($attr5!=0) $res.='@attr 5='.$attr5.' ';
        	$res.="{".$trm."}";
        }
        $this->StT[$this->SpT]=$res;
        $this->SpT++;
        return 0;
    }
    
    function PEval($tl,$tr)
    {
    	if ($this->SpO<1) return -1;
    	switch ($this->StO[$this->SpO - 1])
        {
            case '+':
                $this->StT[$this->SpT] = '@or '.$tl.' '.$tr;
                break;
            case '*':
                $this->StT[$this->SpT] = '@and '.$tl.' '.$tr;
                break;
            case '^':
                $this->StT[$this->SpT] = '@not '.$tl.' '.$tr;
                break;
            default: return -1;
        }
        $this->SpT++;
        $this->SpO--;
        unset($this->StO[$this->SpO]);
        
    }

	function PPopTerm()
	{
		$tr = $this->StT[$this->SpT - 1];
		$this->SpT--;
		unset($this->StT[$this->SpT]);
		return $tr;
	}
	
	function PPopOper()
	{
		$this->SpO--;
		$o=$this->StO[$this->SpO];
		unset($this->StO[$this->SpO]);
		return $o;
	}
	
	function PStates($o,$p)
	{
		if (DPz3950DBG)
		{
			echo '<pre>';
			echo "Operand:$o\nRqst:$p\nOper stack:\n".$this->SpO."\n";
			print_r($this->StO);
			echo "\nTerm Stack:\n".$this->SpT."\n";
			print_r($this->StT);
			echo '</pre>';
		}
	}
    function ConvertSearchExpression($expr)
    {
        // incoming string a-la (("A=$")+((A=$)+(V=NJ)))
        $p = $expr;
        if ($this->remotecp!='utf-8')
        	$p=iconv('utf-8',$this->remotecp,$p);
        $res = '';
        $this->SpO = 0;
        $this->SpT = 0;
        $this->StO = array();
        $this->StT = array();
        while (strlen($p) > 0)
        {
            $this->PSkipComm($p);
            switch ($p{0})
            {
                case '(':
                    $this->StO[$this->SpO] = '(';
                    $this->SpO++;
                    $p = substr($p, 1);
                    $this->PStates('(',$p);
                    break;
                case '+':
                case '*':
                case '^':
                	$o=$p{0};
                    if (($this->SpO == 0) || ($this->StO[$this->SpO - 1] == '('))
                    {
                        $this->StO[$this->SpO] = $o;
                        $this->SpO++;
                    } elseif (($this->StO[$this->SpO - 1] == '+') || ($this->StO[$this->SpO - 1] ==
                    '*') || ($this->StO[$this->SpO - 1] == '^'))
                    {
                        $tr = $this->PPopTerm();
                        $tl = $this->PPopTerm();
                        $this->PEval($tr, $tl);
                    }
                    else  return - 1; // 
                    $p = substr($p, 1);
                    $this->PStates($o,$p);
                    break;
                case ')':
                    if ($this->SpO == 0) return - 1;
                    elseif ($this->StO[$this->SpO - 1] == '(') { $this->PPopOper();}
                    elseif (($this->StO[$this->SpO - 1] == '+') || ($this->StO[$this->SpO - 1] ==
                        '*') || ($this->StO[$this->SpO - 1] == '^'))
                    {
                        $tr = $this->PPopTerm();
                        $tl = $this->PPopTerm();
                        $this->PEval($tl,$tr);
                        if (($this->SpO == 0) || ($this->StO[$this->SpO - 1] != '(')) return - 1;
                        else $this->PPopOper();
                    }
                    $p = substr($p, 1);
                    $this->PStates(')',$p);
                    break;
                default:
                    $e = $this->PTerm($p);
                    if ($e < 0) return $e;
                    $this->PStates('TERMIN',$p);
            }
        }
        if (($this->StO[$this->SpO - 1] == '+') || ($this->StO[$this->SpO - 1] == '*') ||
            ($this->StO[$this->SpO - 1] == '^'))
        {
        	if ($this->SpT < 2) return - 1;
            $tr = $this->PPopTerm(); if ($tr<0) return -1;
            $tl = $this->PPopTerm(); if ($tr<0) return -1;
            if ($this->PEval($tl,$tr)<0) return -1;
            if (($this->SpO != 0)&&($this->StO[$this->SpO - 1] != '(')) return - 1;
            if (($this->SpO != 0)&&($this->StO[$this->SpO - 1] == '('))
            	$this->PPopOper();
        }
        if (($this->SpO != 0) || ($this->SpT != 1)) return - 1;
        $this->PStates('END',$p);
        return $this->PPopTerm();
    }

    function GetFormattedRecordsAfterSearch($DbName, $Expression, $Format, $NumRecords =
        0, $FirstRecord = 0, $Min = 0, $Max = 0, $Sequence = '')
    {
        return - 9999; // temporarry not supported
        $e = $this->ConvertSearchExpression($Expression);

    }

    function GetMaxMfn($DbName)
    {
        return - 9999;
    }

    function NoOperation()
    {
        return 0;
    }

    function RecIfUpdate($DbName, $mfn)
    {
        return 0;
    }

    function RecRead($DbName, $mfn, $bLock,Record $r)
    {
     $e = $this->ConvertSearchExpression('("I='.$mfn.'")');
     yaz_syntax($this->resid, $this->remoteformat);
     yaz_search($this->resid, 'rpn', $e);
     yaz_range($this->resid,1,1);
     yaz_wait();
     $error = yaz_errno($this->resid);
     if ($error!=0) return $this->Error($error);
     $hits = yaz_hits($this->resid);
     if ($hits == 0) return -400;
     yaz_range($this->resid, 1, 1);
     $rec = yaz_record($this->resid, 1, "raw");
     // iso-   -
     $e = $r->SetFromMarc($rec, $this->remotecp); if ($e < 0) return $e;
     $zid=$r->GetField('001',1);
     $e = $r->ApplyFst(APATH_DB, $this->odbi, $this->fstinname); if ($e < 0) return $e;
     if ($r->GetField(903,1)=='') $r->FieldAdd(903,$zid);
     $r->SetMfn($zid);
     return 0;
    }

    function RecReadAndFormat($DbName, $mfn, $bLock, $Format)
    {
     $this->wlog('RecReadAndFomat Started (DbName: '.$DbName.', mfn: '.$mfn.',bLock: '.$bLock.',Format: '.$Format.')<br>');
     $res=$this->Search($DbName, '("I='.$mfn.'")','', $Format, 1,1);
     //print_r($res);
     $this->wlog('res: '.var_export($res,true));
     return $res[1];
    }

    function RecReadAndFormatList($DbName, $mfnstart, $mfnend, $bLock, $Format)
    {
        return -9999;
    }

    function RecVirtualFormat($DbName, $Format, Record $VirtualRecord)
    {
     $odp=new DP($this->odpi);
     return $odp->RecVirtualFormat($DbName, $Format, $VirtualRecord);
     //   64
    }

    function RecWrite($DbName, $bLock, $bIfUpdate, Record $VirtualRecord)
    {
        return - 9999;
    }
    
    function Search($DbName, $Expression, $Sequence, $Format, $NumMfn = 0,
        $FirstMfn = 0, $Min = 0, $Max = 0,$isExt=false)
    {
        $this->wlog("DP_z3950::Search(DbName=$DbName, Expression=$Expression, Sequence=$Sequence, Format=$Format, NumMfn=$NumMfn,FirstMfn=$FirstMfn, Min=$Min, Max=$Max,isExt=$isExt)\n");
        $this->wlog('Expression='.$Expression);
    	//echo $Expression;
        //if (($er = $this->Connect($sysconn)) < 0) return $er;
        //$db = $this->dbcfg['DbIni']['PROVIDER']['DB'];
        $e = $this->ConvertSearchExpression($Expression);
        yaz_syntax($this->resid, $this->remoteformat);
        yaz_search($this->resid, 'rpn', $e);
        yaz_range($this->resid,1,1);
        $this->wlog('Converted expression: '.$e.'<br>');
        yaz_wait();
        $error = yaz_errno($this->resid);
        $this->wlog('Errno: '.$error.'<br>');
        if ($error!=0)
        {
            return $this->Error($error);
        }
		$hits = yaz_hits($this->resid);
        $this->wlog('Hits: '.$hits.'<br>');
		//echo "FirstMfn = $FirstMfn; NumMfn = $NumMfn<br>";
        if ($NumMfn == 0) return array(0 => $hits);
        $res = array();
        $res[0] = $hits;
        //echo $hits;
        if ($hits>0)
        {
        	if (($FirstMfn > 0)&&($FirstMfn<$hits)) 
			{
				$n=min($NumMfn,$hits-$FirstMfn+1);
				yaz_range($this->resid, $FirstMfn, $n);
//				yaz_present($this->resid); yaz_wait();
				//echo "yaz_range ($FirstMfn, $n) hits=$hits<br>";
			}
        }
        $Format=str_replace('mfn','\'~~~~~mfn~~~~~\'',$Format);
        for ($p = $FirstMfn; (($p<=$hits)&&($p <= $FirstMfn + $NumMfn - 1)); $p++)
        {
        	//echo "show $p<br>";
            $rec = yaz_record($this->resid, $p, "raw");
            $this->wlog('Rec #: '.$p.'<br>');
            $this->wlog('IsoBuf: '.var_export($rec,true).'<br>');
            if (empty($rec)) continue;
            //$rec=iconv($this->remotecp,'utf-8',$rec);
            // iso-   -
            $r = new Record(0);
            $e = $r->SetFromMarc($rec, $this->remotecp);
//            $r->Dump();
//            $this->wlog('ISO<br>'.$r->rDump().'<br>');
            $this->wlog("");
            $zid=$r->GetField('001',1);
            if ($e < 0) return $e;
            $db=new DB($this->odbi);
            $e = $r->ApplyFst(APATH_DB, $this->odbi, $this->fstinname);
            $this->wlog('Applied FST ('.$this->odbi.', errorcode: '.$e.')<br>');
            $this->wlog($r->rDump().'<br>');
            if ($e < 0) return $e;
            if ($r->GetField(903,1)=='') $r->FieldAdd(903,$zid);
            $r->SetMfn($zid);
            $nr=array();
            $nr['mfn']=$r->GetMfn();
//            $nr['mfn']=$zid;
            if ($Format=='@') $Format="&uf('6kn_h')";
            $nr['format']=$db->RecVirtualFormat($Format, $r);
            //$r->Dump();
            //print_r($nr);
            $this->wlog('nr[mfn]='.$nr['mfn']."\n");
            $nr['format']=str_replace('~~~~~mfn~~~~~',$nr['mfn'],$nr['format']);
            $this->wlog('Formatted<br>');
            $this->wlog($nr['format']);
            //echo (var_export($nr,true));
            if ($isExt)
            	$res[]=$nr;
            else
            	$res[] = $nr['format'];
           $r->Dispose($r->GetId());
        }
        $this->wlog(var_export($res,true));
        return $res;
    }


       function RecSearch($DbName, $Expression, $Sequence, $NumMfn = 0, $FirstMfn = 0)
       {
    	$r = $this->Search($DbName,$Expression, $Sequence, "&uf('+0')", $NumMfn, $FirstMfn);
	if (!is_array($r)) return array(0=>$r);
	if ($r[0] < 1) return array(0=>$r[0]);
	$res = array(0=>0);
	foreach ($r as $key => $m)
	{
	 if ($key == 0) $res[0] = $m;
	 else
	 {
	  if ($m != '')
	  {
	   $rr = new Record(0);
	   $rr->ParseIrbisRec($m);
	   $res[] = $rr;
	  }
	 }
	}
	return $res;
       }


    function WriteToIni($IniText)
    {
     $odp=new DP($this->odpi);
     return $odp->WriteToIni($IniText);
     //   64
    }

    function GetTermList($DbName, $Pref, $StartTerm, $NumTerms=50, $format =
        '',$isback=false)
    {
    	$res=array();
        //$e = $this->ConvertSearchExpression($Expression);
        yaz_syntax($this->resid, $this->remoteformat);
        $opt=array
		(
			'number'=> $NumTerms,
			'position'=> 1
		);
		if ($isback)
			$opt['stepSize']=-1;
		$e=$this->ConvertSearchExpression($Pref.$StartTerm.'$');
        yaz_scan($this->resid, 'rpn', $e);
//        trigger_error("DP_z3950: (e): ".var_export($e,true).'//'.$Pref.$StartTerm.'$',E_USER_NOTICE);
        $tm=$this->timeout;
        $to=array('timeout'=>$tm);
        if ($to['timeout']<30) $to['timeout']=30;
        //echo "-->{$this->remoteformat}<--";
        yaz_wait($to);
        $error = yaz_errno($this->resid);
        if ($error!=0)
        {
//            trigger_error("DP_z3950: (error)".$error,E_USER_NOTICE);
//            echo "Error: $error";
            return - $error;
        }
    	$ar = yaz_scan_result($this->resid, &$options);
    	//print_r($ar);
//    	trigger_error("DP_z3950: (ar): ".var_export($ar,true),E_USER_NOTICE);
    	while (list($key, list($k, $term, $tcount)) = each($ar)) 
	{
      		if (empty($k)) continue;
      		
      		$t=$term;
      		if ($this->remotecp!='utf-8') $t=iconv($this->remotecp,'utf-8',strtoupper($term));
      		$sr['key']=$t;
      		$sr['refs']=$tcount;
      		$res[] = $sr;
    	}
//        trigger_error("DP_z3950: (res): ".var_export($res,true),E_USER_NOTICE);
        return $res;
    }

    function SetOwnerProvider($id)
    {
     $this->odpi=$id;
    }

    function SetOwnerDb($id)
    {
     $this->odbi=$id;
    }

    function GetFile($nApath,$Adbn,$FileName)
    {
     $odp=new DP($this->odpi);
     return $odp->GetFile($nApath,$Adbn,$FileName);
    }

}
;
?>