<?php 

require_once(dirname(__FILE__) . "/OM.php");

class Ini extends OM
{
 // var $Content;

 function Ini($id)
 {
  $this->OM($id,'Ini');
//  $this->__ExtVars['Content']=1;
 }

 function Load($dbid,$name)
 {
  require_once(dirname(__FILE__) . "/DB.php");
  if (substr_count($name,'.ini')==0) $name.='.ini';
  $this->Name=$name;
  $db=new DB($dbid);
  $this->InitSharedVar('Content','DATAI/'.$db->GetName().'/'.$name);
  if ($this->Content===NULL)
  {
   $this->Content=array();
   $ini=array();
   $r=$db->GetFile(APATH_DB,$name);
   if ($r=='')
   {
    $this->Content=$ini;
    return ER_OK;
   }
   $m=explode("\n",$r);
   $this->Parse($m);
  }
 }

 function ApplyIni($iniid)
 {
  $ini=new Ini($iniid);
  $c=$ini->Content;
  $c1=$this->Content;
  $this->dbg=$ini->Content;
  if (is_array($c)) foreach ($c as $section => $par)
  {
   if (is_array($par)) foreach($par as $pn=>$val)
   {
    $c1[strtoupper($section)][strtoupper($pn)]=$val;
   }
  }
  $this->Content=$c1;
 }

 function Parse($ar)
 {
  $res=array();
  $sect='';
  if (is_array($ar)) foreach($ar as $key=>$r)
  {
   if (is_integer($key))
   {
    $r=trim($r);
    if ($r!='')
    {
     if ($r{0}=='[')
     {
      $sect=strtoupper(trim($r,'[]'));
     }
     else
     {
      $pos = strpos($r, "=");
      if (!is_integer($pos)) {
       // not found...
      }
      else
      {
       $res[strtoupper($sect)][strtoupper(substr($r,0,$pos))]=substr($r,$pos+1);
      }
     }
    }
   }
  }
  $this->Content=$res;
  return $res;
 }

 function GetContent()
 {
  return $this->Content;
 }

 function GetValue($section,$var,$default='')
 {
  $c=$this->Content;
  $res=$default;
  if (isset($c[strtoupper($section)]))
  {
   if (isset($c[strtoupper($section)][strtoupper($var)]))
   {
    $res=$c[strtoupper($section)][strtoupper($var)];
   }
  }
  return $res;
 }

 function SetValue($section,$var,$val)
 {
  $res=$this->Content;
  $res[strtoupper($section)][strtoupper($var)]=$val;
  $this->Content=$res;
 }

 function GetAsJson()
 {
  $m=$this->Content;
  $res='{';
  $c=0;
  if (is_array($m)) foreach ($m as $sect=>$m1)
  {
   if ($c>0) $res.=','; $c++;
   $res.='"'.addslashes($sect).'":{';
   $c1=0;
   if (is_array($m1)) foreach ($m1 as $par=>$val)
   {
    if ($c1>0) $res.=','; $c1++;
    $res.='"'.addslashes($par).'":"'.addslashes($val).'"';
   }
   $res.='}';
  }
  $res.='}';
  return $res;
 }

};

?>