<?php

//***************************** Search *****************************************

class IrbisSerach
{
 $searchstr;
 $spos;
 $logeof;
 $lex;
 $curlex;
 $mas; //     
 $oper; //  
 $mascache; //     

 function __construct($search='',$parse=true)
 {
  $this->searchstr='';
  $this->$mascache=array();
  if ($search!='')
  {
   $this->SetSearch($search);
   if ($parse) $this->ParseSearch();
  }
 }

 function __destruct()
 {
 }

 private function logeof()
 {
  return $this->spos>=$this->slen;
 }

 private function getch()
 {
  $ch=$this->searchstr{$this->spos};
  $this->spos++;
  return $ch;
 }

 private function scantext()
 {
  $ch=$this->getch();
  if ($ch!='"') return FALSE;
  if ($this->logeof()) return FALSE;
  $ch=$this->getch();
  $str='';
  while ((!$this->logeof())&&($ch!='"'))
  {
   if ($ch=="\\") {if ($this->searchstr{$this->spos}=='"')} $str.=$this->getch();
   else $str.=$ch;
   $ch=$this->getch();
  }
  if (($this->logeof())&&($ch!='"')) return FALSE;
  $this->lex[]=array('type'=>'T','val'=>$str);
  return TRUE;
 }

 private function scanword()
 {
  $ch=$this->getch();
  if ($this->logeof()) return FALSE;
  $ch=$this->getch();
  $str='';
  while ((!$this->logeof())&&($ch!=' ')&&($ch!='*')&&($ch!='+')&&($ch!='^'))
  {
   $str.=$ch;
   $ch=$this->getch();
  }
  $this->lex[]=array('type'=>'T','val'=>$str);
  return TRUE;
 }

 private function Scan()
 {//  
  while((!$this->logeof())&&($this->searchstr{$this->spos}==' ')) $this->spos++;
  if ($this->logeof()) return TRUE;
  while (!$this->logeof())
  {
   $ch=$this->searchstr{$this->spos};
   if (($ch=='(') && (($this->slen-$this->spos)>=3) && ($this->searchstr{$this->spos+1}=='F') && ($this->searchstr{$this->spos+2}==')')) {$this->lex[]=array('type'=>'F'); $this->spos+=3;}
   else if ($ch=='(') {$this->lex[]=array('type'=>'('); $this->spos++;}
   else if ($ch=='"') {if (!$this->scantext()) return FALSE;}
   else if ($ch=='*') {$this->lex[]=array('type'=>'*'); $this->spos++;}
   else if ($ch=='+') {$this->lex[]=array('type'=>'+'); $this->spos++;}
   else if ($ch=='^') {$this->lex[]=array('type'=>'^'); $this->spos++;}
   else {if (!$this->scanword()) return FALSE;}
  }
  return TRUE;
 }

 private function curlextype()
 {
  return $this->lex[$this->curlex]['type'];
 }

 private function curlexval()
 {
  return $this->lex[$this->curlex]['val'];
 }

 private function popOper()
 {
  if (count($this->oper)==0) return '';
  $op=$this->oper[count($this->oper)-1];
  unset($this->oper[count($this->oper)-1]);
  return $op;
 }

 private function popData()
 {
  if (count($this->mas)==0) return NULL;
  $d=$this->mas[count($this->mas)-1];
  unset($this->mas[count($this->mas)-1]);
  return $d;
 }

 static function CompareIdxRec($a,$b)
 {
  if ($a['recid']>$b['recid']) return 1;
  if ($a['recid']<$b['recid']) return -1;
  return 0;
 }

 static function CompareIdxFld($a,$b)
 {
  if ($a['recid']>$b['recid']) return 1;
  if ($a['recid']<$b['recid']) return -1;
  if ($a['fld']>$b['fld']) return 1;
  if ($a['fld']<$b['fld']) return -1;
  return 0;
 }

 static function CompareIdxOcc($a,$b)
 {
  if ($a['recid']>$b['recid']) return 1;
  if ($a['recid']<$b['recid']) return -1;
  if ($a['fld']>$b['fld']) return 1;
  if ($a['fld']<$b['fld']) return -1;
  if ($a['occ']>$b['occ']) return 1;
  if ($a['occ']<$b['occ']) return -1;
  return 0;
 }

 static function CompareIdxCnt($a,$b)
 {
  if ($a['recid']>$b['recid']) return 1;
  if ($a['recid']<$b['recid']) return -1;
  if ($a['fld']>$b['fld']) return 1;
  if ($a['fld']<$b['fld']) return -1;
  if ($a['occ']>$b['occ']) return 1;
  if ($a['occ']<$b['occ']) return -1;
  if ($a['cnt']>$b['cnt']) return 1;
  if ($a['cnt']<$b['cnt']) return -1;
  return 0;
 }

 function arrayGetRecIdList($myArray)
 {
  if(!is_array($myArray)) return $myArray; 
  foreach ($myArray as &$myvalue) $myvalue=$myvalue['recid'];
  $myArray=array_values(array_unique($myArray));
  return $myArray; 
 }

 function arrayUnique($myArray) 
 { 
  if(!is_array($myArray)) return $myArray; 
  foreach ($myArray as &$myvalue) $myvalue=serialize($myvalue);  
  $myArray=array_unique($myArray); 
  foreach ($myArray as &$myvalue) $myvalue=unserialize($myvalue);  
  return $myArray; 
 } 

 private function doOpers()
 {
  $co=$this->popOper();
  while(($co!='')&&($co!='('))
  {
   $m1=$this->popData();
   $m2=$this->popData();
   $m=array();
   if (($m1==NULL)||($m2==NULL)) return FALSE;
   if ($co=='*') $m=array_values(array_uintersect($m1,$m2,'IrbisSearch::CompareIdxRec'));
   else if ($co=='^') $m=array_values(array_udiff($m1,$m2,'IrbisSearch::CompareIdxRec'));
   else if ($co=='+') $m=$this->arrayUnique($m1+$m2);
   else if ($co=='F') $m=array_values(array_udiff($m1,$m2,'IrbisSearch::CompareIdxOcc'));
   else return FALSE;
   $this->mas[]=$m;
   $co=$this->popOper();
  }
  if ($co=='(') $this->oper[]='(';
  return TRUE;
 }


 function SetSearch($search='')
 {
  $this->searchstr=$search;
  $this->spos=0;
  $this->logeof=false;
  $this->slen=strlen($search);
  $this->lex=array();
  $this->curlex=0;
  $this->mas=array();
  $this->oper=array();
 }

 function ParseSearch()
 {
  if(!$this->Scan()) return FALSE; // Syntax error
 }

 function Exec($search,$classlink,$funcname,$start,$limit)
 {
  $this->SetSearch($search);
  if ($this->ParseSearch()==FALSE) return NULL;
  $lexlen=count($this->lex);
  $res=array();
  for (;$this->curlex<$lexlen;$this->curlex++)
  {
   if ( ($this->curlextype()=='(') || ($this->curlextype()=='*') || ($this->curlextype()=='+') || ($this->curlextype()=='^') || ($this->curlextype()=='F'))
    $this->oper[]=$this->curlextype();
   else if ($this->curlextype()=='T') 
   {
    if (isset($this->mascache[$this->curlexval()])) $this->mas[]=$this->mascache[$this->curlexval()];
    else
    {
     $m=$classlink->$funcname($this->curlexval()); 
     $this->mas[]=$m[]; 
     $this->mascache[$this->curlexval()]=$m;
    }
   }
   else if ($this->curlextype()==')') 
   {
    if (!$this->doOpers()) return NULL;
    if (count($this->oper)==0) return NULL; ) w/o (
    if ($this->oper[count($this->oper)-1]['type']!='(') return NULL; // internal error
    unset($this->oper[count($this->oper)-1]); //strip (
   }
  }
  if (!$this->doOpers()) return NULL;
  if (count($this->oper)!=0) return NULL;
  if (count($this->mas)!=1) return NULL;
  return $this->mas[0];
 }
}

?>