<?php 
//error_reporting(E_ALL);

require_once(dirname(__FILE__) . '/../cfg.php');

global $OPTIONS;

ini_set("magic_quotes_gpc",'Off');
ini_set("display_errors",'Off');
ini_set("display_startup_errors",'Off');
ini_set("log_errors",'On');
ini_set("error_log",$OPTIONS['DataPath'].'/i128_errors.log');

global $SESSION_OM;
if ($SESSION_OM=='') $SESSION_OM='om';

if(REQUEST('I128NOSESSION')!=1) session_start();

require_once(dirname(__FILE__) . '/lang.php');
require_once(dirname(__FILE__) . '/jsmin.php');

define('ER_OK',0);
define('ER_POINTER',-1);
define('ER_NOTCONNECTED',-2);

function MinJS($js)
{
 return JSMin::minify($js);
}

function php2json($a) 
{
 if(is_null($a)) return 'null';
 if($a===false) return 'false';
 if($a===true) return 'true';
 if(is_scalar($a)) 
 {
  $a=addslashes($a);
  $a=str_replace("\n",'\n',$a);
  $a=str_replace("\r",'\r',$a);
  $a=preg_replace('{(</)(script)}i',"$1'+'$2",$a);
  return "'$a'";
 }
 $isList=true;
 for($i=0,reset($a);$i<count($a);$i++,next($a)) if(key($a)!==$i) 
 {
  $isList=false;
  break;
 }
 $result=array();
 if($isList) 
 {
  foreach($a as $v) $result[]=php2js($v);
  return '['.join(',',$result).']';
 }
 else 
 {
  foreach($a as $k=>$v) $result[]=php2js($k).':'.php2js($v);
  return '{'.join(',',$result).'}';
 }
}

function REQUEST($name)
{
 if (isset($_REQUEST[$name]))
 {
  return $_REQUEST[$name];
 }
 return NULL;
}

function REQUEST_SET($name,$val)
{
 $_REQUEST[$name]=$val;
}

class OM
{
 // type
 // LastError

 var $id;
 var $__ExtVars;
 var $__SharedVars;

 function __set($name,$value) { if ($this->IsSharedVar($name)) {  $this->SetSharedVar($name,$value); } else { global $SESSION_OM; $_SESSION[$SESSION_OM][$this->id][$name]=$value; } }
 function __get($name) { if ($this->IsSharedVar($name)) {return $this->GetSharedVar($name);} global $SESSION_OM; return $_SESSION[$SESSION_OM][$this->id][$name]; }
 private function IsSharedVar($name) {global $SESSION_OM; return isset($_SESSION[$SESSION_OM][$this->id]['__SharedVarsTable'][$name]);}
 private function SetSharedVar($name,$value) { $f=fopen($this->GetSharedVarPath($name),'w'); fwrite($f,serialize($value)); fclose($f); $this->__SharedVars[$name]=$value; }
 private function GetSharedVar($name) { if ($this->__SharedVars[$name]!==NULL) {return $this->__SharedVars[$name];} $vp=$this->GetSharedVarPath($name); if (!file_exists($vp)) {return NULL;} $this->__SharedVars[$name]=unserialize(file_get_contents($vp)); return $this->__SharedVars[$name]; }
 private function GetSharedVarPath($name) {global $SESSION_OM; return $_SESSION[$SESSION_OM][$this->id]['__SharedVarsTable'][$name]; }
 function InitSharedVar($name,$path) { global $OPTIONS; global $SESSION_OM; $this->__SharedVars[$name]=NULL; $_SESSION[$SESSION_OM][$this->id]['__SharedVarsTable'][$name]=$OPTIONS['DataPath'].'/OM_shared/'.$path; @mkdir(dirname($this->__SharedVarsTable[$name]),0777,true); }

 function OM($id=0,$type='')
 {
  $this->__ExtVars=array();
  if ($type=='') $type='OM';
  if ($id<=0)
  {
   $this->OM_CreateNew($type);
  }
  else
   $this->id=$id;
 }

 function OM_CreateNew($type)
 {
  global $SESSION_OM;
  global $OPTIONS;
  $id=0;
  if ($type=='') $type='OM';
  if (
      (isset($_SESSION[$SESSION_OM])) &&
      (is_array($_SESSION[$SESSION_OM]))&&
      (count($_SESSION[$SESSION_OM])>0)
     )
  {
   $l=end($_SESSION[$SESSION_OM]);
   $id=$l['id']+1;
  }
  else
  {
   $id=1;
  }

  $this->SetId($id);
  $this->type=$type;

  if ($id==1)
  {
   //$_SESSION['db1'][]='Create 1: '.var_export(debug_backtrace(),true);
 
  }

//  $this->dbg=var_export(debug_backtrace(),true);
 }

 function Dispose($id=0)
 {
  global $OPTIONS;
  if ($id==0) $id=$this->id;
/*  if ($id==1)
  {
   $f=fopen($OPTIONS['DataPath'].'/om1','a');
   fwrite($f,'REMOVE OM1 '."\n".var_export(debug_backtrace(),true));
   fclose();
  }*/
  foreach($this->__ExtVars as $name=>$reg)
   if (isset($_SESSION[$SESSION_OM][$id][$name]))
    @unlink($OPTIONS['DataPath'].'/OM_objects/'.$_SESSION[$SESSION_OM][$id][$name]);
  global $SESSION_OM;
  $_SESSION[$SESSION_OM][$id]='';
  unset ($_SESSION[$SESSION_OM][$id]);
 }

 function GetId()
 {
  return $this->id;
 }

 function SetId($id)
 {
  global $SESSION_OM;
  $this->id=$id;
  $_SESSION[$SESSION_OM][$id]['id']=$id;
 }

 function GetType()
 {
  return $this->type;
 }

 function GetAsArray()
 {
  global $SESSION_OM;
  return $_SESSION[$SESSION_OM][$this->id];
 }

 function SetFromArray($ar)
 {
  global $SESSION_OM;
  $id=$this->GetId();
  unset($ar['id']);
  $_SESSION[$SESSION_OM][$id]=$ar;
  $_SESSION[$SESSION_OM][$id]['id']=$id;
 }

 function Dump()
 {
  global $SESSION_OM;
  echo '<pre>';
  print_r($_SESSION[$SESSION_OM][$this->id]);
  echo '</pre>';
 }

 function rDump()
 {
  global $SESSION_OM;
  return var_export($_SESSION[$SESSION_OM][$this->id],true);
 }

 function SetError($code)
 {
  $this->LastError=$code;
  return $code;
 }

 function PrintArr($ar)
 {
  echo '<pre>';
  print_r($ar);
  echo '</pre>';
 }

 function recursive_remove_directory($directory, $empty=FALSE)
 {
     if(substr($directory,-1) == '/')
     {
         $directory = substr($directory,0,-1);
     }
     if(!file_exists($directory) || !is_dir($directory))
     {
         return FALSE;
     }elseif(is_readable($directory))
     {
         $handle = opendir($directory);
         while (FALSE !== ($item = readdir($handle)))
         {
             if($item != '.' && $item != '..')
             {
                 $path = $directory.'/'.$item;
                 if(is_dir($path)) 
                 {
                     $this->recursive_remove_directory($path);
                 }else{
                     unlink($path);
                 }
             }
         }
         closedir($handle);
         if($empty == FALSE)
         {
             if(!rmdir($directory))
             {
                 return FALSE;
             }
         }
     }
     return TRUE;
 }

 function CollectGarbage()
 {
  global $OPTIONS;
  $handler = opendir($OPTIONS['DataPath'].'/OM_objects');
  while ($file = readdir($handler)) 
  {
   // if file isn't this directory or its parent, add it to the results
   if ($file != "." && $file != "..") 
   {
    if (time()-filemtime($OPTIONS['DataPath'].'/OM_objects/'.$file)>3600)
     unlink($OPTIONS['DataPath'].'/OM_objects/'.$file);
   }
  }
 }
};


class OMShared
{
 // type
 // LastError

 var $_id;
 var $_mutex;
 var $_fname;
 var $_ro;
 var $_cache;

 function OMShared($id='')
 {
  global $OPTIONS;
  $this->_id=$id;
  $this->_fname=$OPTIONS['DataPath'].'/Shared/'.$this->_id;
  $this->_ro=false;
 }

 function SetReadOnly()
 {
  $this->Lock();
  $this->cache=$this->_GetAsArray();
  $this->_ro=true;
  $this->UnLock();
 }

 function __set($name,$value)
 {
  if ($this->_ro) {$this_cache[$name]=$value; return;}
  $this->Lock();
  $c=$this->_GetAsArray();
  $c[$name]=$value;
  $this->_SetFromArray();
  $this->UnLock();
 }

 function __get($name)
 {
  if ($this->_ro) return $this->_cache[$name];
  $this->Lock();
  $c=$this->_GetAsArray();
  $this->UnLock();
  return $c[$name];
 }

 function GetId()
 {
  return $this->_id;
 }

 function SetId($id)
 {
  $this->_id=$id;
 }

 function GetAsArray()
 {
  if ($this->_ro) return $this->_cache;
  $this->Lock();
  $c=$this->_GetAsArray();
  $this->UnLock();
  return $c;
 }

 function SetFromArray($ar)
 {
  if ($this->_ro) {$this->_cache=$ar; return;}
  $this->Lock();
  $this->_SetFromArray($ar);
  $this->UnLock();
 }
 
 function Dump()
 {
  print_r($this->rDump());
 }

 function rDump()
 {
  return var_export($this->GetAsArray(),true);
 }

 private function Lock()
 {
  $this->_mutex=new Mutex($this->_fname,5); //5 sec for live
  $this->_mutex->waitLock();
 }

 private function UnLock()
 {
  $this->_mutex->releaseLock();
 }
 
 private function _GetAsArray()
 {
  // lock unsafe
  if ($this->_id=='') return array();
  $f='';
  if (file_exists($this->_fname))  $f=file_get_contents($this->_fname);
  if ($f=='') return array();
  return unserialize($f);
 }

 private function _SetFromArray($ar)
 {
  if ($this->_id=='') return;
  $f=fopen($this->_fname,'w');
  fwrite($f,serialize($ar));
  fclose($f);
 }

};
