<?php 
require_once(dirname(__FILE__) . "/OM.php");

class Record extends OM
{
 // Content
 // mfn
 // Status
 // RecVersion

 function Record($id)
 {
  $this->OM($id,'Record');
 }

 function GetContentA()
 {
  return $this->Content;
 }

 function SetContentA($cont)
 {
  $this->Content=$cont;
 }

 function GetVersion()
 {
 	return $this->RecVersion;
 }
 
 function SetVersion($ver)
 {
 	$this->RecVersion=$ver;
 }
 
 function GetStatus()
 {
  return $this->Status;
 }

 function SetStatus($s)
 {
  $this->Status=$s;
 }

 function GetAsIrbRec($wheaders=true)
 {
  $rec=$this->GetContent();
  $res='';
  if ($wheaders)
   $res.=$this->GetMfn()."#".$this->GetStatus()."\r\n0#".$this->GetVersion()."\r\n";
  if (!is_array($rec)) return '';
  foreach ($rec as $field=>$occs)
  {
   if (is_numeric($field))
    if (is_array($occs)) foreach ($occs as $occ=>$val)
     $res.=$field.'#'.$val."\r\n";
  }
  return $res;
 }

 function GetMfn()
 {
  return $this->mfn;
 }

 function SetMfn($mfn)
 {
  $this->mfn=$mfn;
 }

 function Clear()
 {
  $this->SetContentA(array());
  $this->SetMfn(-1);
  $this->SetStatus(0);
  $this->SetVersion(0);
 }

 static function ParseField($field)
 {
  $res=array();
  $f='^*'.$field;
  $fa=explode('^',$f);
  foreach ($fa as $sfd) if ($sfd!='') if (substr($sfd,1)!='') $res[strtoupper($sfd{0}.'')]=substr($sfd,1);
  return $res;
 }

 function GetFieldAsString(array $field)
 {
  $res='';
  foreach($field as $subf=>$data)
  {
   if ($subf==='*') $res=$data.$res;
   else $res.=('^'.$subf.$data);
  }
  return $res;
 }

 function ParseIrbisRec($r,$wheaders=true)
 {
  $this->Clear();
  $rec=array();
  if (!is_array($r))
  {
   $r=str_replace("\n","\r",$r);
   $r1=explode("\r",$r);
  }
  else
   $r1=$r;
  if ($wheaders)
  {
   if ($r1[0]!=0)
   {
    return $this->SetError(ER_OK);
   }
   $rm1=explode('#',$r1[1]);
   $this->SetMfn($rm1[0]);
   $this->SetStatus($rm1[1]);
   if ($this->GetMfn()<=0) $this->SetMfn(-1);
   $rm1=explode('#',$r1[2]);
   if ($rm1[1]!='')
    $this->SetVersion($rm1[1]);
   else
    $this->SetVersion($r1[2]);
   unset($r1[0]);
   unset($r1[1]);
   unset($r1[2]);
  }
  $r=$r1;
  foreach($r as $f)
  {
   $pos = strpos($f, "#");
   if (!is_integer($pos)) {
      // not found...
   }
   else
   {
    $rec[substr($f,0,$pos)][]=$this->ParseField(substr($f,$pos+1));
   }
  }
  $this->SetContentA($rec);
  return $this->SetError(ER_OK);
 }

 function ParseIrbisTxtRec($r,$codepage='utf-8')
 {
  $this->Clear();
  $rec=array();
  $r1=array();
  if (!is_array($r))
  {
   $r1=explode("\r",$r);
  }
  else
   $r1=$r;
  $r=$r1;
  foreach($r as $f)
  {
   $pos = strpos($f, ": ");
   if (!is_integer($pos)) {
      // not found...
   }
   else
   {
    $rec[substr($f,1,$pos-1)][]=$this->ParseField(substr($f,$pos+2));
   }
  }
  $this->SetContentA($rec);
  return $this->SetError(ER_OK);
 }

 function ParseIrbisTxtExpRec($r,$codepage='utf-8')
 {
  $this->Clear();
  $rec=array();
  $r1=array();
  if (!is_array($r))
  {
   $r1=explode("\r",$r);
  }
  else
   $r1=$r;
  $r=$r1;
  foreach($r as $f)
  {
   $fs=trim($f,"\r\n");
   if ($codepage!='utf-8') $fs=iconv($codepage,'utf-8',$fs);
   $pos = strpos($fs, ": ");
   if (!is_integer($pos)) {
      // not found...
   }
   else
   {
    $rec[substr($fs,1,$pos-1)][]=$this->ParseField(trim(substr($fs,$pos+2),"\n\r"));
   }
  }
  $this->SetContentA($rec);
  return $this->SetError(ER_OK);
 }


 function FieldDelete($field,$occ)
 {
  $c=$this->GetContentA();
  if (!isset($c[$field][$occ-1])) return;
  $o=$occ;
  while (isset($c[$field][$o]) )
  {
   $c[$field][$o-1]=$c[$field][$o];
   $o++;
  }
  unset($c[$field][$o-1]);
  $this->SetContentA($c);
 }

 function FieldDeleteAllOcc($field)
 {
  $c=$this->GetContentA();
  unset ($c[$field]);
  $this->SetContentA($c);
 }

 function FieldAddA($field,array $value)
 {
  $c=$this->GetContentA();
  $c[$field][]=$value;
  $this->SetContentA($c);
 }

 function FieldAdd($field,$value)
 {
  $c=$this->GetContentA();
  if (!is_array($c)) $c=array();
  if (!is_array($c[$field])) $c[$field]=array();
  $c[$field][]=$this->ParseField($value);
  $this->SetContentA($c);
  return count($c[$field]);
 }

 function GetFieldOcc($fld)
 {
  $c=$this->GetContentA();
  if (!is_array($c)) $c=array();
  if (!is_array($c[$fld])) $c[$fld]=array();
  return count($c[$fld]);
 }

 function GetField($fld,$occ)
 {
  $c=$this->GetContentA();
  if (!is_array($c[$fld][$occ-1])) return '';
  return $this->GetFieldAsString($c[$fld][$occ-1]);
 }

 function SetField($fld,$occ,$val)
 {
  $cnt=$this->GetContentA();
  $cnt[$fld][$occ-1]=$this->ParseField($val);
  $this->SetContentA($cnt);
 }

 function GetFieldA($fld,$occ)
 {
  $c=$this->GetContentA();
  return $c[$fld][$occ-1];
 }

 function SetFieldA($fld,$occ,array $val)
 {
  $cnt=$this->GetContentA();
  $cnt[$fld][$occ-1]=$val;
  $this->SetContentA($cnt);
 }

 function GetFieldAA($fld)
 {
  $c=$this->GetContentA();
  return $c[$fld];
 }

 function SetFieldAA($fld,array $arval)
 {
  $cnt=$this->GetContentA();
  $cnt[$fld]=$arval;
  $this->SetContentA($cnt);
 }


 function CopyField($fldfrom,$occfrom,$fldto,$occto)
 {
  $cnt=$this->GetContentA();
  $cnt[$fldfrom][$occfrom-1]=$cnt[$fldto][$occto-1];
  $this->SetContentA($cnt);
 }

 function CopyFieldAllOcc($fldfrom,$fldto)
 {
  $cnt=$this->GetContentA();
  $cnt[$fldfrom]=$cnt[$fldto];
  $this->SetContentA($cnt);
 }

 function MoveField($fldfrom,$occfrom,$fldto,$occto)
 {
  $cnt=$this->GetContentA();
  $cnt[$fldfrom][$occfrom-1]=$cnt[$fldto][$occto-1];
  unset($cnt[$fldfrom][$occfrom-1]);
  $this->SetContentA($cnt);
 }

 function MoveFieldAllOcc($fldfrom,$fldto)
 {
  $cnt=$this->GetContentA();
  $cnt[$fldfrom]=$cnt[$fldto];
  unset($cnt[$fldfrom]);
  $this->SetContentA($cnt);
 }
 
 function GetSubField($fld,$occ,$subfield)
 {
  $c=$this->GetContentA();
  return $c[$fld][$occ-1][strtoupper($subfield).''];
 }

 function SetSubField($fld,$occ,$subf,$val)
 {
  $c=$this->GetContentA();
  $c[$fld][$occ-1][strtoupper($subf).'']=$val;
  $this->SetContentA($c);
 }

 function RemoveSubField($fld,$occ,$subf)
 {
  $c=$this->GetContentA();
  unset($c[$fld][$occ-1][strtoupper($subf).'']);
  $this->SetContentA($c);
 }

 function GetContent()
 {
  $c=$this->GetContentA();
  $res=array();
  foreach ($c as $fld=>$occa)
  {
   foreach ($occa as $occ=>$flda)
   {
    if (is_array($flda)) $res[$fld][$occ]=$this->GetFieldAsString($flda);
   }
  }
  return $res;
 }

 function SetContent($cont)
 {
  $res=array();
  foreach ($cont as $fld=>$occa)
  {
   foreach ($occa as $occ=>$fldt)
   {
    $res[$fld][$occ]=$this->ParseField($fldt);
   }
  }
  $this->Content=$res;
 }

 function ParseFromJson($rec)
 {
  $this->Clear();
  if ($rec=='') return;
  $c=array();
  $rec=json_decode(stripslashes($rec));
  if (is_object($rec->data)) foreach($rec->data as $fld=>$flddata)
  {
   $c[$fld]=$flddata->data;
  }
  $this->SetContent($c);
 }
 
 function ParseFromEditorJson($json)
 {
 	$this->Clear();
 	$t=json_decode($json,true);
 	//print_r($t);
	$this->SetMfn($t['mfn']);
	$this->SetVersion($t['ver']);
	$c=array();
	if (is_array($t['data'])) foreach ($t['data'] as $fld=>$fldinf)
	{
		$c[$fld]=$fldinf['data'];
	}
	$this->SetContent($c);	
 }

    function SetFromMarc($mrc, $cp)
    {
        $this->Clear();
        $len = strlen($mrc);
        if ($len < 25)
            return - 141;
        $leader['recsize'] = substr($mrc, 0, 5);
        if ((int)$leader['recsize'] != (int)$len)
            return - 141;
        $leader['recstatus'] = substr($mrc, 5, 1);
        $leader['rectype'] = substr($mrc, 6, 1);
        $leader['recbiblevel'] = substr($mrc, 7, 1);
        $leader['rectreelevel'] = substr($mrc, 8, 1);
        $leader['flen'] = substr($mrc, 10, 1);
        $leader['sflen'] = substr($mrc, 11, 1);
        $leader['bdataaddr'] = substr($mrc, 12, 5);
        if (($leader['bdataaddr'] < 25) || ($leader['bdataaddr'] > $leader['recsize']))
            return - 141;
        $leader['codelevel'] = substr($mrc, 17, 1);
        $leader['catform'] = substr($mrc, 18, 1);
        $dircnt = ($leader['bdataaddr'] - 25) / 12;
        $cont=array();
        $cont['999'][] = substr($mrc, 5, 20);
        for ($i = 0; $i < $dircnt; $i++) {
            $tag = substr($mrc, (24 + 12 * $i), 3);
            $flen = substr($mrc, (27 + 12 * $i), 4);
            $fstart = substr($mrc, (31 + 12 * $i), 5);
            $fld = substr($mrc, $fstart + $leader['bdataaddr'], $flen - 1);
            if ($fstart + $flen > $leader['recsize'])
                return - 141;
            $fld = str_replace("\x1F", '^', $fld);
            if ($cp!='utf-8')
             $fld = iconv($cp, 'utf-8', $fld);
            $cont[$tag][] = $fld;
        }
        $this->SetContent($cont);
        return 0;
    }


    function GetLeader()
    {
     $c=$this->GetContentA();
     $leader='';
     if (strlen($c['leader'])==24) return $c['leader'];
     $v999=$this->GetField(999,1);
     if (strlen($v999)==24) return $v999;
     if (strlen($v999)==8) return sprintf("#####%s22#####%s450 ", substr($v999,0,5), substr($v999,5,3));
     return '#####nam  22##### i 450 ';
    }

    function GetAsMarc($codepage='utf-8',$R_DELIM="\x1D",$F_DELIM="\x1E",$S_DELIM="^")
    {
     $nRecLen=25; // = +.  
     $nDataLen=0;
     $nDirLen;
     $marker='';
     $dir='';
     $data='';
     $leader=$this->GetLeader();
     trigger_error('leader='.$leader,E_USER_NOTICE);
     $MD=substr($leader,5,5).substr($leader,17,3);//'00000000';
     $sRes='';
     $c=$this->GetContent();
     foreach ($c as $tag=>$flddata)
     {
      foreach ($flddata as $occ=>$s)
      {
       if ($s{0}==' ') $s{0}='#';
       if ($s{1}==' ') $s{1}='#';
       if ($codepage!='utf-8') $s=iconv('utf-8',$codepage,$s);
       if ($S_DELIM!='^') $s=str_replace('^',$S_DELIM,$s);
       $s.=$F_DELIM;
       if (
             ($nDataLen+$nDirLen+24+strlen($dir)+strlen($s)<=99999)&&
             (strlen($s)<=9999)&&
             ($tag<999)&&($tag>0)
           )
       {
        $dir.=sprintf('%03d%04d%05d',$tag,strlen($s),$nDataLen);
        $data.=$s;
        $nDataLen+=strlen($s);
        $nDirLen+=12;
       }
      }
     }
     $marker=sprintf("%05d%s22%05d%s450 ",strlen($data)+26+strlen($dir), substr($MD,0,5), 25+strlen($dir), substr($MD,5,3));
     return $marker.$dir.$F_DELIM.$data.$R_DELIM;
    }


    function GetAsJson()
    {
     $c=$this->GetContentA();
     return json_encode($c);
    }

    function GetAsXml()
    {
     $c=$this->GetContentA();
     $CR="\r\n";
     $leader=$this->GetLeader();
     $res='<record>'.$CR.'<mrk>'.$CR.'<m_0_4 len="5">'.substr($leader,0,5).'</m_0_4>'.$CR.'<m_5_5 len="1">'.substr($leader,5,1).'</m_5_5>'.$CR.'<m_6_6 len="1">'.substr($leader,6,1).'</m_6_6>'.$CR.'<m_7_7 len="1">'.substr($leader,7,1).'</m_7_7>'.$CR.'<m_8_8 len="1">'.substr($leader,8,1).'</m_8_8>'.$CR.'<m_9_9 len="1">'.substr($leader,9,1).'</m_9_9>'.$CR.'<m_10_10 len="1">'.substr($leader,10,1).'</m_10_10>'.$CR.'<m_11_11 len="1">'.substr($leader,11,1).'</m_11_11>'.$CR.'<m_12_16 len="5">'.substr($leader,12,5).'</m_12_16>'.$CR.'<m_17_17 len="1">'.substr($leader,17,1).'</m_17_17>'.$CR.'<m_18_18 len="1">'.substr($leader,18,1).'</m_18_18>'.$CR.'<m_19_19 len="1">'.substr($leader,19,1).'</m_19_19>'.$CR.'<m_20_23 len="4">'.substr($leader,20,4).'</m_20_23>'.$CR.'</mrk>'.$CR;
     foreach ($c as $tag=>$fdata)
     {
      foreach ($fdata as $occ=>$fld)
      {
       $res.='<FIELD.'.$tag.'>';
       foreach($fld as $sf=>$sfdata) $res.='<SUBFIELD.'.$sf.'>'.$sfdata.'</SUBFIELD.'.$sf.'>';
       $res.='</FIELD.'.$tag.'>'.$CR;
      }
     }
     $res.='</record>'.$CR;
     return $res;
    }

    function GetAsIrbText()
    {
     $c=$this->GetContent();
     $CR="\r\n";
     $res='';
     foreach ($c as $tag=>$fdata)
     {
      foreach ($fdata as $occ=>$fld)
      {
       $res.='#'.$tag.': '.$fld.$CR;
      }
     }
     $res.='*****'.$CR;
     return $res;
    }

    function ApplyFst($apath, $dbid, $name)
    {                   // dbid
      require_once(dirname(__FILE__) . "/DB.php");
      $db=new DB($dbid);
      if (substr_count($name,'.FST')==0) $name.='.FST';
      $fst=$db->GetFile($apath,$name);
      if ($fst < 0) return $fst;

      // getpft by fst
      $l = explode("\n", $fst);
      $pft = '';
      $cnt = 0;
      if (is_array($l))
          foreach ($l as $k => $str) {
              if (trim(substr($str, 6), " \n\r\t") != '') {
                  if ($cnt > 0)
                      $pft .= ",";
                  $cnt++;
                  $tag = '';
                  $j = 0;
                  while (($str{$j} >= '0') && ($str{$j} <= '9')) {
                      $tag .= $str{$j};
                      $j++;
                  }
                  $pft .= "'\x01" . $tag . "\x02'," . trim(substr($str, $j + 3));
              }
          }
      //$ff=fopen('pft','w');
      //fwrite($ff,$pft);
      //fclose($ff);
      //format
      //trigger_error('PFT: '.$pft,E_USER_NOTICE);
      $res = $db->RecVirtualFormat($pft, $this);
      //trigger_error('PFT res: '.$res,E_USER_NOTICE);
      //apply res to cur rec
      if ($res < 0)  return $res;
      $this->Clear();
      $m1 = explode("\x01", $res);
      if (is_array($m1))
       foreach ($m1 as $m2) 
       {
        $tag = '';
        $j = 0;
        while (($m2{$j} >= '0') && ($m2{$j} <= '9')) 
        {
            $tag .= $m2{$j};
            $j++;
        }
        $tag = $tag + 0;
        $f = substr($m2, $j + 1);
        if (($tag > 0) && ($f != ''))
        {
         $f1=explode("\r",$f);
         foreach($f1 as $f2)
          if (trim($f2,"\r\n")!='')
            $this->FieldAdd($tag, trim($f2,"\r\n"));
        }
       }
     return 0;
    }

    function ApplyGbl($dbid, $gblname,&$res)
    {
     if (strpos($fgblname,'.gbl128')!==false) $gblname=substr($gblname,0,-7);
     if ($dbid<1) return '';
     if ($gblname=='') return '';
     $db=new DB($dbid);
     $fname=dirname(__FILE__).'/gbl/';
     if (file_exists($fname.$db->GetName().'/'.$gblname.'.user.gbl128')) $fname=$fname.$db->GetName().'/'.$gblname.'.user.gbl128';
     else if (file_exists($fname.$db->GetName().'/'.$gblname.'.gbl128')) $fname=$fname.$db->GetName().'/'.$gblname.'.gbl128';
     else if (file_exists($fname.$gblname.'.user.gbl128')) $fname=$fname.$gblname.'.user.gbl128';
     else if (file_exists($fname.$gblname.'.gbl128')) $fname=$fname.$gblname.'.gbl128';
     else return '';
     require_once($fname);
     $cname='Gbl128_'.$gblname;
     $c=new $cname;
     return $c->DoWork($db,$this,$res);
    }

    function SetFromRecord(Record $r)
    {
     global $SESSION_OM;
     $id=$this->id;
     $_SESSION[$SESSION_OM][$id]=$_SESSION[$SESSION_OM][$r->GetId()];
     $_SESSION[$SESSION_OM][$id]['id']=$id;
  //   $this->Contetnt=$r->GetContent();
  //   $this->SetMfn($r->GetMfn());
  //   $this->SetStatus($r->GetStatus());
  //   $this->SetVersion($r->GetVersion());
    }

    function GetBrief($dbid)
    {
     require_once(dirname(__FILE__) . "/../formats/brief.php");
     require_once(dirname(__FILE__) . "/DB.php");
     $db=new DB($dbid);
     $c=new IBIS($db,$this);
     return $c->brief();
    }
}

?>