<?php 

class RecordSet extends OM
{

 // var $Content
 // var $Count
 // var $Mfns
 // var $SearchExp
 // var $SearchSeq
 // var $CurPos
 // var $SearchDbId
 var $LoadPortion;

 function RecordSet($id)
 {
  $this->OM($id,'RecordSet');
  $this->Clear();
  $this->LoadPortion=50;
 }

 function __destruct() 
 { // may be not?
  $cont=$this->Content;
  foreach ($cont as $rec) $rec->Dispose($rec->GetId());
  $this->Content=array();
 }

 function Clear()
 {
  $cont=$this->Content;
  if (is_array($cont)) foreach ($cont as $rec) $rec->Dispose($rec->GetId());
  $this->Content=array();
  $this->Count=0;
  $this->Mfns=array();
  $this->SearchExp='';
  $this->SearchSeq='';
  $this->CurPos=0;
  SearchDbId=0;
 }

 function SetFromSearch(DB $db, $Search, $Posl='')
 {
  $this->Clear();
  $fr=$db->FindRecords($Search,$Posl,1,$this->LoadPortion);
  if (!is_array($fr)) return $fr; if ($fr[0]<0) return $fr[0];
  $this->SearchExp=$Search;
  $this->SearchSeq=$Posl;
  $this->Count=$fr[0];
  $cont=$this->Content;
  for ($i=1;$i<=$fr[0];$i++)
  {
   $this->Mfns[$i]=$fr[$i]->GetMfn();
   $cont[$i]=$fr[$i]->GetId();
  }
  $this->SearchDbId=$db->GetId();
  $this->SeekFirst();
  return ER_OK;
 }

 function SeekFirst()
 {
  if ($this->Count>0) $this->CurPos=1 else $this->CurPos=0;
  return $this->Load();
 }

 function SeekLast()
 {
  $this->CurPos=$this->Count;
  return $this->Load();
 }

 function SeekNext()
 {
  if ($this->CurPos<$this->Count) { $this->CurPos++; return $this->Load(); }
  return FALSE;
 }

 function SeekPrev()
 {
  if ($this->CurPos>1) { $this->CurPos--; return $this->Load(); }
  return FALSE;
 }

 function JumpTo($pos)
 {
  if (($pos>0) && ($pos<=$this->Count)) { $this->CurPos=$pos; return $this->Load(); }
  return FALSE;
 }

 function GetCurrent()
 {
  if ($this->CurPos<1) return FALSE;
  $r = new Record($this->Content[$this->CurPos]);
  return r;
 }

 private function Load()
 {
  $cp=$this->CurPos;
  if($cp<1) return FALSE;
  if ($cp>$this->Count) return FALSE;
  if (isset($this->Mfns[$cp])) return TRUE;
  $mn=min($this->Count,$cp+$this->LoadPortion);
  if (($this->SearchDbId>0)&&(($this->SearchExp!='') || ($this->SearchSeq!='')))
  {
   $db=new DB($this->SearchDbId);
   for ($i=$mn;(($i>=$cp) && isset($this->Mfns[$i]));$i--) $mn--; //try to minimize range if end loaded
   $fr=$db->FindRecords($this->SearchExp,$this->SearchSeq,$cp,$mn-$cp+1);
   if (!is_array($fr)) return FALSE; if ($fr[0]<0) return FALSE;
   foreach($fr as $k=>$r)
   {
    $this->Content[$k+$cp-1]=$r->GetId();
    $this->Mfns[$k+$cp-1]=$r->GetMfn();
   }
  }
  else return FALSE;
 }

}

?>