﻿<?php 

// group types
define("GT_SID", 1); // Наследовать права от sid
define("GT_SITE", 2); // Права, заданные на сайте
define("GT_CHB", 3); // ЧБ
define("GT_FAK", 4);
define("GT_NAPR", 5);
define("GT_SPEC", 6);
define("GT_VO", 7);
define("GT_FO", 8);
define("GT_SEM", 9);
define("GT_GROUP", 10);
define("GT_KAT", 11);
define("GT_IP", 12);
define("GT_LIB",13); // Является читателем некоторой библиотеки

// User Rights
define("UR_VIEW", 1); // 00000000 00000001
define("UR_EDIT", 2); // 00000000 00000010
define("UR_DELETE", 4); // 00000000 00000100
define("UR_ADDSUB", 8); // 00000000 00001000

define("UR_R_VIEW", 256); // 00000001 00000000
define("UR_R_EDIT", 512); // 00000010 00000000
define("UR_R_DELETE", 1024); // 00000100 00000000
define("UR_R_ADDSUB", 2048); // 00001000 00000000

define("UR_OWNER", 65535); // 11111111 11111111

define('UA_USER', 1); // 0000 0000 0000 0001
define('UA_ADMIN', 65535); // 1111 1111 1111 1111

define('FLD_CHB', 30);
define('FLD_KAT', 50);
define('FLD_STUD', 90);

// Sequrity errors
define('ER_SIDNOTFOUND', -1001);
define('ER_SIDDUBLETFOUND', -1002);

define('DB_IBIS',1);

define("MODULESID_SECURITY", '00000000000000000000000000000009');

require_once (dirname(__FILE__) . "/OM.php");
require_once (dirname(__FILE__) . "/DB.php");


class LibInfo extends OM
{
	// sid
	/* var LibInfoStruct - часть LNS
	     	array
		 	(
		 		'Name'=>string,
		 		'i128url'=>string,
		 		'DbList':array [Name]
				(
					$Name=>Array
					(
						Desc:string,
						Type:string,
						ProviderData:array,
						IsIbis:bool,
   						IsRdr:bool,
						IsCmpl:bool,
						IsVuz:bool
					)
				)
			)
	*/
	
	function LibInfo($id = 0)
	{
		$this->OM($id, 'LibInfo');
	}
	function SetSid($sid)
	{
		$this->sid=$sid;
	}
	function SetName($Name)
	{
		$lis=$this->LibInfoStruct;
		$lis['Name'] = $Name;
		$this->LibInfoStruct=$lis;
	}
	function GetName()
	{
		$lis=$this->LibInfoStruct;
		return $lis['Name'];
	}
	function GetInfoBySid($sid)
	{
		// Обращаемся к LNS-серверу за данными о библиотеке и заполняем данными структуру LibInfoStruct
	}
}

class UserInfo extends OM
{
	// var UserInfByLib // 1 user may be in several libraries... So type of this variable is array.  There are each element is array (sid=>(LibInfoId,RdrRecId))
	// var bIsUserSiteRootAdmin
	// var UID // Уникальный идентификатор пользователя

	function UserInfo($id = 0)
	{
		$this->OM($id, 'UserInfo');
	}
	function IsHaveRights($groupname)
	{
	} //must check have user SITE rights or not
	function GetChb($lib)
	{
		$uibl = $this->UserInfByLib;
		if ($uibl[$lib]['RdrRecId'] > 0)
		{
			$r = new Record($uibl[$lib]['RdrRecId']);
			return $r->GetField(FLD_CHB, 1);
		}
		else
		{
			return '';
		}
	} // return chb of user
	function IsUserInStud($lib, $studinfo)
	{
		$uibl = $this->UserInfByLib;
		$uisubf = array('fak' => 'A', 'year' => '0', 'sem' => 'F', 'group' => 'E', 'fo' =>
			'O', 'vo' => 'V', 'ins' => 'J', 'napr' => 'N', 'spec' => 'C', 'kafv' => 'D');
		if ($uibl[$lib]['RdrRecId'] > 0)
		{
			$r = new Record($uibl[$lib]['RdrRecId']);
			$mocc = $r->GetFieldOcc(FLD_STUD);
			for ($i = 1; $i <= $mocc; $i++)
			{
				$res = true;
				foreach ($studinfo as $key => $val)
				{
					$res = (($res) && ($r->GetSubField(FLD_STUD, $i, $uisubf[$key]) == $val));
				}
				if ($res) return $res;
			}
			return false;
		}
		else
		{
			return false;
		}
	}
	function IsUserInLib($lib)
	{
		$uibl = $this->UserInfByLib;
		return isset($uibl[$lib]);
	}
	function IsUserInFak($lib, $fak)
	{
		return IsUserInStud($lib, array('fak' => $fak));
	}
	function IsUserInNapr($lib, $napr)
	{
		return IsUserInStud($lib, array('napr' => $napr));
	}
	function IsUserInSpec($lib, $spec)
	{
		return IsUserInStud($lib, array('spec' => $spec));
	}
	function IsUserInVo($lib, $vo)
	{
		return IsUserInStud($lib, array('vo' => $vo));
	}
	function IsUserInFo($lib, $fo)
	{
		return IsUserInStud($lib, array('fo' => $fo));
	}
	function IsUserInSem($lib, $sem)
	{
		return IsUserInStud($lib, array('sem' => $sem));
	}
	function IsUserInGroup($lib, $group)
	{
		return IsUserInStud($lib, array('group' => $group));
	}
	private function IsInUserRecField($lib, $fld, $val)
	{
		$uibl = $this->UserInfByLib;
		if ($uibl[$lib]['RdrRecId'] > 0)
		{
			$r = new Record($uibl[$lib]['RdrRecId']);
			$mocc = $r->GetFieldOcc($fld);
			for ($i = 1; $i <= $mocc; $i++)
			{
				if ($r->GetField($fld, $i) == $val) return true;
			}
			return false;
		}
		else
		{
			return false;
		}
	}
	function IsUserInKat($lib, $kat)
	{
		return $this->IsInUserRecField($lib, FLD_KAT, $kat);
	}

	function IsUserSiteRootAdmin()
	{
		return $this->bIsUserSiteRootAdmin;
	}
	function GetUserLibsIdArray()
	{
		$uibl = $this->UserInfByLib;
		$res=array();
		foreach ($uibl as $lib=>$uibla)
		{
			$res[]=$lib;
		}
		return $res;
	}
	function GetUID()
	{
		$uid=$this->UID;
		return $uid;
	}
}

class Security extends OM
{

	// var $DbIcSysId
	// var UserInfo
	// var IpRangesForCurUser

	function Security($id, $dbIcSysId)
	{
		$this->OM($id, 'Sequrity');
		$this->DbIcSysId = $dbIcSysId;
		$this->CalculateIpRangesForCurUser();
	}

	function CalculateIpRangesForCurUser()
	{
		// Load IPRANGES
		$dbIcSysId = $this->dbIcSysId;
		if ($dbIcSysId > 0)
		{
			$db = new DB($dbIcSysId);
			$iprs = $db->FindRecords('V=IPRANGE');
			$ipr = array();
			if (is_array($iprs))
			{
				for ($i = 1; $i <= $iprs[0]; $i++)
				{
					$r = $iprs[$i];
					for ($j = 1; $j <= $r->GetFieldOcc(3004); $j++)
					{
						if (($r->GetSubField(3004, $j, 'A') <= $this->NormalizeIp($_SERVER['REMOTE_ADDR'])) &&
							($this->NormalizeIp($_SERVER['REMOTE_ADDR']) <= $r->GetSubField(3004, $j, 'B')))
						{
							$ipr[$r->GetSubField(3001, 1, 'A')][] = array('startip' => $r->GetSubField(3004,
								$j, 'A'), 'endip' => $r->GetSubField(3004, $j, 'B'));
						}
					}
				}
			}
			$this->IpRangesForCurUser = $ipr;
			$db->FindRecordsClearResult($iprs);
		}
	}

	private function NormalizeIp($ip)
	{
		$m = explode('.', $ip);
		return sprintf('%03d.%03d.%03d.%03d', $m[0], $m[1], $m[2], $m[3]);
	}
	private function GetDbIcSysId()
	{
		return $this->DbIcSysId;
	}

	function SetUserInfo($ui)
	{
		$this->UserInfo = $ui;
	}

	function ConstructField3002($lib, $grouptype, $groupname, $rights, $isAnd)
	{
		return "^A$lib^B$grouptype^C$groupname^D$rights^E$isAnd";
	}

	function DeleteOwner($sid)
	{
		$db = new DB($this->GetDbIcSysId());
		$rec=$this->FindSidRecord($sid); if ($rec<0) return $rec;
		$rec->SetSubField(3001, 1, 'C', '');
		$db->SaveAndUpdateRecord($rec, true);
	}

	function IsHaveRights($sid, $rights)
	{
		$r = $this->GetUserRights($sid);
		return (((int)$r & (int)$rights) == (int)$rights);
	}

	function IsHaveRightsView($sid)
	{
		return $this->IsHaveRights($sid, UR_VIEW);
	}

	function IsHaveRightsEdit($sid)
	{
		return $this->IsHaveRights($sid, UR_EDIT);
	}

	function IsHaveRightsDelete($sid)
	{
		return $this->IsHaveRights($sid, UR_DELETE);
	}

	function IsHaveRightsAddSub($sid)
	{
		return $this->IsHaveRights($sid, UR_ADDSUB);
	}

	function IsHaveRightsViewRights($sid)
	{
		return $this->IsHaveRights($sid, UR_R_VIEW);
	}

	function IsHaveRightsEditRights($sid)
	{
		return $this->IsHaveRights($sid, UR_R_EDIT);
	}

	function IsHaveRightsDeleteRights($sid)
	{
		return $this->IsHaveRights($sid, UR_R_DELETE);
	}

	function IsHaveRightsAddSubRights($sid)
	{
		return $this->IsHaveRights($sid, UR_R_ADDSUB);
	}

	function IsUserInGroup($lib, $grouptype, $groupname)
	{
		// Булева функа. Определяет принадлежит ли текущий пользователь указанной группе
		$u = new UserInfo($this->UserInfo);
		//if (($grouptype != GT_IP) && (!$u->IsUserInLib($lib))) return false; // нужно еще что-то придумать для пользователей ВНЕШНИХ библиотек
		switch ($grouptype)
		{
			case GT_SID:
				return false;
				break;
			case GT_SITE:
				return ($u->IsHaveRights($groupname));
				break;
			case GT_CHB:
				return ($u->GetChb($lib) == $groupname);
				break;
			case GT_FAK:
				return $u->IsUserInFak($lib, $groupname);
				break;
			case GT_NAPR:
				return $u->IsUserInNapr($lib, $groupname);
				break;
			case GT_SPEC:
				return $u->IsUserInSpec($lib, $groupname);
				break;
			case GT_VO:
				return $u->IsUserInVo($lib, $groupname);
				break;
			case GT_FO:
				return $u->IsUserInFo($lib, $groupname);
				break;
			case GT_SEM:
				return $u->IsUserInSem($lib, $groupname);
				break;
			case GT_GROUP:
				return $u->IsUserInGroup($lib, $groupname);
				break;
			case GT_KAT:
				return $u->IsUserInKat($lib, $groupname);
				break;
			case GT_IP:
				$ip = $this->NormalizeIp($_SERVER['REMOTE_ADDR']);
				$irfcu=$this->IpRangesForCurUser;
				if (is_array($irfcu[$groupname]))
				{
					$res=false;
					foreach($irfcu[$groupname] as $g)
					{
						$res=($res||(($g['startip']<=$ip)&&($ip<=$g['endip'])));
					}
					return $res;
				}
				return false;
				break;
			case GT_LIB:
				return $u->IsUserInLib($groupname);
				break;
			default:
				return false;
		}
		return false;
	}

	function GetUserRights($sid)
	{
		global $OPTIONS;
		$u=new UserInfo($this->UserInfo);
		if($u->IsUserSiteRootAdmin()) return UR_OWNER;
		$rights = 0;
		$isAnd = false;
		$isOwner = false;
		$Module = '';
		$ulibs=$u->GetUserLibsIdArray();
		$db=new DB($this->DbIcSysId);
		// читаем запись дескриптора безопасности
		$sidrec=$this->FindSidRecord($sid); if ($sidrecs<0) return $rights;
		// Является ли юзер владельцем объекта
		if (($sidrec->GetSubField(3001, 1, 'B') != '') && ($sidrec->GetSubField(3001, 1, 'B') ==
			$u->GetUID())) 
		{
			$sidrec->Dispose($sidrec->GetId());
			return UR_OWNER;
		}
		// Наследуем права
		if ($sidrec->GetSubField(3001, 1, 'C') != '') $rights = $this->GetUserRights($sidrec->GetSubField(3001, 1, 'C'));
		// Применяем специфические права на тип данного объекта
		$Module = $sidrec->GetSubField(3001, 1, 'E');
		if ($Module != 'MODULE')
		{
			(int)$rights |= (int)$this->GetUserRights('00000000000000000000000000000000');
		}
		$isAnd = $sidrec->GetSubField(3001, 1, 'D');
					
		foreach($ulibs as $lib)
		{
			// Берем список групп с правами на объект
			$f3002occ = $sidrec->GetFieldOcc(3002);
			for ($i = 1; $i <= $f3002occ; $i++)
			{
				if ((($rec->GetSubField(3002, $i, 'A') == '') || ($lib ==
				$sidrec->GetSubField(3002, $i, 'A'))) && ($this->IsUserInGroup($lib, $rec->
				GetSubField(3002, $i, 'B'), $rec->GetSubField(3002, $i, 'C'))))
				{
					if ($isAnd) (int)$rights = ((int)$rights & (int)$rec->GetSubField(3002, $i, 'D'));
					else  (int)$rights = ((int)$rights | (int)$rec->GetSubField(3002, $i, 'D'));
				}
			}
		}
		$sidrec->Dispose($sidrec->GetId());
		return $rights;
	}

	function GetModuleSID($modname)
	{
		$db=new DB($this->DbIcSysId);
		return $db->Search('(V=MODULES)*(MODNAME='.$modname.')','','v3001^A');
	}

	function CreateNewSID($typename, $OwnerSID = "", $isAnd = false)
	{
		$u=new UserInfo($this->UserInfo);
		if ($OwnerSID == '') $OwnerSID = $this->GetModuleSID($typename);
		$OwnerUID = $u->GetUID();
		$sid = md5(date("D\, j M Y G:i:s T").microtime());
		return '^A'.$sid.'^B'.$OwnerUID.'^C'.$OwnerSID.'^D'.$isAnd.'^E'.$typename;
	}

	function DeleteSID($sid, $rec = null)
	{
		$db=new DB($this->DbIcSysId);
		if (($this->GetUserRights($sid) & (UR_R_DELETE)) != UR_R_DELETE)
		{
			return - 6000; // Access Denied
		}
		$osid = '';
		if (($rec != null) && ($sid == $rec->GetSubField(3001, 1, 'A')))
		{
			$osid = $rec->GetSubField(3001, 1, 'C');
		}
		else
		{
			$r = $this->FindSidRecord($sid);
			if ($r < 0) return $r;
			$osid = $r->GetSubField(3001, 1, 'C');
			$r->Dispose($r->GetId());
		}
		$recs = $db->FindRecords('OSID='.$sid);
		if ($recs < 0) return $recs;
		for ($i=1; $i<=$recs[0];$i++)
		{
			$recs[$i]->SetSubField(3001, 1, 'C', $osid);
			$db->SaveAndUpdateRecord($recs[$i], true);
		}
		$db->FindRecordsClearResult($recs);
		return 0;
	}

	function GetGroupTypeName($lib, $grouptype)
	{
		switch ($grouptype)
		{
			case GT_SID:
				return "Наследовать права от";
				break;
			case GT_SITE:
				return "Права на сайте";
				break;
			case GT_CHB:
				return "Отдельный пользователь";
				break;
			case GT_FAK:
				return "Факультет";
				break;
			case GT_NAPR:
				return "Направление";
				break;
			case GT_SPEC:
				return "Специальность";
				break;
			case GT_VO:
				return "Вид обучения";
				break;
			case GT_FO:
				return "Форма обучения";
				break;
			case GT_SEM:
				return "Семестр";
				break;
			case GT_GROUP:
				return "Группа";
				break;
			case GT_KAT:
				return "Категория читателя";
				break;
			case GT_IP:
				return "IP-адрес или сеть";
				break;
			case GT_LIB:
				return "Пользователь организации";
			default:
				return "<НЕ ИЗВЕСТНО>";
		}
	}

// ----------- Отредактировано до сюда

	function GetPrintableName($grouptype, $groupname, $lib)
	{
		global $OPTIONS;
//		$rdr = UseModule('i64f')->GetLibRDR($lib);
		$res='';
		if ($grouptype==GT_SITE)
		{
			switch ($groupname)
			{
				case UA_USER:
					$res .= 'Зарегистрированный пользователь';
					break;
				case UA_ADMIN:
					$res .= 'Администратор';
					break;
			}
		}
		elseif ($grouptype==GT_LIB)
		{
			// нужно вернуть строку вида Пользователь организации "Научная библиотека ОмГУ им. Ф. М. Достоевского" 
		}
		elseif ($grouptype==GT_IP)
		{
			$db=new DB($this->DbIcSysId);
			$recs = $db->FindRecords('SID='.$groupname);
			if ((!($recs<0))&&($recs[0]==1)&&isset($recs[1]))
			{
				$r = $recs[1];
				$res .= $r->GetSubField(3003, 1, 'A');
			}
		}
		elseif ($grouptype==GT_GROUP)
		{
			$res .= $groupname;
		}
		else
		{
			$rdr=new DB(0);
			// Вот тут нужно придумать как получить в распоряжение БД Читателей библиотеки ;lib
			switch ($grouptype)
			{
				case GT_SITE:
				case GT_LIB: 
				case GT_IP:
				case GT_GROUP:
					break;
				case GT_CHB:
					$res .= $rdr->Search('SPB='.$groupname,'', "v10,' ',v11,' ',v12");
					break;
				case GT_FAK:
					$res .= $rdr->GetMnuDescByKey(APATH_DB,'fak.mnu', $groupname);
					break;
				case GT_NAPR:
					$res .= $rdr->GetMnuDescByKey(APATH_DB,'napr.mnu', $groupname);
					break;
				case GT_SPEC:
					$res .= $rdr->GetMnuDescByKey(APATH_DB,'spec.mnu', $groupname);
					break;
				case GT_VO:
					$res .= $rdr->GetMnuDescByKey(APATH_DB,'vo.mnu', $groupname);
					break;
				case GT_FO:
					$res .= $rdr->GetMnuDescByKey(APATH_DB,'fo.mnu', $groupname);
					break;
				case GT_SEM:
					$res .= $rdr->GetMnuDescByKey(APATH_DB,'sem.mnu', $groupname);
					break;
				case GT_KAT:
					$res .= $rdr->GetMnuDescByKey(APATH_DB,'50.mnu', $groupname);
					break;
				default:
					$res .= $groupname;
			}
		}
		return $res;
	}

	/*private function GetRightsListRecurse($sid, $r)
	{
		$recs = UseModule('i64f')->FindRecords('ICSYS', 'SID='.$sid);
		if (isset($recs[0]))
		{
			$rec = $recs[0];
			$f3002cnt = $rec->GetFieldOcc(3002);
			for ($i = 1; $i <= $f3002cnt; $i++)
			{
				$row1 = array();
				$row1['sid'] = $sid;
				$row1['lib'] = $rec->GetSubField(3002, $i, 'A');
				$row1['grouptype'] = $rec->GetSubField(3002, $i, 'B');
				$row1['groupname'] = $rec->GetSubField(3002, $i, 'C');
				$row1['rights'] = $rec->GetSubField(3002, $i, 'D');
				$row1['isAnd'] = $rec->GetSubField(3002, $i, 'E');
				$isfound = false;
				// Пытаемся найти такие же права
				foreach ($r as & $r1)
				{
					if (($r1['lib'] == $row1['lib']) && ($r1['grouptype'] == $row1['grouptype']) &&
						($r1['groupname'] == $row1['groupname']) && ($r1['isAnd'] == $row1['isAnd']))
					{
						$isfound = true;
						$r1['rights'] = ((int)$r1['rights'] | (int)$row1['rights']);
					}
				}
				if (!$isfound) $r[] = $row1;
			}
			$OwnerSID = $rec->GetSubField(3001, 1, 'C');
			if ($OwnerSID != '') $r = $this->GetRightsListRecurse($OwnerSID, $r);
		}
		return $r;
	}*/

	function SetOwnerSID($owner, $sid)
	{
		$db=new DB($this->DbIcSysId);
		$rec=$this->FindSidRecord($sid); if ($rec<0) return $rec;
		$rec->SetSubField(3001, 1, 'C', $owner);
		$db->SaveAndUpdateRecord($rec,true);
	}
	
	private function FindSidRecord($sid)
	{
		$db=new DB($this->DbIcSysId);
		$recs = $db->FindRecords('SID='.$sid);
		if ($recs<0) return $recs;
		if ($recs[0] < 1) return ER_SIDNOTFOUND;
		if ($recs[0] > 1)
		{
			$db->FindRecordsClearResult($recs);
			return ER_SIDDUBLETFOUND;
		}
		return $recs[1];
	}
}
;

?>