<?php 
require_once(dirname(__FILE__) . "/OM.php");
require_once(dirname(__FILE__) . "/DB.php");

class WS extends OM
{

 // Content
 // RecId

 function WS($id=0)
 {
  $this->OM($id,'WS');
 }

 function LoadWS($dbid,$name)
 {
  $this->Name=$name;
  $db=new DB($dbid);
  $this->Content=array();
  $ws=array();
  if (substr_count($name,'.ws')==0) $name.='.ws';
  $r=$db->GetFile(APATH_DB,$name);
  //trigger_error('wsname: '.$name,E_USER_NOTICE);
  if ($r=='')
  {
   $this->Content=$ws;
   return ER_OK;
  }
  $m=explode("\n",trim($r));
  $RLC=$m[0];
  $pos=1+2*$RLC;
  $sc=count($m);
  for ($i=0;$i<$sc;$i++)
   $m[$i]=iconv('windows-1251','UTF-8',trim($m[$i]));
  for ($i=0;$i<$RLC;$i++)
  {
    $ws[$m[$i+1]]['fldcount']=$m[$i+$RLC+1];
  }
  foreach($ws as $key=>$rl)
  {
   if ($key{0}=='@')
   {
    unset($ws[$key]);
    $sr=$this->LoadWS($dbid,substr($key,1));
    if ($sr==ER_OK)
    {
     $sr=$this->Content;
     $this->Content=array();
    }
    else
    {
     $this->SetError($sr);
     $this->Content=array();
     return $sr;
    }
    $ws=array_merge($ws,$sr);
   }
   else
   {
    for ($i=0;$i<$rl['fldcount'];$i++)
    {
     $b=$pos+10*$i;
     $rl['ee']=$ws[$m[$b]];
     $rl[$m[$b]]['caption']=$m[$b+1];
     $rl[$m[$b]]['repeat']=$m[$b+2];
     $rl[$m[$b]]['helpid']=$m[$b+3];
     $rl[$m[$b]]['inmode']=$m[$b+4];
     $rl[$m[$b]]['dopinf']=$m[$b+5];
     $rl[$m[$b]]['flk']=$m[$b+6];
     $rl[$m[$b]]['help']=$m[$b+7];
     $rl[$m[$b]]['default']=$m[$b+8];
    }
    $pos+=(10*$rl['fldcount']);
    if ($key{0}!='@')
    {
     $ws[$key]=$rl;
    }
   }
  }
  $this->Content=$ws;
  return ER_OK;
 }

 function GetFieldDefaultValue($fld)
 {
  $ws=$this->Content;
  if (is_array($ws)) foreach ($ws as $rl)
  {
   if (is_array($rl)) foreach ($rl as $key=>$f)
   {
    if ( ($key!='fldcount') && ($key!='ee'))
    {
     if ($key==$fld)
     {
      if ($f['default']!='') return $f['default'];
     }
    }
   }
  }
  return '';
 }

 function ApplyToRec($recid)
 {
  $this->RecId=$recid;
  require_once(dirname(__FILE__) . "/Record.php");
  $rrec=new Record($recid);
  //$rec=$rrec->Content;
  $ws=$this->Content;
  if (is_array($ws)) foreach ($ws as $rl)
  {
   if (is_array($rl)) foreach ($rl as $key=>$f)
   {
    if ( ($key!='fldcount') && ($key!='ee'))
    {
     if (($f['default']!='')&&($rrec->GetField($key,1)==''))
      $rrec->SetField($key,1,$f['default']);
     if ($key=='920') $rrec->SetField($key,1,$f['default']);
    }
   }
  }
  //$rrec->Content=$rec;
  return $this->SetError(ER_OK);
 }

 function RecSetField($field,$occ,$value)
 {

 }

 function JS_GetRLList($wsname,$recid,$dbid)
 {
  $RLItemsUrl='../vidget/WS.php?op=GetRLList&dbid='.$dbid.'&recid='.$recid.'&wsname='.urlencode($wsname);
  $this->RecId=$recid;
  $res=array();
  $cont=$this->Content;
  $recid=$this->RecId;
  if (is_array($cont)) foreach($cont as $key=>$val)
  {
   if ($key!='resultcode')
   {
    $res[]="{
           title: '".$key."',
           autoScroll:true,
           layout:'fit',
           listeners:
           {
            activate: function(tab)
            {
             while (tab.items.length>0) tab.remove(tab.items.length-1);
             wsbbar=new Irbis.WsBBar();
             fnClick=function(sm,rowIndex,r)
             {
              grid.wsbbar.setText(r.get('Help'));
             };
             var occaction = new Ext.ux.grid.RowAction
	     ({
		qtip:'Добавить новое повторение поле',
		menuDisabled:true,header: '№',dataIndex:'Occ',resizable:false,fixed:true,align:'center'
	     });
             var grid=new Ext.grid.EditorGridPanel
             ({
               bbar:wsbbar,
               store: new Ext.data.JsonStore
               ({
                 url: '".$RLItemsUrl."'+'&RL=".urlencode($key)."',
                 root: 'RLItems',
                 bbar:wsbbar,
                 fields: ['FieldId','Desc','Field','Occ','Value','HelpId','DopInf','InMode','Help'],
                 autoLoad:true,
                 listeners:
                 {
                  datachanged:function(store)
                  {
                   store.commitChanges();
                  },
                  update:function(store,record,index)
                  {
                   if (index==Ext.data.Record.COMMIT)
                   {
                    Ext.Ajax.request({
                       url: '../vidget/WS.php',
                       params: 
                       { 
                        op: 'WsRecFieldSet',
                        field: record.get('Field'),
                        occ: record.get('Occ'),
                        value: record.get('Value'),
                        recid:'".$recid."'
                       }
                    });
                   }
                  }
                 }
               }),
               autoShow:true,
               viewConfig: 
               {
                 forceFit: true, autoFill:true
               },
               clicksToEdit:1,
               sm: new Ext.grid.CheckboxSelectionModel({listeners:{rowselect: fnClick},moveEditorOnEnter:true,singleSelect:false,width:20}),
               plugins:[occaction],
               columns:
               [
                new Ext.grid.CheckboxSelectionModel({singleSelect:false,width:20}),
                {renderer:function(v,m,r){m.css+=' x-grid3-cell-disabled';m.attr='ext:qtip=\"'+r.get('Help')+' \" ext:qtitle=\"'+r.get('Desc')+'\"';return v;},menuDisabled:true,header: 'Название элемента',width:200,dataIndex:'Desc',resizable:false,fixed:true},
                //
                occaction,
                {
                 header: 'Значение',
                 width:160,
                 dataIndex:'Value',
                 editor: new Irbis.FieldEditor({db:$dbid,ds:this,host:'../classes/json.php'}),
		 menuDisabled:true,
		 renderer:function(v,m,r){m.attr='ext:qtip=\"'+v+' \" ';return v;},
                 resizable:false
                },
               ],
               stripeRows: true,
               autoExpandColumn: 'Value'
             });
             grid.wsbbar=wsbbar;
             tab.add(grid);
             tab.doLayout();
            }
           }
           }";
   }
  }
  return $res;
 }
};
?>