<?php 
require_once(dirname(__FILE__) . "/OM.php");
require_once(dirname(__FILE__) . "/DB.php");
require_once(dirname(__FILE__) . "/ARM.php");

class WSS extends OM
{

 // Name
 // Content

 function WSS($id)
 {
  $this->OM($id,'WSS');
 }

 function LoadWSS($dbid,$name)
 {
  $this->Name=$name;
  $db=new DB($dbid);
  $arm=new ARM(1/*$db->GetArmId()*/);
  $this->Content=array();
  $wss=array();
  if (substr_count($name,'.wss')==0) $name.='.wss';
  $r=$db->GetFile(APATH_DB,$name);
  if ($r=='')
  {
   $this->Content=$wss;
   return ER_OK;
  }
  $m=explode("\n",$r);
  $FC=$m[0];
  $pos=1;
  $sc=count($m);
  for ($i=0;$i<$sc;$i++)
   $m[$i]=iconv('windows-1251','UTF-8',trim($m[$i]));

  for ($i=0;$i<$FC;$i++)
  {
   $b=1+10*$i;
   $sf=$m[$b];
   $wss[$sf]=array();
   $wss[$sf]['Desc']=$m[$b+1];
   $wss[$sf]['Repeat']=$m[$b+2];
   $wss[$sf]['HelpId']=$m[$b+3];
   $wss[$sf]['InMode']=$m[$b+4];
   $wss[$sf]['DopInf']=$m[$b+5];
   $wss[$sf]['flk']=$m[$b+6];
   $wss[$sf]['Help']=$m[$b+7];
   $wss[$sf]['default']=$m[$b+8];
   if ($wss[$sf]['InMode']==2)
   {// $wss[$sf]['DopInf'] = "IBIS,A=,fmt"
    $l=strlen($wss[$sf]['DopInf']);
    $ii=0; $j=0;
    $dbn='';
    $pref='';
    $fmt='';
    for ($ii=0;(($wss[$sf]['DopInf']{$ii}!=',')&&($ii<$l));$ii++);
    $dbn=substr($wss[$sf]['DopInf'],0,$ii);
    for ($j=$ii+1;(($wss[$sf]['DopInf']{$j}!=',')&&($j<$l));$j++);
    $pref=substr($wss[$sf]['DopInf'],$ii+1,$j-$ii-1);
    $fmt=substr($wss[$sf]['DopInf'],$j+1);
    if ($dbn=='')
    {
     $wss[$sf]['SearchCfg']['db']=$dbid;
    }
    else
     $wss[$sf]['SearchCfg']['db']=$arm->GetDbIdByName($dbn);
//    $wss[$sf]['SearchCfg']['db']=$ii;
    $wss[$sf]['SearchCfg']['pref']=$pref;
    $wss[$sf]['SearchCfg']['fmt']=$fmt;
   }
  }
  $this->Content=$wss;
  return ER_OK;
 }

 function SetField($val)
 {
  $wss=array();
  $l=strlen($val);
  $s='*';
  for ($pos=0;$pos<$l;$pos++)
  {
   if ($val{$pos}=='^')
   {
    $pos++;
    if ($pos<$l)
    {
     $s=$val{$pos};
     $wss[$s]='';
    }
   }
   else
   {
    $wss[$s].=$val{$pos};
   }
  }
  $cn=$this->Content;
  foreach($cn as $s=>$d)
  {
   $cn[$s]['Value']=$wss[$s];
  }
  $this->Content=$cn;
//  print_r($this->Content);
  return $this->SetError(ER_OK);
 }

 function GetAsJson()
 {
  $res='{totalCount:'.count($this->Content).', RecList: [';
  $cnt=0;
  $cn=$this->Content;
  if (is_array($cn)) foreach($cn as $s=>$d)
  {
   if ($cnt>0) $res.=','; $cnt++;
   $res.='{sf:"'.$s.'",caption:"'.addslashes($d['Desc']).'",ftext:"'.addslashes($d['Value']).'",helpid:"'.addslashes($d['HelpId']).'",dopinf:"'.addslashes($d['DopInf']).'",inmode:'.$d['InMode'].',help:"'.addslashes($d['Help']).'",SearchInfo:{';
   if ($d['InMode']==2)
    $res.='Pref:"'.addslashes($d['SearchCfg']['pref']).'",Db:'.$d['SearchCfg']['db'].',Fmt:"'.addslashes($d['SearchCfg']['fmt']).'"';
   $res.='}}';
  }
  $res.=']}';
  return $res;
 }
};
?>