<?php 

require_once (dirname(__FILE__) . "/Record.php");
require_once (dirname(__FILE__) . "/DB.php");

class format 
{
 
 var $r;                 // record for formating
 var $db;                // database
 var $occ;               // current occurence
 var $occtotal;          // total occurences
 var $pos;               // position in pft
 var $pft;               // pft body
 var $pftlen;            // pft length
 var $groupres;          // group format result
 var $groupstartpos;     // group start position
 // literals
 var $literalleft;
 var $literalright;
 var $repeatedliteralleft;
 var $repeatedliteralleftplus;
 var $repeatedliteralright;
 var $repeatedliteralrightplus;
 
 function format(DB $db, Record $r) 
 {
  $this->r=$r; 
  $this->db=$db;
  $this->occ=0;
  $this->groupres=''; // 
  $this->pos=0;
  $this->pft='';
  $this->pftlen=0;
  $this->occtotal=0;
  $this->groupstartpos=0;
  $this->literalleft='';
  $this->literalright='';
  $this->repeatedliteralleft='';
  $this->repeatedliteralleftplus=false;
  $this->repeatedliteralright='';
  $this->repeatedliteralrightplus=false;
 }
 
 private function shift($cnt=1)
 {
  $this->pos=$this->pos+$cnt;
 }
 
 private function symb() 
 {
  $this->shift();
  return $this->pft{$this->pos-1};
 }
 
 private function symbprobe($shift=0) 
 {
  return $this->pft{$this->pos+$shift};
 }
 
 private function back()
 {
  $this->pos--;
 }
 
 private function notend() {  return ($this->pos!=$this->pftlen); }
 
 private function v()
 { //v910^a*1.1  // Always return array!
  //echo $this->symb();
  mb_internal_encoding('utf-8');
  if ($this->symb()=='v')
  {
   //$this->shift();
   $fld=$this->ParseNumber();
   $subf='';
   $shift=0;
   $len=0;
   if($this->symbprobe()=='^') {$this->shift(); $subf=$this->symb();}
   if($this->symbprobe()=='*') {$this->shift(); $shift=$this->ParseNumber();}
   if($this->symbprobe()=='.') {$this->shift(); $len=$this->ParseNumber();}
   $c=array();
   if(isset($this->Cache['v'][$fld.'^'.$subf.'*'.$shift.'.'.$len]))
   {
    $c=$this->Cache['v'][$fld.'^'.$subf.'*'.$shift.'.'.$len];
    $c=$this->ParseRepeatedLiteralRight($c);
    return $c;
   }
   $focc=$this->r->GetFieldOcc($fld);
   if ($subf=='')
   {
    for ($i=1;$i<=$focc;$i++)
    {
     if ($len>0) $c[]=mb_substr($this->r->GetField($fld, $i),$shift,$len); else $c[]=mb_substr($this->r->GetField($fld, $i),$shift);
    }
   }
   else 
   {
    for ($i=1;$i<=$focc;$i++)
    { 
     if($len>0) $c[]=mb_substr($this->r->GetSubField($fld, $i, $subf),$shift,$len,'utf-8'); 
     else $c[]=mb_substr($this->r->GetSubField($fld, $i, $subf),$shift);
    }
   }
   $this->Cache['v'][$fld.'^'.$subf.'*'.$shift.'.'.$len]=$c;
   $c=$this->ParseRepeatedLiteralRight($c);
   return $c; 
  }
  else return array('***Internal Error (v)***');
 }
 
 private function ParseNumber()
 {
  $res=0;
  while (is_numeric($this->symbprobe())) $res=10*$res+$this->symb();
  return $res;
 }
 
 private function ParseString($delim)
 {
  if ($this->symb()!=$delim) return '***Internal Error (Parse String delimiter)***';
  $res='';
  $c=$this->symb();
  while (($c!=$delim) && ($this->notend()))
  {
   $res.=$c;
   $c=$this->symb();
  }
  if ($c!=$delim) return '***Unexpected end of string. End of format found***';
  return $res;
 }

 private function ParseRepeatedLiteralLeft()
 {
  $l=$this->ParseString('|');
  $plus='';
  if ($this->symbprobe()=='+') $plus=$this->symb();
  $c=$this->ParseCommand();
  foreach($c as $oc=>$str)
  {
   if (($oc>0)|| (($oc==0)&&($plus==''))) $c[$oc]=$l.$str;
  }
  return $c;
 }
 
 private function ParseRepeatedLiteralRight(array $c)
 {
  $plus='';
  if (($this->symbprobe()=='+')&&($this->symbprobe(1)=='|')) $plus=$this->symb();
  if ($this->symbprobe()=='|')
  {
   $rl=$this->ParseString('|');
   $loc=count($c)-1;
   foreach($c as $oc=>$str)
   {
    if (($oc<$loc) || (($oc==$loc)&&($plus==''))) $c[$oc]=$str.$rl;
   }
  }
  return $c;
 }
 
 private function ParseLiteralLeft() 
 {
  $c=array();
  if ($this->symbprobe()=='"')
  {
   $ll.=$this->ParseString('"');
   $c=$this->ParseCommand();
   $k=implode('',$c);
   if ($k!='') $c[0]=$ll.$c[0];
  }
  return array($c); 
 }
 
 private function ParseLiteralRight($c)
 {
  if ($this->symbprobe()=='"')
  {
   $rl.=$this->ParseString('"');
   while($this->symbprobe()=='"') $rl.=$this->ParseString('"');
   $k=implode('',$c);
   if ($k!='') $c[count($c)-1]=$c[count($c)-1].$rl;
  }
  return $c; 
 }
 
 private function ParseCommand()
 {
  //echo $this->symbprobe().'-'.$this->pos.'~';
  switch ($this->symbprobe())
  {
   case '"': return $this->ParseLiteralLeft();
   case '|': return $this->ParseRepeatedLiteralLeft();
   case 'v': return $this->ParseLiteralRight($this->v()); break;
   default: $this->shift(); return array('***Syntax error ['.$this->pos.']: '.$this->symbprobe().'***'."\n"); 
  }
 }
 
 function Exec($pft)
 {
  $this->pft=$pft;
  $this->pftlen=strlen($this->pft);
  $res='';
  while($this->pos<$this->pftlen)
  {
   $res.=implode('',$this->ParseCommand());
  }
  return $res;
 }
}

?>