<?php

require_once(dirname(__FILE__) . "/mnu.php");

class Format128
{

 function Format128()
 {
 }

 function Fmt(DB $db,Record $r,$name,$formatstorage='',$params=array())
 {
  //echo "\n-----------------[ '.$name.' ]--------------------------------\n";
  $fn=dirname(__FILE__).'/formats/';
  if ($formatstorage=='') $formatstorage=$r->GetField(920,1);
  if ($formatstorage!='') $fn.=trim($formatstorage,'/').'/';
  $fn.=($name.'.pft128');

  $fsc=str_replace('/','_',$formatstorage);
  $fsc=str_replace("\\",'_',$formatstorage);
  $cn='i128Format_'.$fsc;
  if ($fsc!='') $cn.='_';
  $cn.=$name;

  global $I128FORMATS;
  if (isset($I128FORMATS[$cn])) 
  {
   $c=$I128FORMATS[$cn]; 
   $resf=$c->Fmt($db,$r,$params);
   //echo $resf."\n--- END ".$name."\n";
   return $resf;
  }
  
  if (file_exists($fn.'.user'))
  {
   require_once($fn.'.user');
  }
  else
  {
   if(file_exists($fn))
   {
    require_once($fn);
   }
   else
   {
    //echo '*** NOFORMAT ***';
    return '';
   }
  }
  $fc=new $cn;
  $I128FORMATS[$cn]=$fc;
  $resf=$fc->Fmt($db,$r,$params);
  //print_r($resf);
  //echo "\n-----------------[ END $fn ]--------------------------------\n";
  return $resf;
 }
};


class FormatHelper
{

 var $r;
 var $db;
 var $res;
 var $Cache;

 function FormatHelper()
 {
 }

 function __destruct() 
 {
  $this->DeInit();
 }

 function Init(DB $db, $r=null)
 {
  $this->db=$db;
  $this->r=$r;
  $this->Cache=array('mnu'=>array());
 }

 function DeInit()
 {
  $this->ClearRs();
 }

 function SubFmt($name,$formatstorage='',$params=array())
 {
  $fmt=new Format128;
  $res=$fmt->Fmt($this->db,$this->r,$name,$formatstorage,$params);
  return $res;
 }

 function ClearRs()
 {
  if (isset($this->Cache['rs'])) foreach($this->Cache['rs'] as $key=>$rs)
  {
   $rs=$this->Cache['rs'][$key]['rs'];
   if (is_array($rs) && ($rs[0]>0)) $this->db->FindRecordsClearResult($rs);
  }
  unset($this->Cache['rs']);
 }

 function GetRs($search,$seq='')
 {
  $rskey=md5($search.'/'.$seq);
  $jrs=array();
  if (isset($this->Cache['rs'][$rskey]))
  {
   $jrs=$this->Cache['rs'][$rskey]['rs'];
  }
  else
  {
   $jrs=$this->db->FindRecords($search,$seq,1,1);
   $this->Cache['rs'][$rskey]['rs']=$jrs;
  }
  return $jrs;
 }

 function occs($fld)
 {
  return $this->r->GetFieldOcc($fld);
 }
 
 function uslliteral($v,$prefix,$postfix='')
 {
  if ($v!='') return $prefix.$v.$postfix;
  else return $v;
 }
 
 function prepostfix(array $vals,$prefixtype='',$prefix='',$postfixtype='',$postfix='')
 {
  $res='';
  foreach ($vals as $k=>$v)
  {
   if ($v!='')
   {
    if ($prefixtype=='|') $res.=$prefix;
    if (($prefixtype=='|+') && ($k>0)) $res.=$prefix;
    $res.=$v;
    if ($postfixtype=='|') $res.=$postfix;
    if (($postfixtype=='+|') && ($k>0)) $res.=$postfix;
   }
  }
  if (($res!='') && ($prefixtype=='"')) $res=($prefix.$res);
  if (($res!='') && ($postfixtype=='"')) $res=($res.$postfix);
  return $res;
 }

 function v($fld,$occ=0,$subf='',$prefixtype='',$prefix='',$postfixtype='',$postfix='')
 {
  $res='';
  $startocc=1;
  $endocc=$this->r->GetFieldOcc($fld);
  if ($occ>0)
  {
   $startocc=$occ;
   $endocc=min($occ,$endocc);
  }
  $prep=array();
  for ($i = $startocc; $i <= $endocc; $i++)
  {
   $v='';
   if ($subf=='') $v=$this->r->GetField($fld, $i);
   else $v=$this->r->GetSubField($fld, $i, $subf);
   if ($v!='')
   {
    $prep[]=$v;
   }
  }
  
  return $this->prepostfix($prep,$prefixtype,$prefix,$postfixtype,$postfix);
 }

 function d($fld,$occ=0,$subf='',$prefixtype='',$prefix='',$postfixtype='',$postfix='')
 {
  $res='';
  $startocc=1;
  $endocc=$this->r->GetFieldOcc($fld);
  if ($occ>0)
  {
   $startocc=$occ;
   $endocc=min($occ,$endocc);
  }
  $prep=array();
  for ($i = $startocc; $i <= $endocc; $i++)
  {
   $v='';
   if ($subf=='') $v=$this->r->GetField($fld, $i);
   else $v=$this->r->GetSubField($fld, $i, $subf);
   if ($v!='')
   {
    $prep[]=v;
   }
  }
  foreach ($prep as $k=>$v)
  {
   if ($prefixtype=='|') $res.=$prefix;
   if (($prefixtype=='|+') && ($k>0)) $res.=$prefix;
   if ($postfixtype=='|') $res.=$postfix;
   if (($postfixtype=='+|') && ($k>0)) $res.=$postfix;
  }
  if ((count($prep)>0) && ($prefixtype=='"')) $res.=($prefix.$res);
  if ((count($prep)>0) && ($postfixtype=='"')) $res.=($res.$postfix);
  return $res;
 }

 function n($fld,$occ=0,$subf='',$prefixtype='',$prefix='',$postfixtype='',$postfix='')
 {
  $res='';
  $startocc=1;
  $endocc=$this->r->GetFieldOcc($fld);
  if ($occ>0)
  {
   $startocc=$occ;
   $endocc=min($occ,$endocc);
  }
  $prep=array();
  for ($i = $startocc; $i <= $endocc; $i++)
  {
   $v='';
   if ($subf=='') $v=$this->r->GetField($fld, $i);
   else $v=$this->r->GetSubField($fld, $i, $subf);
   if ($v=='')
   {
    $prep[]='';
   }
  }
  return $this->prepostfix($prep,$prefixtype,$prefix,$postfixtype,$postfix);
 }

 function p($fld,$occ=0,$subf='')
 {
  $focc=$this->r->GetFieldOcc($fld);
  if ($focc==0) return false;
  if ($occ>$focc) return false;
  if ($subf=='') return true;
  if ($occ==0)
  {
   for ($i = 1; $i <= $focc; $i++)
    if ($this->r->GetSubField($fld, $i, $subf)!='') return true;
   return false;
  }
  return $this->instr($this->r->GetField($fld, $occ),'^'.$subf);
 }

 function a($fld,$occ=0,$subf='')
 {
  $focc=$this->r->GetFieldOcc($fld);
  if ($focc==0) return true;
  if ($occ>$focc) return true;
  if ($subf=='') return false;
  if ($occ==0)
  {
   for ($i = 1; $i <= $focc; $i++)
   {
    $fv=$this->r->GetField($fld, $i);
    if (($this->instr($fv,'^'.strtoupper($subf))) || ($this->instr($fv,'^'.strtolower($subf)))) return false;
   }
   return true; 
  }
  $fv=$this->r->GetField($fld, $occ);
  return !(($this->instr($fv,'^'.strtoupper($subf))) || ($this->instr($fv,'^'.strtolower($subf))));
 }

 function s($fld,$subf)
 {
  $focc=$this->r->GetFieldOcc($fld);
  $res='';
  for ($i=1;$i<=$focc;$i++)
  $res.=$this->r->GetSubField($fld, $i, $subf);
  return $res;
 }

 function instr($str,$test)
 {
  if (($test=='')||($str=='')) return FALSE;
  $res=(strstr($str, $test)!==FALSE);
  return $res;
 }
 
 function SetRecord(Record $r)
 {
  $this->r=$r;
 }

 function mnudescbykey($mnuname,$key)
 {
  $m=new mnu(0);
  if (isset($this->Cache['mnu'][$mnuname]))
   $m->Content=$this->Cache['mnu'][$mnuname];
  else 
   $m->LoadMnu($this->db->GetId(), $mnuname);
  $this->Cache['mnu'][$mnuname]=$m->Content;
  $res=$m->GetDescByKey($key);
  $m->Dispose($m->GetId());
  return $res; 
 }

 function ufG0($str,$symb)
 { //Вернуть часть строки до заданного символа (не включая его);
  $pos=strpos($str,$symb);
  if ($pos===FALSE) return $str;
  return substr($str,0,$pos);
 }

 function ufG1($str,$symb)
 { //Вернуть часть строки начиная с заданного символа (включая его);
  $pos=strpos($str,$symb);
  if ($pos===FALSE) return '';
  return substr($str,$pos);
 }

 function ufG2($str,$symb)
 { //Вернуть часть строки начиная с заданного символа (НЕ включая его);
  $pos=strpos($str,$symb);
  if ($pos===FALSE) return '';
  return substr($str,$pos+1);
 }

 function IrbisToHumanDate($idate)
 {
  $res='';
  if (substr($idate,6,2)!='') $res.=substr($idate,6,2).'.';
  if (substr($idate,4,2)!='') $res.=substr($idate,4,2).'.';
  if (substr($idate,0,4)!='') $res.=substr($idate,0,4);
  return $res;
 }

}


?>