<?php 
require_once(dirname(__FILE__) . "/OM.php");
require_once(dirname(__FILE__) . "/DB.php");
require_once(dirname(__FILE__) . "/DP.php");

class mnu extends OM
{
 // Content

 function mnu($id)
 {
  $this->OM($id,'mnu');
 }

 function ParseMnuLink($name)
 {
  $res=array();
  $rm=stripslashes(trim($name));
  $res['sorttype']=0;
  $regexp="^([^\\\\]+)[\\\\]{0,1}((SYS|DBN)*[,]*([0-9]*))*[\\\\]{0,1}(.*)$";
  $pre=ereg($regexp,$rm,$matches);
  if ($matches[5]==2) $res['sorttype']=2; else if ($matches[5]==1) $res['sorttype']=1; else $res['sorttype']=0;
  $res['apath']=APATH_DB;
  if ($matches[3]=='SYS')
   $res['apath']=APATH_SYS;
  $name=strtoupper($matches[1]);
  if (substr_count($name,'.MNU')==0) $name.='.MNU';
  $res['name']=$name;
  return $res;
 }

 function ParseMnu($textbuf)
 {
  $mnu=array();
  $m=explode("\n",$textbuf);
  for ($i=0;2*$i<count($m);$i++)
  {
   if ((trim($m[2*$i])!='*****')&&($m[2*$i]!='')&&($m[2*$i+1]!=''))
    $mnu[trim($m[2*$i],"\n\r")]=trim($m[2*$i+1],"\n\r");
  }
  $this->Content=$mnu;
  return $mnu;
 }

 function LoadDataiMnu($providerid,$name)
 {
  $dprv=new DP($providerid);
  $mnu=array();
  $pn=$this->ParseMnuLink($name);
  $this->SortType=$pn['sorttype'];

  $this->Name=$pn;
  $this->InitSharedVar('Content','DATAI/'.$pn['name']);
  if ($this->Content!==NULL)
  {
   if ($pn['sorttype']==1) ksort($mnu); elseif ($pn['sorttype']==2) asort($mnu);
   return ER_OK;
  }
  $r=iconv('windows-1251','utf-8',$dprv->GetFile(1,'',$pn['name']));
  if ($r=='')
  {
   $this->Content=$mnu;
   return ER_OK;
  }
  $mnu=$this->ParseMnu($r);
  // ⥯ 㦭 㥬
  if ($pn['sorttype']==1) ksort($mnu); elseif ($pn['sorttype']==2) asort($mnu);

  
  $this->Content=$mnu;
  return ER_OK;
 }

 function LoadMnu($dbid,$name)
 {
  $db=new DB($dbid);
  $mnu=array();
  $debug=0;
  $pn=$this->ParseMnuLink($name);
  $this->SortType=$pn['sorttype'];

  $this->Name=$pn;
  $this->InitSharedVar('Content','DATAI/'.$db->GetName().'/'.$pn['name']);
  if ($this->Content!==NULL)
  {
   if ($pn['sorttype']==1)  asort($mnu);
   if ($pn['sorttype']==2) ksort($mnu); 
   return ER_OK;
  }
  $r=iconv('windows-1251','utf-8',$db->GetFile($pn['apath'],$pn['name']));
  if ($r<0) return $r;
  if ($r=='')
  {
   $this->Content=$mnu;
   return ER_OK;
  }
  $mnu=$this->ParseMnu($r);
  if ($pn['sorttype']==1)  asort($mnu);
  if ($pn['sorttype']==2) ksort($mnu); 
  
  $this->Content=$mnu;
  return ER_OK;
 }

 function strpos($str1, $str2)
 {
  return strpos(iconv('utf-8','windows-1251',mb_strtoupper($str1,'utf-8')),iconv('utf-8','windows-1251',mb_strtoupper($str2,'utf-8')));
 }

 function GetAsJson($start=1,$limit=1000,$startval='')
 {
  $m=$this->Content;
  $res='{totalCount:'.count($m).',RecList: [';
  $cnt=0;
  $c=0;
  $l=$limit;
  if (is_array($m)) foreach ($m as $key=>$val)
  {
   if ( 
        (($limit=='')||( ($limit>0)&&($l>0)&&(($c+1)>=$start) )) &&
        (
         (($this->SortType!=2) && ( (($startval=='') || ($this->strpos($key,$startval)!==FALSE)))) ||
         (($this->SortType==2) && ( (($startval=='') || ($this->strpos($val,$startval)!==FALSE))))
        )
      )
   {
    $l--;
    if ($cnt>0) $res.=','; $cnt++;
    $res.='{key:"'.addslashes($key).'",val:"'.addslashes($val).'"}';
   }
   $c++;
  }
  $res.=']}';
  return $res;
 }
 
 function GetDescByKey($key)
 {
 	$c=$this->Content;
 	if (isset($c[$key])) return $c[$key];
	return $key;
 }
 
 function GetDescByKeyNCase($key)
 {
 	$c=$this->Content;
 	foreach($c as $k=>$val)
 	{
 	 if (mb_strtoupper($k,'utf-8')==mb_strtoupper($key,'utf-8')) return $val;
 	}
	return $key;
 }

 function GetKeyByDesc($desc)
 {
  $c=$this->Content;
  if (is_array($c)) foreach ($c as $key=>$d) if ($d==$desc) return $key;
  return false;
 }

 function SortByKey($asc=true)
 {
  $c=$this->Content;
  if (is_array($c)) { if ($asc) ksort($c); else krsort($c);}
  $this->Content=$c;
 }
 function SortByDesc($asc=true)
 {
  $c=$this->Content;
  if (is_array($c)) { if ($asc) asort($c); else arsort($c);}
  $this->Content=$c;
 }
 function Add($key,$val='')
 {
  $m=$this->Content;
  $m[$key]=$val;
  $this->Content=$m;
 }

 function GetContent()
 {
  return $this->Content;
 }
}
?>