<?php 
require_once(dirname(__FILE__).'/api.php');
require_once(dirname(__FILE__).'/../classes/DB.php');
require_once(dirname(__FILE__).'/../classes/Record.php');

/*
320 - Примечание о наличии библиографии/указателей
330 * Перечень приложений
    F - Автор (ФИО)
    X - Роль (Инвертирование ФИО допустимо?)
    C - Заглавие
    P - Пояснительный текст
481 * Приплетенные номера за другие годы
    A - Заглавие СИ приплетенных номеров
    D - Место хранения
    F - Том
    H - Кумулированные номера
    I - ISSN СИ приплетенных номеров
    Q - Год
    W - Шифр СИ приплетенных номеров
903 - Шифр выпуска
910 * Сведения об экземплярах
    A - Статус
    B - инв. номер экземпляра
    C - Дата поступления
    D - место хранения
    E - Цена экземпляра
    F - Канал поступления
    H - ш/код радиометка
    I - инв № подшивки
    K - Кол-во экземпляров для докомплектования
    L - Валюта
    M - Новое место хранения
    P - шифр подшивки в БД
    Q - Наименование коллекции
    S - Дата проверки фонда
    T - Специальное назначение фонда (ВУЗ)
    U - Номер КСУ
    V - Номер записи КС2 (номер акта списания)
    W - Номер акта передачи в другое подразделение
    X - для ЦБС/ВУЗ кол-во списываемых экземпляров
    Y - Номер акта
    Z - для ЦБС/ВУЗ количество перемещаемых экземпляров
    0 - число проверенных экземпляров
    1 - ЭКЗ (ЦБС/ВУЗ)
    2 - Число выданных экземпляров для статуса U
    = - Коэффициент многоразового использования
    ! - Реальное место хранения экземпляра
922 * Статья из журнала
    F - Первый автор
    ? -  расширение инициалов
    X - Роль (Инвертирование ФИО допустимо?)
    Q -  Функция
    Y -  Работает в данной организации?
    = -  Место работы автора
    [ - Признак формирования записи в БД ATHRA
    2 - Второй автор
    , -  расширение инициалов
    < - Роль (Инвертирование ФИО допустимо?)
    S -  Функция
    Z -  Работает в данной организации?
    + -  Место работы автора
    ] - Признак формирования записи в БД ATHRA
    3 - Третий автор
    ; -  расширение инициалов
    > - Роль (Инвертирование ФИО допустимо?)
    T -  Функция
    N -  Работает в данной организации?
    - -  Место работы автора
    / - Признак формирования записи в БД ATHRA
    W - Другие авторы
    C - Заглавие
    D - параллельное заглавие
    U - Роль (№ раздела/относится к разделу №)
    E - Сведения, относящиеся к заглавию
    G - Сведения об ответственности
    4 - Страницы
    0 - Иллюстрации
    P - Примечания о наличии библиографии
    5 - Ключевые слова (тема 1)
    6 - Ключевые слова (тема 2)
    7 - Ключевые слова (тема 3)
    L - Издательский индекс
    ! - 1-й автор (Ввод через Authority-файл)
    . - 2-й автор (Ввод через Authority-файл)
    : - 3-й автор (Ввод через Authority-файл)
    ( - Вид НТД документа
    ) - Номер документа
930 * Кумулированные номера за другой год
    A - Шифр номера из объединенного выпуска
    T - Валовый номер
    0 - Валовый номер
    1 - Валовый номер
    2 - Валовый номер
931 * дополнение к номеру
    A - валовый шифр
    B - примечание к номеру (текст)
    С - дополнение к номеру (выводится в скобках)
    D - шифр приложения к номеру
    E - вид носителя приложения к номеру
    2 - шифр отдельного номера из объединенного выпуска
    3 - -"-
    4 - -"-
933 - Шифр СИ или журнала
932 - Служебное: № статьи для копироования
934 - год
935 - том (если есть)
936 - номер, часть
937 * технологический путь
    A - Этап технологического пути
    B - Дата передачи
    C - Исполнитель (ФИО)
    D - Дата возврата
    E - Исполнитель (ФИО)
    N - Номер экземпляра
993 * Копия - микрофильм/микрофиша
    A - Носитель
    B - Шифр
    D - Место хранения
*/


class fmt_NJ extends Format
{
 
 function fmt_NJ(DB $db, $r=null)
 {
  $this->Format($db,$r);
  mb_internal_encoding('utf-8');
 }
 

 function show923()
 {
  $res='';
  $v923occ=$this->r->GetFieldOcc(923);
   for ($occ = 1; $occ <= $v923occ; $occ++) 
   {
    $res.=$this->uslliteral($this->v(923,$occ,'H','|+',' ; '), '. ');
    if (!$this->instr($this->v(923,$occ,'H'), ':'))
    {
     if ($this->p(923,$occ,'H')) $res.=$this->d(923,$occ,'I','|',', ');
     else  $res.=$this->d(923,$occ,'I','|','. ');
    }
    $res.=$this->v(923,$occ,'I').$this->v(923,$occ,'K','|','. ');
    if (!$this->instr($this->v(923,$occ,'K'), ':'))
    {
     if ($this->p(923,$occ,'K')) $res.=$this->d(923,$occ,'L','|',', ');
     else  $res.=$this->d(923,$occ,'L','|','. ');
    }
    $res.=$this->v(923,$occ,'L').$this->v(923,$occ,'M','|','. ');
    if (!$this->instr($this->v(923,$occ,'M'), ':'))
    {
     if ($this->p(923,$occ,'M')) $res.=$this->d(923,$occ,'N','|',', ');
     else  $res.=$this->d(923,$occ,'N','|','. ');
    }
    $res.=$this->v(923,$occ,'N');
   }  
   return $res;
 }

 function njname()
 {
  $res='';
  $v920=$this->r->GetField(920, 1);
  $jloaded=false; $jr=array(); $jrs=array();
  if ($v920=='NJ')
  {
   $jrs=$this->GetRs('I='.$this->r->GetField(933,1));
   if (is_array($jrs) && ($jrs[0]>0))
   {
    $jloaded=true;
    $jr=$jrs[1];
   }
   if ($jloaded)
   {
    $res.=$jr->GetSubField(200,1,'A');
   }
  }
  $res.=' ('.$this->v(933).')';
  return $res;
 }
 
 function brief()
 {
  $res='';
  $v920=$this->r->GetField(920, 1);
  if ($v920!='NJ') return '';
  $jloaded=false; $jr=array(); $jrs=array();
  $jrs=$this->GetRs('I='.$this->r->GetField(933,1));
  if (is_array($jrs) && ($jrs[0]>0))
  {
   $jloaded=true;
   $jr=$jrs[1];
  }
   
  if (($this->v(230)!='') || ($this->v(337)!='')) $res.=' [Электронный ресурс] ';
  else
  {
   if (($this->db->GetIniValue('PRIVATE', 'FPS','')=='') && ($this->v(905,0,'S')==''))
    $res.=' [Текст]';
  } 

  $v215occ=$this->r->GetFieldOcc(215);
  for ($occ = 1; $occ <= $v923occ; $occ++) 
  {
   $res.=$this->uslliteral($this->v(215,$occ,'A','|',' ; '), '. - ').$this->d(215,$occ,'1','|',' ');
   $v2151=$this->v(215,$occ,'1');
   if ($this->instr(mb_substr($v2151,2),':')) $res.=mb_substr($v2151,0,2); else $res.=$v2151;
   if (($this->p(215,$occ,'A')) && ($this->a(215,$occ,'1'))) $res.=$this->mnudescbykey('110b.mnu', '4').'.'; 
  }

  if ($jloaded)
  {
   $res.=$jr->GetSubField(200,1,'A');
   if ($jr->GetFieldOcc(230)>0) $res.=' [Электр.ресурс]';
   $res.='. - '.$this->mnudescbykey('110b.mnu',$jr->GetSubField(110,1,'B'));
  }

  $res.=$this->v(934,0,'','"',', ','"','г.');
  if ($this->p(935))
  {
   if (((mb_substr($this->v(935),1)+0)==0) && (mb_substr($this->v(935),1)!='0')) $res.=' ';
   else 
   {
    if ($jloaded)
    {
     if ($jr->GetSubField(210,1,'8')!='') $res.=' '.$jr->GetSubField(210,1,'8').' '; else $res.=' т. ';
    }
   }
   $res.=$this->v(935);
  }

  if ($this->p(936))
  {
   if (((mb_substr($this->v(936),1)+0)==0) && (mb_substr($this->v(936),1)!='0')) $res.=' ';
   else
   {
    if ($jloaded)
    {
     if ($jr->GetSubField(210,1,'9')!='') $res.=' '.$jr->GetSubField(210,1,'9').' '; else $res.=' № ';
    }
   }
   $res.=$this->v(936);
  }
  $res.=$this->v(931,0,'C','|',' (','|',')');
  return $res;
 }
 /*
==>  fi,v936 fi,| (|v931^c|)|,
  (if p(v930)then if v930^a<>''then ', ',&uf('G0/'&unifor(|G2/|v930^a)),' г.' if v930^t<>''then  ref(l("I="v933),if p(v210^8) then' 'v210^8' 'else' т. 'fi) &unifor('G0/'&unifor('G2/'&unifor(|G2/|v930^a)))fi,ref(l("I="v933),if p(v210^9) then' 'v210^9' 'else' № 'fi,),if v930^t<>''then &unifor('G2/'&unifor('G2/'&unifor(|G2/|v930^a)))else &unifor('G2/'&unifor(|G2/|v930^a))fi fi fi)
  "  (Введено оглавление)"d922
  fi,
  if v920:'NJ'then else" (Введено оглавление)"d330,
  if v920.1:'A' then
  ".- "v963^1,if a(v963^1)then" // "d463 fi,
  (| ; |+v463^7,if a(v463^7) then| ; |+v463^c fi,| : |v963^e,| / |v963^f,|. - |v463^d,| : |v463^g,
  if p(v463^c)then
  if s(v463^d,v463^g)<>''then|, |v463^j else |. - |v463^j fi,|. - |v463^v else
  ". - "|. ; |+v463^v fi,
  if p(v463^v)then| : |v463^a else|. |v463^a fi,
  if p(v463^v)then| |v463^h else". - "|.; |+v463^h fi,
  if p(v463^h)then| : |v463^i else|. |v463^i fi,|, |v463^k,
  if p(v463^k)then| : |v463^l else|. |v463^l fi,|. - |v963^p,|.- Ст.|v463^N,|.- |v463^1,
  if a(v463^1) and p(v463^s)then'. - ',mpu,&unifor('Korg.mnu|4'),'. ',mpl,fi, v463^s)
  fi fi,
  FI,&unifor('!'),&unifor('+F'),&uf('['), */
}
?>