<?php 

require_once(dirname(__FILE__).'/../classes/DB.php');
require_once(dirname(__FILE__).'/../classes/Record.php');
require_once(dirname(__FILE__).'/../classes/mnu.php');

class Format
{

 var $r;
 var $db;
 var $res;
 var $Cache;

 function Format(DB $db, $r=null)
 {
  $this->db=$db;
  $this->r=$r;
  $this->Cache=array('mnu'=>array());
 }

 function __destruct() 
 {
  $this->ClearRs();
 }

 function ClearRs()
 {
  if (isset($this->Cache['rs'])) foreach($this->Cache['rs'] as $key=>$rs)
  {
   $rs=$this->Cache['rs'][$key]['rs'];
   if (is_array($rs) && ($rs[0]>0)) $this->db->FindRecordsClearResult($rs);
  }
  unset($this->Cache['rs']);
 }

 function GetRs($search,$seq='')
 {
  $rskey=md5($search.'/'.$seq);
  $jrs=array();
  if (isset($this->Cache['rs'][$rskey]))
  {
   $jrs=$this->Cache['rs'][$rskey]['rs'];
  }
  else
  {
   $jrs=$this->db->FindRecords($search,$seq,1,1);
   $this->Cache['rs'][$rskey]['rs']=$jrs;
  }
  return $jrs;
 }

 function occs($fld)
 {
  return $this->r->GetFieldOcc($fld);
 }
 
 function uslliteral($v,$prefix,$postfix='')
 {
  if ($v!='') return $prefix.$v.$postfix;
  else return v;
 }

 function prepostfix(array $vals,$prefixtype='',$prefix='',$postfixtype='',$postfix='')
 {
  $res='';
  foreach ($vals as $k=>$v)
  {
   if ($v!='')
   {
    if ($prefixtype=='|') $res.=$prefix;
    if (($prefixtype=='|+') && ($k>0)) $res.=$prefix;
    $res.=$v;
    if ($postfixtype=='|') $res.=$postfix;
    if (($postfixtype=='+|') && ($k>0)) $res.=$postfix;
   }
  }
  if (($res!='') && ($prefixtype=='"')) $res=($prefix.$res);
  if (($res!='') && ($postfixtype=='"')) $res=($res.$postfix);
  return $res;
 }

 function v($fld,$occ=0,$subf='',$prefixtype='',$prefix='',$postfixtype='',$postfix='')
 {
  $res='';
  $startocc=1;
  $endocc=$this->r->GetFieldOcc($fld);
  if ($occ>0)
  {
   $startocc=$occ;
   $endocc=min($occ,$endocc);
  }
  $prep=array();
  for ($i = $startocc; $i <= $endocc; $i++)
  {
   $v='';
   if ($subf=='') $v=$this->r->GetField($fld, $i);
   else $v=$this->r->GetSubField($fld, $i, $subf);
   if ($v!='')
   {
    $prep[]=$v;
   }
  }
  return $this->prepostfix($prep,$prefixtype,$prefix,$postfixtype,$postfix);
 }

 function d($fld,$occ=0,$subf='',$prefixtype='',$prefix='',$postfixtype='',$postfix='')
 {
  $res='';
  $startocc=1;
  $endocc=$this->r->GetFieldOcc($fld);
  if ($occ>0)
  {
   $startocc=$occ;
   $endocc=min($occ,$endocc);
  }
  $prep=array();
  for ($i = $startocc; $i <= $endocc; $i++)
  {
   $v='';
   if ($subf=='') $v=$this->r->GetField($fld, $i);
   else $v=$this->r->GetSubField($fld, $i, $subf);
   if ($v!='')
   {
    $prep[]=v;
   }
  }
  foreach ($prep as $k=>$v)
  {
   if ($prefixtype=='|') $res.=$prefix;
   if (($prefixtype=='|+') && ($k>0)) $res.=$prefix;
   if ($postfixtype=='|') $res.=$postfix;
   if (($postfixtype=='+|') && ($k>0)) $res.=$postfix;
  }
  if ((count($prep)>0) && ($prefixtype=='"')) $res.=($prefix.$res);
  if ((count($prep)>0) && ($postfixtype=='"')) $res.=($res.$postfix);
  return $res;
 }

 function n($fld,$occ=0,$subf='',$prefixtype='',$prefix='',$postfixtype='',$postfix='')
 {
  $res='';
  $startocc=1;
  $endocc=$this->r->GetFieldOcc($fld);
  if ($occ>0)
  {
   $startocc=$occ;
   $endocc=min($occ,$endocc);
  }
  $prep=array();
  for ($i = $startocc; $i <= $endocc; $i++)
  {
   $v='';
   if ($subf=='') $v=$this->r->GetField($fld, $i);
   else $v=$this->r->GetSubField($fld, $i, $subf);
   if ($v=='')
   {
    $prep[]='';
   }
  }
  return $this->prepostfix($prep,$prefixtype,$prefix,$postfixtype,$postfix);
 }

 function p($fld,$occ=0,$subf='')
 {
  $focc=$this->r->GetFieldOcc($fld);
  if ($focc==0) return false;
  if ($occ>$focc) return false;
  if ($subf=='') return true;
  if ($occ==0)
  {
   for ($i = 1; $i <= $focc; $i++)
   if ($this->instr($this->r->GetField($fld, $occ),'^'.$subf)) return true;
   return false;
  }
  return $this->instr($this->r->GetField($fld, $occ),'^'.$subf);
 }

 function a($fld,$occ=0,$subf='')
 {
  $focc=$this->r->GetFieldOcc($fld);
  if ($focc==0) return true;
  if ($occ>$focc) return true;
  if ($subf=='') return false;
  if ($occ==0)
  {
   for ($i = 1; $i <= $focc; $i++)
   {
    $fv=$this->r->GetField($fld, $i);
    //echo $fv.'-'.$subf.'-'.var_export(($this->instr($fv,'^'.strtoupper($subf))),true).'<br>';
    if (($this->instr($fv,'^'.strtoupper($subf))) || ($this->instr($fv,'^'.strtolower($subf)))) return false;
    //echo var_export($this->instr($fv,'^'.strtoupper($subf)),true);
   }
   return true; 
  }
  $fv=$this->r->GetSubField($fld, $occ, $subf);
  return !(($this->instr($fv,'^'.strtoupper($subf))) || ($this->instr($fv,'^'.strtolower($subf))));
 }

 function s($fld,$subf)
 {
  $focc=$this->r->GetFieldOcc($fld);
  $res='';
  for ($i=1;$i<=$focc;$i++)
  $res.=$this->r->GetSubField($fld, $i, $subf);
  return $res;
 }

 function instr($str,$test)
 {
  $res=(strstr($str, $test)!==FALSE);
  //echo $str.'-'.$test.'-'.var_export($res,true).'<br>';
  return $res;
 }
 
 function SetRecord(Record $r)
 {
  $this->r=$r;
 }

 function mnudescbykey($mnuname,$key)
 {
  $m=new mnu(0);
  if (isset($this->Cache['mnu'][$mnuname]))
   $m->Content=$this->Cache['mnu'][$mnuname];
  else 
   $m->LoadMnu($this->db->GetId(), $mnuname);
  $this->Cache['mnu'][$mnuname]=$m->Content;
  $res=$m->GetDescByKey($key);
  $m->Dispose($m->GetId());
  return $res; 
 }
}
?>