<?php 
require_once(dirname(__FILE__).'/api.php');
require_once(dirname(__FILE__).'/../classes/DB.php');
require_once(dirname(__FILE__).'/../classes/Record.php');

class IBIS extends Format
{
 
 function IBIS(DB $db, $r=null)
 {
  $this->Format($db,$r);
  mb_internal_encoding('utf-8');
 }
 

 function show923()
 {
  $res='';
  $v923occ=$this->r->GetFieldOcc(923);
   for ($occ = 1; $occ <= $v923occ; $occ++) 
   {
    $res.=$this->uslliteral($this->v(923,$occ,'H','|+',' ; '), '. ');
    if (!$this->instr($this->v(923,$occ,'H'), ':'))
    {
     if ($this->p(923,$occ,'H')) $res.=$this->d(923,$occ,'I','|',', ');
     else  $res.=$this->d(923,$occ,'I','|','. ');
    }
    $res.=$this->v(923,$occ,'I').$this->v(923,$occ,'K','|','. ');
    if (!$this->instr($this->v(923,$occ,'K'), ':'))
    {
     if ($this->p(923,$occ,'K')) $res.=$this->d(923,$occ,'L','|',', ');
     else  $res.=$this->d(923,$occ,'L','|','. ');
    }
    $res.=$this->v(923,$occ,'L').$this->v(923,$occ,'M','|','. ');
    if (!$this->instr($this->v(923,$occ,'M'), ':'))
    {
     if ($this->p(923,$occ,'M')) $res.=$this->d(923,$occ,'N','|',', ');
     else  $res.=$this->d(923,$occ,'N','|','. ');
    }
    $res.=$this->v(923,$occ,'N');
   }  
   return $res;
 }

 function njname()
 {
  $res='';
  $v920=$this->r->GetField(920, 1);
  $jloaded=false; $jr=array(); $jrs=array();
  if ($v920=='NJ')
  {
   $jrs=$this->GetRs('I='.$this->r->GetField(933,1));
   if (is_array($jrs) && ($jrs[0]>0))
   {
    $jloaded=true;
    $jr=$jrs[1];
   }
   if ($jloaded)
   {
    $res.=$jr->GetSubField(200,1,'A');
   }
  }
  $res.=' ('.$this->v(933).')';
  return $res;
 }
 
 function brief()
 {
  $res='';
  $v920=$this->r->GetField(920, 1);
  $jloaded=false; $jr=array(); $jrs=array();
  if ($v920=='NJ')
  {
   $jrs=$this->GetRs('I='.$this->r->GetField(933,1));
   if (is_array($jrs) && ($jrs[0]>0))
   {
    $jloaded=true;
    $jr=$jrs[1];
   }
  }
  if ($v920=='SZPRF') $res.='Служебная запись - Проверка фонда';
  else
  {
   if (!$this->instr($v920, 'NJ'))
   {
    $res.=$this->v(503,0,'A','','','"','. ').$this->v(461,0,'X');
    $s461x=$this->s(461,'X');
    if ($s461x!='')
    {
     if ($this->instr($s461x,'.')) $res.=' ';
     else $res.='. ';
    }
   }
   $res.=$this->v(461,0,'C');
   $v46occ=$this->r->GetFieldOcc(46);
   for ($occ = 1; $occ <= $v46occ; $occ++) 
   {
    $res.=$this->v(46,$occ,'H','|','. ');
    if ($this->p(46,$occ,'I')) $res.=$this->v(46,$occ,'I','|',', '); else $res.=$this->v(46,$occ,'I','|','. ');
    $res.=$this->v(46,$occ,'K','|','. ');
    if ($this->p(46,$occ,'K')) $res.=$this->v(46,$occ,'M','|',', '); else $res.=$this->v(46,$occ,'M','|','. '); 
   }
   $res.=$this->v(461,0,'2','|',' [','|',']');
   
   if ($this->p(461)) 
   {
    if ($this->a(461,0,'2'))
    {
     $res.=$this->d(900,0,'T','"',' [').
           $this->mnudescbykey('oomr.mnu', $this->v(900,0,'T')).
           $this->d(900,0,'T','"',']');
     if($this->a(900,0,'T'))
     {
      if (($this->v(230)!='') || ($this->v(337)!='') || $this->v(135)!='')
       $res.=' [Электронный ресурс] ';
      else
      {
       if (($this->db->GetIniValue('PRIVATE', 'FPS','')=='') && ($this->v(905,0,'S')==''))
        $res.=' [Текст]';
      } 
     }      
    }
    $res.=$this->v(461,0,'E','|',' : ');
    if (!$this->p(461,0,'X'))
     $this->v(461,0,'F','|',' / ');
    $v46occ=$this->r->GetFieldOcc(46);
    for ($occ = 1; $occ <= $v46occ; $occ++) 
    {
     if (($this->v(46,$occ,'A')!='') && ($this->v(46,$occ,'V')!=''))
      $res.=$this->uslliteral($this->v(46,$occ,'A','|+',' ('), '. - (', '').$this->v(46,0,'V','|',' ; ').')';
    }
    $res.=$this->d(461,0,'','"','. ').$this->v(200,0,'V');
    if ($this->p(200,0,'V')) $res.=$this->v(200,0,'A','"',' : '); else $res.=$this->v(200,0,'A');
    if (($this->v(200,0,'V')=='') && ($this->v(200,0,'A')==''))
    {
     $v925occ=$this->r->GetFieldOcc(925);
     for ($occ = 1; $occ <= $v925occ; $occ++) 
     {
      $res.=$this->v(925,$occ,'V','|+','. ');
      if($this->p(925,$occ,'V')) $res.=$this->v(925,$occ,'A','|',' : '); else $res.=$this->v(925,$occ,'A'); 
     }
    }
   }
   if ($this->a(461))
   {
    $res.=$this->v(700,0,'A').$this->d(700,0,'D','"',' ').$this->v(700,0,'G','"',', ');
    if ($this->a(700,0,'G')) $res.=$this->v(700,0,'B','"',' ');
    $res.=$this->d(700,0,'G','"','.').$this->d(700,0,'A','"',' ');
    if ($this->p(982))
    {
     if(!$this->instr($this->v(200,0,'A'), $res.=$this->r->GetSubField(982, 1, '9')))
     {
      $res.=$this->r->GetSubField(982, 1, '0').$this->d(982,0,'0','"',' ').$this->r->GetSubField(982, 1, '9').$this->d(982,0,'9','"',' ');
     }
    }
    $res.=$this->v(200,0,'A').$this->v(200,0,'B','"',' [','"',']');
   }
   if(!$this->p(110))
   {
    //var_export($this->a(200,0,'B'));
    if (($this->p(200)) && ($this->a(200,0,'B')))
    {
     $res.=$this->d(900,0,'T','"',' [').$this->mnudescbykey('oomr.mnu', $this->r->GetSubField(900, 1, 'T')).$this->d(900,0,'T','"',']');
     if($this->a(900,0,'T'))
     {
      if (($this->v(230)!='') || ($this->v(337)!='') || ($this->v(135)!=''))
      {
       $res.=' [Электронный ресурс]';
      }
      else
      {
       $res.=$this->db->GetIniValue('PRIVATE', 'FPS','');
       if ( ($this->db->GetIniValue('PRIVATE', 'FPS','')=='') && ($this->v(905,0,'S')==''))
       {
        $res.=' [Текст]';
       }
      }
     }    
    }
   } 
  }
  $res.=$this->v(200,0,'E','|',' : ');
  if ($this->r->GetField(920, 1)=='J')
  {
   $res.=$this->show923();
  }
  else 
  {
   $v923occ=$this->r->GetFieldOcc(923);
   for ($occ = 1; $occ <= $v923occ; $occ++) 
   {
    if ($this->p(923,$occ))
    {
     if ($this->instr(v920,'SPEC')) $res.=$this->uslliteral($this->d(923,$occ,'','|+',' ; '), ', ').$this->v(923,$occ,'H');
     else $res.=$this->uslliteral($this->d(923,$occ,'','|+',' ; '), '. ').$this->v(923,$occ,'H');
     if ($this->p(923,$occ,'H')) $res.=$this->d(923,$occ,'I','|','. ');
     if (($this->r->GetSubField(923, $occ, 'K')!='') || ($this->r->GetSubField(923, $occ, 'L')!=''))
     {
      if ($this->instr(v920, 'SPEC')) $res.=', '; else $res.='. ';
     } 
     $this->v(923,$occ,'K');
     if (($this->v(923,$occ,'K')!='') || ($this->v(923,$occ,'L')!=''))
     {
      if ($v920=='SPEC') $res.=', '; else $res.='. ';
     }
     $res.=$this->v(923,$occ,'K');
     if ($this->p(923,$occ,'K')) $this->d(923,$occ,'K','|','. ');
     $res.=$this->v(923,$occ,'L');
    }
   }
   $res.= $this->v(200,0,'F','|',' / ');
   if ($v920=='J') $res.='. - '.$this->mnudescbykey('110b.mnu',$this->v(110,0,'B'), $key).$this->d(210,0,'D','"',' выходит с ','"','г.');
   else $res.=$this->v(210,0,'D','"',', ');
   if ($this->a(210,0,'D')) $res.=$this->v(461,0,'H','|',', ');
   $v215occ=$this->r->GetFieldOcc(215);
   for ($occ = 1; $occ <= $v923occ; $occ++) 
   {
    $res.=$this->uslliteral($this->v(215,$occ,'A','|',' ; '), '. - ').$this->d(215,$occ,'1','|',' ');
    $v2151=$this->v(215,$occ,'1');
    if ($this->instr(mb_substr($v2151,2),':')) $res.=mb_substr($v2151,0,2); else $res.=$v2151;
    if (($this->p(215,$occ,'A')) && ($this->a(215,$occ,'1'))) $res.=$this->mnudescbykey('110b.mnu', '4').'.'; 
   }
  }
  if ($this->instr($v920, 'NJ'))
  {
   if ($jloaded)
   {
    $res.=$jr->GetSubField(200,1,'A');
    if ($jr->GetFieldOcc(230)>0) $res.=' [Электр.ресурс]';
    $res.='. - '.$this->mnudescbykey('110b.mnu',$jr->GetSubField(110,1,'B'));
   }
   $res.=' ('.$this->v(933).')';
   $res.=$this->v(934,0,'','"',', ','"','г.');
   if ($this->p(935))
   {
    if (((mb_substr($this->v(935),1)+0)==0) && (mb_substr($this->v(935),1)!='0')) $res.=' ';
    else 
    {
     if ($jloaded)
     {
      if ($jr->GetSubField(210,1,'8')!='') $res.=' '.$jr->GetSubField(210,1,'8').' '; else $res.=' т. ';
     }
    }
    $res.=$this->v(935);
   }
   if ($this->p(936))
   {
    if (((mb_substr($this->v(936),1)+0)==0) && (mb_substr($this->v(936),1)!='0')) $res.=' ';
    else
    {
     if ($jloaded)
     {
      if ($jr->GetSubField(210,1,'9')!='') $res.=' '.$jr->GetSubField(210,1,'9').' '; else $res.=' № ';
     }
    }
    $res.=$this->v(936);
   }
   $res.=$this->v(931,0,'C','|',' (','|',')');
  }
  return $res;
 }
 /*
==>  fi,v936 fi,| (|v931^c|)|,
  (if p(v930)then if v930^a<>''then ', ',&uf('G0/'&unifor(|G2/|v930^a)),' г.' if v930^t<>''then  ref(l("I="v933),if p(v210^8) then' 'v210^8' 'else' т. 'fi) &unifor('G0/'&unifor('G2/'&unifor(|G2/|v930^a)))fi,ref(l("I="v933),if p(v210^9) then' 'v210^9' 'else' № 'fi,),if v930^t<>''then &unifor('G2/'&unifor('G2/'&unifor(|G2/|v930^a)))else &unifor('G2/'&unifor(|G2/|v930^a))fi fi fi)
  "  (Введено оглавление)"d922
  fi,
  if v920:'NJ'then else" (Введено оглавление)"d330,
  if v920.1:'A' then
  ".- "v963^1,if a(v963^1)then" // "d463 fi,
  (| ; |+v463^7,if a(v463^7) then| ; |+v463^c fi,| : |v963^e,| / |v963^f,|. - |v463^d,| : |v463^g,
  if p(v463^c)then
  if s(v463^d,v463^g)<>''then|, |v463^j else |. - |v463^j fi,|. - |v463^v else
  ". - "|. ; |+v463^v fi,
  if p(v463^v)then| : |v463^a else|. |v463^a fi,
  if p(v463^v)then| |v463^h else". - "|.; |+v463^h fi,
  if p(v463^h)then| : |v463^i else|. |v463^i fi,|, |v463^k,
  if p(v463^k)then| : |v463^l else|. |v463^l fi,|. - |v963^p,|.- Ст.|v463^N,|.- |v463^1,
  if a(v463^1) and p(v463^s)then'. - ',mpu,&unifor('Korg.mnu|4'),'. ',mpl,fi, v463^s)
  fi fi,
  FI,&unifor('!'),&unifor('+F'),&uf('['), */
}
?>