<?php 


require_once(dirname(__FILE__).'/ButtonManagers.inc');

class rlbManageRecs extends ButtonManagerPreselected
{

 function Start(&$res)
 {
  $res['container']=$this->GetContainer();
  if ($this->GetContainer()=='xml')
   $res['res'].='<?xml version="1.0" encoding="UTF-8"?>'."\r\n".'<RECORDS>'."\r\n";
  return TRUE;
 }

 function DoWork($db,$r,&$res)
 {
  $CR="\r\n";
  if ($this->GetFstName()!='') $r->ApplyFst(APATH_DB, $db->GetId(), $this->GetFstName());
  $r0='';
  $cp=$this->GetCodepage();
  switch($this->GetContainer())
  {
   case 'text': $r0=$r->GetAsIrbText(); if ($cp!='utf-8') $r0=iconv('utf-8',$cp,$r0); break;
   case 'iso': $r0=$r->GetAsMarc($cp); break;
   case 'xml': $r0=$r->GetAsXml(); if ($cp!='utf-8') $r0=iconv('utf-8',$cp,$r0); break;
   case 'json': $r0=','.$r->GetAsJson(); if ($cp!='utf-8') $r0=iconv('utf-8',$cp,$r0); break;
  }
  $res['res'].=$r0;
 }

 function End(&$res)
 {
  if ($this->GetContainer()=='xml')
   $res['res'].='</RECORDS>';
  if ($this->GetContainer()=='json')
   $res['res']='['.substr($res['res'],1).']';
  $this->ActionSetLoadFile('../vidget/rlbExportRecs.php');
  return TRUE;
 }

 function GetResult($res)
 {
  $ext='';
  $ct='';
  switch($res['container'])
  {
   case 'text': $ct='text/plain'; $ext='txt'; break;
   case 'iso': $ct='text/iso'; $ext='iso'; break;
   case 'xml': $ct='application/xml'; $ext='xml'; break;
   case 'json': $ct='application/json'; $ext='json'; break;
  }

  header ("Cache-Control: private");
  header ("Cache-Control: must-revalidate, post-check=0, pre-check=0");
  header ("Content-Type: $ct");
  header ("Content-Length: " . strlen($res['res']));
  header ("Content-Disposition: attachment; filename=export.$ext");
  echo $res['res'];
 }

}

$m=new rlbManageRecs;
$m->Run();



?>