﻿<?php 

require_once(dirname(__FILE__).'/ButtonManagers.inc');

class rlbManageRecs extends ButtonManagerPreselected
{

 var $importcount;

 function Start()
 {
  $db=$this->GetDb();
  $cont=$this->GetContainer();
  $cp=$this->GetCodepage();
  $fname=$this->GetFileName();
  $fstname=$this->GetFstName();

  $this->SetTotCount(filesize($fname));
  if ($this->GetTotCount()<1)
  {
   echo 'File size is 0';
   return FALSE;
  }
  $this->SetCurCount(0);

  $f=fopen($fname,'r');
  if ($f===FALSE)
  {
   echo 'Unable to open file '.$fname;
   return FALSE;
  }

  //set_time_limit(36000);

  if ($cont=='iso')
  {
   $r=new Record(0);
   while (!feof($f))
   {
    $sz=fread($f,5);
    $rsz=$sz+0;
    if ($rsz>0)
    {
     $rec=$sz.fread($f,$rsz-5);

     $r->Clear();
     $r->SetFromMarc($rec,$cp);
     if ($fstname!='') $r->ApplyFst(APATH_DB,$db->GetId(),$fstname);
     $db->SaveAndUpdateRecord($r);

     $this->importcount++;
     $this->SetCurCount(ftell($f));
     $this->UpdateTask();
    }
   }
   $r->Dispose($r->GetId());
  }
  else if ($cont=='text')
  {
   $r=new Record(0);
   while (!feof($f))
   {
    $s=fgets($f);
    $rec='';
    while ((trim($s)!='*****') && (!feof($f)) )
    {
     $rec.=$s;
     $s=fgets($f);
    }
    if (trim($rec)!='')
    {
     $r->Clear();
     $r->ParseIrbisTxtExpRec($rec,$cp);
     if ($fstname!='') $r->ApplyFst(APATH_DB,$db->GetId(),$fstname);
     $db->SaveAndUpdateRecord($r);

     $this->importcount++;
     $this->SetCurCount($this->GetCurCount()+5+$sz);
     $this->UpdateTask();
    }
   }
   $r->Dispose($r->GetId());
  }
  else if ($cont=='xml')
  {
   $records = new SimpleXMLElement(file_get_contents($fname));
   if (count($records)>0)
    $this->SetTotCount(count($records));
   $r=new Record(0);
   $rc=0;
   foreach($records as $rec)
   {
    $r->Clear();
    foreach($rec as $fldtag=>$flddata)
    {
     if (strpos($fldtag,'FIELD.')!==false)
     {
      $tag=substr($fldtag,6);
      $fldarr=array();
      if (trim($flddata,"\r\n")!='')
      {
       $fldarr['*']=trim($flddata,"\r\n");
      }
      else
      {
       foreach($flddata as $sftag=>$sfdata)
       {
        if (strpos($sftag,'SUBFIELD.')!==false)
        {
         $sf=substr($sftag,9);
         $fldarr[$sf]=trim($sfdata,"\r\n");
        }
       }
      }
      if (count($fldarr)>0)
      {
       $r->FieldAddA($tag,$fldarr);
      }
     }
    }
    if ($fstname!='') $r->ApplyFst(APATH_DB,$db->GetId(),$fstname);
    $db->SaveAndUpdateRecord($r);

    $this->importcount++;
    $this->SetCurCount($this->importcount);
    $this->UpdateTask();
   }
   $r->Dispose($r->GetId());
  }
  else if ($cont=='json')
  {
   $records=json_decode(file_get_contents($fname),true);
   if (is_array($records)) 
   {
    $r=new Record(0);
    $rc=count($records);
    $this->SetTotCount($rc);
    foreach ($records as $record)
    {
     $r->Clear();
     $r->SetContentA($record);
     if ($fstname!='') $r->ApplyFst(APATH_DB,$db->GetId(),$fstname);
     $db->SaveAndUpdateRecord($r);

     $this->importcount++;
     $this->SetCurCount($this->importcount);
     $this->UpdateTask();
    }
    $r->Dispose($r->GetId());
   }
  }

  fclose($f);

  $this->ActionSetReload();

  return FALSE;
 }

 function GetProgressMessage()
 {
  return $this->importcount.' записей импортировано';
 }

 function DoWork($db,$r,&$res)
 {
 }
}

$m=new rlbManageRecs;
$m->Run();

?>